// WSTray.cpp : Defines the entry point for the application.
//

#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <string>
#include <sstream>
#include <process.h>
//#include "shared_mem.h"
#include "shlobj.h"

#include "resource.h"

#define WM_USER_SHELLICON WM_USER + 996

#ifndef ES_AWAYMODE_REQUIRED
#define ES_AWAYMODE_REQUIRED	((DWORD)0x00000040)
#endif

static HINSTANCE appInstance = 0;
static HWND hiddenWindow = 0;
static HWND statusDlg = 0;

int service = -1;

static HANDLE sm_handle = 0;
//static SHARED_DATA *sharedData = 0;
static int lastCount = 0;
static int port = -1;
static FILE* pStatFile = NULL;
std::string filePath = "nowRunning.txt";
std::string leftClick = "DVSTray Left-Click";	// Let Windows decide the extension.
std::string rightClick = "DVSTray Right-Click";	// Let Windows decide the extension.
std::string cmdStart = "Start Server";
std::string logPath = "log";
std::string listFileToCopy = "toCopy.txt";
std::string copyToPath = "";
char tCount[100];
bool bSoon = false;
int nCount = 0;
LARGE_INTEGER wakeTime;
int nErrorCount(0);
char indicateAlive = 0;
char indicateAlivePrev = -1;
DWORD tickCountPrev = 0;
DWORD pid = 0;
int nCountTask = 0;
int leftClickAction(2), rightClickAction(1);
bool bLoadOnStartup(true);

HANDLE m_hTimer = INVALID_HANDLE_VALUE;

char text[1000];

inline char* loadString(UINT uId)
{
	return LoadString(appInstance, uId, text, 500) ? text : NULL;
}

void openStatFile()
{
	pStatFile = _fsopen(filePath.c_str(), "rb", _SH_DENYNO);
}

void getActiveCount()
{
	if (pStatFile == NULL)
		openStatFile();

	if (pStatFile != NULL)
	{
		rewind(pStatFile);
		if ( fgets(tCount, 51, pStatFile) )
		{
			if (strlen(tCount) >= 50)
			{
				indicateAlive = tCount[33];
				if ( (indicateAlive != indicateAlivePrev) || ((GetTickCount() - tickCountPrev) <= (120 * 1000)) )
				{
					bSoon = tCount[0] == '1' ? true : false;
					tCount[50] = 0x00;
					nCountTask = strtol(tCount+42, 0, 16);
					tCount[42] = 0x00;
					pid = strtol(tCount+34, 0, 16);
					tCount[33] = 0x00;
					nErrorCount = strtol(tCount+25, 0, 16);
					tCount[25] = 0x00;
					nCount = strtol(tCount+17, 0, 16);
					tCount[17] = 0x00;
					wakeTime.QuadPart = _strtoi64(tCount+1, 0, 16) * 10000 + 0x19db1ded53e8000L;

					if ( indicateAlive != indicateAlivePrev )
					{
						indicateAlivePrev = indicateAlive;
						tickCountPrev = GetTickCount();
					}

					return;
				}
			}
		}
	}

	bSoon = false;
	nCount = -1;
	wakeTime.QuadPart = 0;
	nErrorCount = -1;
	pid = 0;
	nCountTask = -1;
}

void copyFileRequest()
{
	FILE* pListFileToCopy = _fsopen(listFileToCopy.c_str(), "rb", _SH_DENYNO);
	if (pListFileToCopy == NULL)
	{
		return;
	}

	char fileToCopy[2000];
	if ( fgets( fileToCopy, 1000, pListFileToCopy ) == NULL)
	{
		if ( pListFileToCopy != NULL )
			fclose( pListFileToCopy );
		return;
	}

	if ( pListFileToCopy != NULL )
		fclose( pListFileToCopy );

	DWORD dwAttrs = GetFileAttributes(fileToCopy);
	if (dwAttrs==INVALID_FILE_ATTRIBUTES)
	{
		DeleteFile(listFileToCopy.c_str());
		return;
	}

	if (dwAttrs & FILE_ATTRIBUTE_DIRECTORY) 
	{
		std::string fileToCopy2 = fileToCopy;
		fileToCopy2 += "\\";
		WIN32_FIND_DATA FileData;
		HANDLE hSearch;
		BOOL fFinished = FALSE;

		hSearch = FindFirstFile((fileToCopy2 + "\\*.xml").c_str(), &FileData);
		if (hSearch == INVALID_HANDLE_VALUE)
		{
			DeleteFile(listFileToCopy.c_str());
			return;
		}

		while (!fFinished)
		{ 
			if ( !CopyFile((fileToCopy2 + FileData.cFileName).c_str(), (copyToPath + FileData.cFileName).c_str(), FALSE) )
			{
				FindClose(hSearch);
				DeleteFile(listFileToCopy.c_str());
				return;
			}

			if (!FindNextFile(hSearch, &FileData))
			{
				if (GetLastError() == ERROR_NO_MORE_FILES)
					fFinished = TRUE;
				else
				{
					FindClose(hSearch);
					DeleteFile(listFileToCopy.c_str());
					return;
				}
			}
		}

		FindClose(hSearch);
	}
	else
	{
		std::string str = fileToCopy;
		std::string str2 = str.substr( str.find_last_of("\\") + 1 );
		CopyFile(fileToCopy, (copyToPath + str2).c_str(), FALSE);
	}

	if ( !DeleteFile(listFileToCopy.c_str()) )
	return;
}

void updateTrayIcon()
{
	NOTIFYICONDATA nData;
	nData.cbSize = sizeof(NOTIFYICONDATA);
	nData.hWnd = hiddenWindow;
	nData.uID = 0;
	nData.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
	nData.uCallbackMessage = WM_USER_SHELLICON;

	int iconID = 0;

	getActiveCount();
	if (nErrorCount > 0)
	{
		if (nErrorCount == 1)
			strcpy(nData.szTip,"1 recording error has occurred");
		else
		{
			char buffer[200];
			sprintf_s(buffer, 200, "%d recording errors have occurred", nErrorCount);
			strcpy(nData.szTip,buffer);
		}
		iconID = IDI_STATUS_NOTRUNNING;
	}
	else if (nCount > 0)
	{
		char buffer[200];
		if (nCount == 1)
			strcpy(nData.szTip,"1 capture running");
		else
		{
			sprintf_s(buffer, 200, "%d captures running", nCount);
			strcpy(nData.szTip,buffer);
		}
		iconID = IDI_STATUS_CAPTURING;
	}
	else if (nCountTask > 0)
	{
		char buffer[200];
		if (nCountTask == 1)
			strcpy(nData.szTip,"1 task running");
		else
		{
			sprintf_s(buffer, 200, "%d tasks running", nCountTask);
			strcpy(nData.szTip,buffer);
		}
		iconID = IDI_STATUS_RUNNING;
	}
	else if (bSoon)
	{
		strcpy(nData.szTip,"A capture will start soon");
		iconID = IDI_STATUS_RUNNING;
	}
	else if (nCount == 0)
	{
		strcpy(nData.szTip,"No capture running");
		iconID = IDI_STATUS_RUNNING;
	}
	else
	{
		strcpy(nData.szTip,"DV Scheduler not running");
		iconID = IDI_STATUS_NOTRUNNING;
	}

	HINSTANCE hModule  = GetModuleHandle(NULL);
	HICON icon = LoadIcon(hModule, (LPCTSTR)iconID);
	nData.hIcon = icon;

	Shell_NotifyIcon(NIM_MODIFY, &nData);

	DeleteObject(icon);
}

unsigned int __stdcall messageWatcher(void *lpParameter)
{
	static int loop = 0;
	bool bSoonPrev = false;
	int nErrorCountPrev = 0;
	int nCountTaskPrev = 0;

    while (true)
    {
		getActiveCount();

		if ( (nCount != lastCount) || (bSoon != bSoonPrev) || (nErrorCount != nErrorCountPrev) || (nCountTask != nCountTaskPrev) || (++loop > 30) )
		{
			if ( (nCount != lastCount) || (bSoon != bSoonPrev) || (nCountTask != nCountTaskPrev) )
			{
				if ( (nCount > 0) || bSoon || (nCountTask > 0) )
					SetThreadExecutionState(ES_CONTINUOUS | ES_SYSTEM_REQUIRED | ES_AWAYMODE_REQUIRED);
				else
					SetThreadExecutionState(ES_CONTINUOUS);
			}

			updateTrayIcon();
			lastCount = nCount;
			bSoonPrev = bSoon;
			nErrorCountPrev = nErrorCount;
			nCountTaskPrev = nCountTask;

			loop = 0;
		}

		copyFileRequest();

		Sleep(1000);
	}
	return 0;
}

BOOL setRegistryInt(LPCTSTR name, const DWORD& value)
{
	HKEY hk; 
	DWORD dwDisp; 

	if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\DV Scheduler", 
		0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_WRITE, NULL, &hk, &dwDisp)) 
	{
		MessageBox(NULL, loadString(IDS_ERROR_SAVE_REGISTRY), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (RegSetValueEx(hk,              // subkey handle 
		name,        // value name 
		0,                         // must be zero 
		REG_DWORD,             // value type 
		(LPBYTE) &value,        // pointer to value data 
		sizeof(DWORD))) // length of value data 
	{
		MessageBox(NULL, loadString(IDS_ERROR_REGISTRY_SAVEVALUE), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		RegCloseKey(hk); 
		return FALSE;
	}

	return TRUE;
}

void waitForTrayWnd()
{
	HWND hWndTaskBar = 0;
	int count = 0;
	
	while(count < 60)
	{
		hWndTaskBar = FindWindow("Shell_TrayWnd", "");

		if(hWndTaskBar != 0)
			break;

		count++;
		Sleep(500);
	}
}

void addTrayIcon()
{
	NOTIFYICONDATA nData;
	nData.cbSize = sizeof(NOTIFYICONDATA);
	nData.hWnd = hiddenWindow;
	nData.uID = 0;

	Shell_NotifyIcon(NIM_DELETE, &nData);

	nData.cbSize = sizeof(NOTIFYICONDATA);
	nData.hWnd = hiddenWindow;
	nData.uCallbackMessage = WM_USER_SHELLICON;
	nData.uID = 0;
	nData.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
	strcpy(nData.szTip,"No capture running");
	HICON icon = LoadIcon(appInstance, (LPCTSTR)IDI_STATUS_RUNNING);
	nData.hIcon = icon;
	Shell_NotifyIcon(NIM_ADD, &nData);
	DeleteObject(icon);
}

void showMenu(HWND hWnd)
{
	HMENU hMenu = LoadMenu(appInstance, MAKEINTRESOURCE(IDR_MENU));
	HMENU hContext = GetSubMenu(hMenu, 0);

	MENUITEMINFO menuInfo;
	menuInfo.cbSize = sizeof(MENUITEMINFO);

	menuInfo.fMask = MIIM_STATE;
	menuInfo.fState = bLoadOnStartup ? MFS_CHECKED : MFS_UNCHECKED;
	SetMenuItemInfo(hContext, IDR_LOADONWINDOWSSTARTUP, false, &menuInfo);

	menuInfo.fMask = MIIM_FTYPE | MIIM_STATE;
	menuInfo.fType = MFT_RADIOCHECK;
	switch (leftClickAction)
	{
	case 0:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWSTATUS, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWMENU, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_USER, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHMAINPAGE, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHEPGPAGE, false, &menuInfo);
		break;
	case 1:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWMENU, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWSTATUS, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_USER, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHMAINPAGE, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHEPGPAGE, false, &menuInfo);
		break;
	case 2:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_USER, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWSTATUS, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWMENU, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHMAINPAGE, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHEPGPAGE, false, &menuInfo);
		break;
	case 3:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHMAINPAGE, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWSTATUS, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWMENU, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_USER, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHEPGPAGE, false, &menuInfo);
		break;
	case 4:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHEPGPAGE, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWSTATUS, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_SHOWMENU, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_USER, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_LEFT_LAUNCHMAINPAGE, false, &menuInfo);
		break;
	}

	switch (rightClickAction)
	{
	case 0:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_RIGHT_SHOWSTATUS, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_RIGHT_SHOWMENU, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_RIGHT_USER, false, &menuInfo);
		break;
	case 1:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_RIGHT_SHOWMENU, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_RIGHT_SHOWSTATUS, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_RIGHT_USER, false, &menuInfo);
		break;
	case 2:
		menuInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(hContext, IDR_RIGHT_USER, false, &menuInfo);
		menuInfo.fState = MFS_UNCHECKED;
		SetMenuItemInfo(hContext, IDR_RIGHT_SHOWSTATUS, false, &menuInfo);
		SetMenuItemInfo(hContext, IDR_RIGHT_SHOWMENU, false, &menuInfo);
		break;
	}

	POINT point;
	GetCursorPos(&point);

	SetForegroundWindow(hWnd);
	TrackPopupMenuEx(hContext, TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
		point.x, point.y, hWnd, NULL);

	DestroyMenu(hMenu);
}

BOOL startService()
{
	SC_HANDLE schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (schSCManager == NULL)
	{
		MessageBox(NULL, loadString(IDS_ERROR_OPENSCM), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	SC_HANDLE schService = OpenService(schSCManager, "DVScheduler", SERVICE_START | SERVICE_QUERY_STATUS);
	if (schService == NULL)
	{
		MessageBox(NULL, loadString(IDS_ERROR_OPENSERVICE), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		CloseServiceHandle(schSCManager);
		return FALSE;
	}

	if (!StartService(
		schService,  // handle to service 
		0,           // number of arguments 
		NULL) )      // no arguments 
	{
		if (GetLastError() == ERROR_SERVICE_ALREADY_RUNNING)
		{
			MessageBox(NULL, loadString(IDS_DVS_ALREADYRUNNING), "DVSTray", MB_OK | MB_ICONINFORMATION);
		}
		else
		{
			MessageBox(NULL, loadString(IDS_ERROR_START_DVS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		}
		CloseServiceHandle(schService);
		CloseServiceHandle(schSCManager);
		return 0; 
	}

    SERVICE_STATUS_PROCESS ssStatus; 
    DWORD dwOldCheckPoint; 
    DWORD dwStartTickCount;
    DWORD dwWaitTime;
    DWORD dwBytesNeeded;

	// Check the status until the service is no longer start pending. 

	if (!QueryServiceStatusEx( 
		schService,             // handle to service 
		SC_STATUS_PROCESS_INFO, // info level
		(LPBYTE)&ssStatus,              // address of structure
		sizeof(SERVICE_STATUS_PROCESS), // size of structure
		&dwBytesNeeded ) )              // if buffer too small
	{
		MessageBox(NULL, loadString(IDS_ERROR_QUERYSERVICE), "DVSTray", MB_OK | MB_ICONINFORMATION);
		CloseServiceHandle(schService);
		CloseServiceHandle(schSCManager);
		return 0; 
	}

	// Save the tick count and initial checkpoint.

	dwStartTickCount = GetTickCount();
	dwOldCheckPoint = ssStatus.dwCheckPoint;

	while (ssStatus.dwCurrentState == SERVICE_START_PENDING) 
	{ 
		// Do not wait longer than the wait hint. A good interval is 
		// one tenth the wait hint, but no less than 1 second and no 
		// more than 10 seconds. 

		dwWaitTime = ssStatus.dwWaitHint / 10;

		if( dwWaitTime < 1000 )
			dwWaitTime = 1000;
		else if ( dwWaitTime > 10000 )
			dwWaitTime = 10000;

		Sleep( dwWaitTime );

		// Check the status again. 

		if (!QueryServiceStatusEx( 
			schService,             // handle to service 
			SC_STATUS_PROCESS_INFO, // info level
			(LPBYTE)&ssStatus,              // address of structure
			sizeof(SERVICE_STATUS_PROCESS), // size of structure
			&dwBytesNeeded ) )              // if buffer too small
			break; 

		if ( ssStatus.dwCheckPoint > dwOldCheckPoint )
		{
			// The service is making progress.

			dwStartTickCount = GetTickCount();
			dwOldCheckPoint = ssStatus.dwCheckPoint;
		}
		else
		{
			if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
			{
				// No progress made within the wait hint
				break;
			}
		}
	} 

	CloseServiceHandle(schService);
	CloseServiceHandle(schSCManager);

	if (ssStatus.dwCurrentState == SERVICE_RUNNING) 
	{
		MessageBox(NULL, loadString(IDS_DVS_STARTED), "DVSTray", MB_OK | MB_ICONINFORMATION);
		return 1;
	}
	else 
	{ 
		MessageBox(NULL, loadString(IDS_ERROR_START_DVS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		return 0;
	} 
}

BOOL stopService()
{
	SC_HANDLE schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (schSCManager == NULL)
	{
		MessageBox(NULL, loadString(IDS_ERROR_OPENSCM), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	SC_HANDLE schService = OpenService(schSCManager, "DVScheduler", SERVICE_STOP);
	if (schService == NULL)
	{
		MessageBox(NULL, loadString(IDS_ERROR_OPENSERVICE), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		CloseServiceHandle(schSCManager);
		return FALSE;
	}

	SERVICE_STATUS ssStatus; 

	// Send a control value to the service. 

	if (! ControlService( 
		schService,   // handle to service 
		SERVICE_CONTROL_STOP,   // control value to send 
		&ssStatus) )  // address of status info 
	{
		if (GetLastError() == ERROR_SERVICE_NOT_ACTIVE)
		{
			MessageBox(NULL, loadString(IDS_DVS_NOTRUNNING), "DVSTray", MB_OK | MB_ICONINFORMATION);
		}
		else
		{
			MessageBox(NULL, loadString(IDS_ERROR_STOP_DVS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		}
	}
	else
	{
		MessageBox(NULL, loadString(IDS_DVS_STOPPED), "DVSTray", MB_OK | MB_ICONINFORMATION);
	}
	return TRUE;
}

void launchBrowser(LPCTSTR url)
{
	char buffer[1000];
	sprintf_s(buffer, 500, "http://localhost:%d%s", port, url);

	ShellExecute(NULL, "open", buffer, NULL, NULL, SW_SHOWNORMAL);
}

BOOL processMenuAction(WPARAM wParam)
{
	switch (LOWORD(wParam))
	{
	case IDR_EXIT:
		if ( MessageBox(NULL, loadString(IDS_CONFIRM_EXIT), "DVSTray", MB_OKCANCEL | MB_ICONQUESTION) == IDOK )
			PostMessage(hiddenWindow, WM_CLOSE, 0, 0);
		return TRUE;
	case IDR_LOADONWINDOWSSTARTUP:
		bLoadOnStartup = !bLoadOnStartup;
		setRegistryInt("LoadOnStartup", bLoadOnStartup);
		return TRUE;
	case IDR_STARTDVSCHEDULER:
		if ( service == 0 )
		{
			HANDLE hProcess = NULL;
			DWORD exitCode;
			if ( (nCount >= 0) && (hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, pid)) && 
				GetExitCodeProcess(hProcess, &exitCode) && (exitCode == STILL_ACTIVE) )
			{
				MessageBox(NULL, loadString(IDS_DVS_ALREADYRUNNING), "DVSTray", MB_OK | MB_ICONINFORMATION);
				CloseHandle(hProcess);
				return TRUE;
			}
			if (hProcess)
			{
				CloseHandle(hProcess);
				hProcess = NULL;
			}

			if ( (int)ShellExecute(NULL, NULL, cmdStart.c_str(), NULL, NULL, SW_SHOWNORMAL) <= 32 )
				MessageBox(NULL, loadString(IDS_ERROR_START_DVS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
			else
			{
				for (int i=0; i<15; i++)
				{
					Sleep(1000);
					if ( (nCount >= 0) && (hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, pid)) && 
						GetExitCodeProcess(hProcess, &exitCode) && (exitCode == STILL_ACTIVE) )
					{
						MessageBox(NULL, loadString(IDS_DVS_STARTED), "DVSTray", MB_OK | MB_ICONINFORMATION);
						CloseHandle(hProcess);
						return TRUE;
					}
					if (hProcess)
					{
						CloseHandle(hProcess);
						hProcess = NULL;
					}
				}
				MessageBox(NULL, loadString(IDS_ERROR_START_DVS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
			}
		}
		else if ( service == 1 )
		{
			if (!IsUserAnAdmin())
			{
				LPWSTR *szArglist;
				int nArgs;
				szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);
				if ( NULL == szArglist )
				{
					MessageBox(NULL, loadString(IDS_ERROR_GETCOMMANDLINE), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
					return FALSE;
				}

				char cPath[3000];
				WideCharToMultiByte(CP_UTF8, 0, szArglist[0], -1, cPath, 3000, NULL, NULL);
				char cArg[3000];
				if (nArgs > 1)
				{
					WideCharToMultiByte(CP_UTF8, 0, szArglist[1], -1, cArg, 3000, NULL, NULL);
				}
				LocalFree(szArglist);
				int valArg = atoi(cArg);
				if (valArg < 0)
					valArg *= -1;
				valArg += 300000;
				_itoa_s(valArg, cArg, 3000, 10);

				if ( (int)ShellExecute(NULL, "runas", cPath, cArg, NULL, SW_SHOWNORMAL) <= 32 )
				{
					MessageBox(NULL, loadString(IDS_ERROR_RUNAS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
					return FALSE;
				}
				PostMessage(hiddenWindow, WM_CLOSE, 0, 0);
				return FALSE;
			}

			startService();
		}
		else
		{
			MessageBox(NULL, loadString(IDS_ERROR_READ_REGISTRY), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		}
		return TRUE;
	case IDR_STOPDVSCHEDULER:
		if ( MessageBox(NULL, loadString(IDS_CONFIRM_STOP_DVS), "DVSTray", MB_OKCANCEL | MB_ICONQUESTION) != IDOK )
			return TRUE;

		if ( service == 0 )
		{
			DWORD exitCode;
			HANDLE hProcess = NULL;
			if ( (nCount < 0) || ((hProcess = OpenProcess(PROCESS_TERMINATE | PROCESS_QUERY_INFORMATION, FALSE, pid)) && 
				GetExitCodeProcess(hProcess, &exitCode) && (exitCode != STILL_ACTIVE)) )
			{
				MessageBox(NULL, loadString(IDS_DVS_NOTRUNNING), "DVSTray", MB_OK | MB_ICONINFORMATION);
			}
			else if (hProcess && TerminateProcess(hProcess, 0) )
			{
				MessageBox(NULL, loadString(IDS_DVS_STOPPED), "DVSTray", MB_OK | MB_ICONINFORMATION);
			}
			else
			{
				MessageBox(NULL, loadString(IDS_ERROR_STOP_DVS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
			}
			if (hProcess)
				CloseHandle(hProcess);
		}
		else if ( service == 1 )
		{
			if (!IsUserAnAdmin())
			{
				LPWSTR *szArglist;
				int nArgs;
				szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);
				if ( NULL == szArglist )
				{
					MessageBox(NULL, loadString(IDS_ERROR_GETCOMMANDLINE), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
					return FALSE;
				}

				char cPath[3000];
				WideCharToMultiByte(CP_UTF8, 0, szArglist[0], -1, cPath, 3000, NULL, NULL);
				char cArg[3000];
				if (nArgs > 1)
				{
					WideCharToMultiByte(CP_UTF8, 0, szArglist[1], -1, cArg, 3000, NULL, NULL);
				}
				LocalFree(szArglist);
				int valArg = atoi(cArg);
				if (valArg < 0)
					valArg *= -1;
				valArg += 600000;
				_itoa_s(valArg, cArg, 3000, 10);

				if ( (int)ShellExecute(NULL, "runas", cPath, cArg, NULL, SW_SHOWNORMAL) <= 32 )
				{
					MessageBox(NULL, loadString(IDS_ERROR_RUNAS), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
					return FALSE;
				}
				PostMessage(hiddenWindow, WM_CLOSE, 0, 0);
				return FALSE;
			}

			stopService();
		}
		else
		{
			MessageBox(NULL, loadString(IDS_ERROR_READ_REGISTRY), "DVSTray", MB_OK | MB_ICONEXCLAMATION);
		}
		return TRUE;
	case IDR_SHOWSTATUS:
		PostMessage(hiddenWindow, WM_USER+69, 0, 0);
		return TRUE;
	case IDR_MAIN:
		launchBrowser("");
		return TRUE;
	case IDR_EPG:
		launchBrowser("/servlet/EpgDataRes?action=12&scrollto=-1");
		return TRUE;
	case IDR_OPENLOG:
		ShellExecute(NULL, "open", logPath.c_str(), NULL, NULL, SW_SHOWNORMAL);
		return TRUE;
	case IDR_LEFT_SHOWSTATUS:
		leftClickAction = 0;
		setRegistryInt("LeftClick", leftClickAction);
		return TRUE;
	case IDR_LEFT_SHOWMENU:
		leftClickAction = 1;
		setRegistryInt("LeftClick", leftClickAction);
		return TRUE;
	case IDR_LEFT_USER:
		leftClickAction = 2;
		setRegistryInt("LeftClick", leftClickAction);
		return TRUE;
	case IDR_LEFT_LAUNCHMAINPAGE:
		leftClickAction = 3;
		setRegistryInt("LeftClick", leftClickAction);
		return TRUE;
	case IDR_LEFT_LAUNCHEPGPAGE:
		leftClickAction = 4;
		setRegistryInt("LeftClick", leftClickAction);
		return TRUE;
	case IDR_RIGHT_SHOWSTATUS:
		rightClickAction = 0;
		setRegistryInt("RightClick", rightClickAction);
		return TRUE;
	case IDR_RIGHT_SHOWMENU:
		rightClickAction = 1;
		setRegistryInt("RightClick", rightClickAction);
		return TRUE;
	case IDR_RIGHT_USER:
		rightClickAction = 2;
		setRegistryInt("RightClick", rightClickAction);
		return TRUE;
	}

	return FALSE;
}

LRESULT CALLBACK statusProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
		{
			return TRUE;
		}

		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDOK: case IDCANCEL:
				DestroyWindow(hDlg);
				statusDlg = 0;
				return TRUE;
			case IDC_BUTTON_MENU:
				showMenu(hDlg);
				return TRUE;
			default:
				return processMenuAction(wParam);
			}
		}

		case WM_CONTEXTMENU:
		{
			showMenu(hDlg);
			return TRUE;

			break;
		}
	}
    return FALSE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static UINT s_uTaskbarRestart;

	switch (message) 
	{
        case WM_CREATE:
            s_uTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));
            break;

		case WM_USER+69:
		{
			if(statusDlg > 0)
			{
				DestroyWindow(statusDlg);
			}

			HINSTANCE hInst = GetModuleHandle(NULL);
			statusDlg = CreateDialogParam(hInst, (LPCTSTR)IDD_STATUS, NULL, (DLGPROC)statusProc, 0);

			getActiveCount();
			char buff01[128];
			if (nErrorCount > 0)
			{
				if (nErrorCount == 1)
					strcpy(buff01,"1 Recording Error Has Occurred");
				else
				{
					char buffer[200];
					sprintf_s(buffer, 200, "%d Recording Errors Have Occurred", nErrorCount);
					strcpy(buff01,buffer);
				}
			}
			else if (nCount > 0)
			{
				strcpy(buff01, "DV Scheduler Capturing");
			}
			else if (nCountTask > 0)
			{
				strcpy(buff01, "DV Scheduler Running Task");
			}
			else if (bSoon)
			{
				strcpy(buff01, "DV Scheduler Soon Capturing");
			}
			else if (nCount == 0)
			{
				strcpy(buff01, "DV Scheduler Idle");
			}
			else
			{
				strcpy(buff01, "DV Scheduler Not Running");
			}
			SendDlgItemMessage(statusDlg, IDC_STATUS_TEXT, WM_SETTEXT, (WPARAM)127, (LPARAM)buff01);

			char buff02[128];
			sprintf(buff02, "Capture running: %d", nCount);
			if (nCount >= 0)
				SendDlgItemMessage(statusDlg, IDC_STATUS_CURRENT, WM_SETTEXT, 0, (LPARAM)buff02);
			else
				SendDlgItemMessage(statusDlg, IDC_STATUS_CURRENT, WM_SETTEXT, 0, (LPARAM)"");

			sprintf(buff02, "Task running: %d", nCountTask);
			if (nCountTask >= 0)
				SendDlgItemMessage(statusDlg, IDC_STATUS_TASK, WM_SETTEXT, 0, (LPARAM)buff02);
			else
				SendDlgItemMessage(statusDlg, IDC_STATUS_TASK, WM_SETTEXT, 0, (LPARAM)"");

			ShowWindow(statusDlg, 1);

			return 0;
		}

		case WM_USER_SHELLICON:
		{
			if(lParam == WM_RBUTTONUP)
			{
				switch (rightClickAction)
				{
				case 0:
					PostMessage(hiddenWindow, WM_USER+69, 0, 0);
					break;
				case 1:
					showMenu(hWnd);
					break;
				case 2:
					if ( (int)ShellExecute(NULL, NULL, rightClick.c_str(), NULL, NULL, SW_SHOWNORMAL) <= 32 )
					{
						if ( (int)ShellExecute(NULL, NULL, (rightClick + ".url").c_str(), NULL, NULL, SW_SHOWNORMAL) <= 32 )
							PostMessage(hiddenWindow, WM_USER+69, 0, 0);
					}
					break;
				}

				return 0;
			}
			else if(lParam == WM_LBUTTONUP)
			{
				switch (leftClickAction)
				{
				case 0:
					PostMessage(hiddenWindow, WM_USER+69, 0, 0);
					break;
				case 1:
					showMenu(hWnd);
					break;
				case 2:
					if ( (int)ShellExecute(NULL, NULL, leftClick.c_str(), NULL, NULL, SW_SHOWNORMAL) <= 32 )
					{
						if ( (int)ShellExecute(NULL, NULL, (leftClick + ".url").c_str(), NULL, NULL, SW_SHOWNORMAL) <= 32 )
							PostMessage(hiddenWindow, WM_USER+69, 0, 0);
					}
					break;
				case 3:
					launchBrowser("");
					break;
				case 4:
					launchBrowser("/servlet/EpgDataRes?action=12&scrollto=-1");
					break;
				}

				return 0;
			}

			break;
		}

		case WM_POWERBROADCAST:
		{
			if(wParam == PBT_APMQUERYSUSPEND)
			{
				getActiveCount();
				if ( (nCount > 0) || bSoon || (nCountTask > 0) )
				{
					PostMessage(hiddenWindow, WM_USER+69, 1, 0);
					return BROADCAST_QUERY_DENY;
				}

				return TRUE;
			}
			else if (wParam == PBT_APMSUSPEND)
			{
				if (wakeTime.QuadPart > 0)
					SetWaitableTimer(m_hTimer, &wakeTime, 0, NULL, NULL, TRUE);
				else
					CancelWaitableTimer(m_hTimer);

				return TRUE;
			}
			break;
		}

		case WM_COMMAND:
		{
			return processMenuAction(wParam);
		}

		default:
		{
			if(message == s_uTaskbarRestart)
				addTrayIcon();

			return DefWindowProc(hWnd, message, wParam, lParam);
		}
   }

   return 0;
}

HWND InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hWnd = CreateWindow("DVSTrayIcon", "DVS Tray Icon", 0,
      0, 0, 0, 0, NULL, NULL, hInstance, NULL);

   return hWnd;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "DVSTrayIcon";
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	bool bStartup = false;
	// Check command line.
	std::string cmdLine(lpCmdLine);
	if ( cmdLine == "-" )
	{
		bStartup = true;
	}
	else
	{
		std::istringstream i(cmdLine);
		if ( (i >> port) && (port < 0) )
		{
			port *= -1;
			bStartup = true;
		}
	}

	// Command to start/stop service.
	int nCmd = 0;
	if (port >= 300000)
	{
		nCmd = port / 300000;
		port -= nCmd * 300000;
	}

	// Check registry.
	HKEY hKey = NULL;
	RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\DV Scheduler", 0, KEY_READ, &hKey);

	if(hKey)
	{
		DWORD dwType, cbData(4), value(2);
		if ( (RegQueryValueEx(hKey, "LoadOnStartup", NULL, &dwType, (BYTE*)&value, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_DWORD) )
		{
			bLoadOnStartup = (value != 0);
			if (!bLoadOnStartup && bStartup)
			{
				RegCloseKey(hKey);
				return 0;
			}
		}
		cbData = 4;
		value = 2;
		if ( (RegQueryValueEx(hKey, "LeftClick", NULL, &dwType, (BYTE*)&value, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_DWORD) )
		{
			leftClickAction = value;
		}
		cbData = 4;
		value = 2;
		if ( (RegQueryValueEx(hKey, "RightClick", NULL, &dwType, (BYTE*)&value, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_DWORD) )
		{
			rightClickAction = value;
		}
	}

	RegCloseKey(hKey);

	RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\DV Scheduler", 0, KEY_READ, &hKey);

	if(hKey)
	{
		DWORD dwType, cbData(1000);
		char buffer[2000];
		bool bSaveToAppData(false);
		if ( (RegQueryValueEx(hKey, "Port", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			std::string portT(buffer);
			std::istringstream i(portT);
			if (port < 0)
				i >> port;
		}
		else if (port < 0)
			port = 8007;
		cbData=1000;
		if ( (RegQueryValueEx(hKey, "SaveToAppData", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			bSaveToAppData = (buffer[0] == '1');
		}
		cbData=1000;
		if ( (RegQueryValueEx(hKey, "Path", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			strcat_s(buffer, 1000, "\\");

			leftClick = buffer + leftClick;
			rightClick = buffer + rightClick;
			cmdStart = buffer + cmdStart;
			if (!bSaveToAppData)
			{
				filePath = buffer + filePath;
				logPath = buffer + logPath;
			}
		}
		cbData=1000;
		if ( (RegQueryValueEx(hKey, "Service", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			std::string serviceT(buffer);
			std::istringstream i(serviceT);
			i >> service;
		}
		cbData=1000;
		if ( (RegQueryValueEx(hKey, "DataPath", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			strcat_s(buffer, 1000, "\\");
			if (bSaveToAppData)
			{
				filePath = buffer + filePath;
				logPath = buffer + logPath;
			}
			strcat_s(buffer, 1000, "temp\\");
			copyToPath = buffer;
			listFileToCopy = buffer + listFileToCopy;
		}
	}

	RegCloseKey(hKey);

	openStatFile();

	m_hTimer = CreateWaitableTimer(NULL, TRUE, "DVSTray Timer");

	MSG msg;

	appInstance = hInstance;
	MyRegisterClass(hInstance);

	hiddenWindow = InitInstance (hInstance, 1);

	if (hiddenWindow == 0) 
	{
		return FALSE;
	}

	waitForTrayWnd();

	addTrayIcon();

	//sharedData = (SHARED_DATA*)smem_create_share(&sm_handle, "Global\\$WebSchedulerSHARED$", sizeof(SHARED_DATA), true);

	// start mail slot thread
	unsigned int threadId = 0;
	_beginthreadex(NULL, 0, &messageWatcher, 0, NULL, &threadId);

	switch (nCmd)
	{
	case 1:
		startService();
		break;
	case 2:
		stopService();
		break;
	}

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if(!IsDialogMessage(statusDlg, &msg))
		{
			if (msg.message == WM_CLOSE)
				break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	//smem_close_share(sm_handle, sharedData);

	CloseHandle(m_hTimer);

	NOTIFYICONDATA nData;
	nData.hWnd = hiddenWindow;
	nData.uID = 0;
	Shell_NotifyIcon(NIM_DELETE, &nData);

	return 0;
}
