var text, obj, balloon2;
var bObj = false;
var prevCell = null;

var posX, posY;

function moveToolTip()
{
    var body = document.getElementsByTagName('body');
    var leftPos = posX - balloon2.offsetWidth - 15;
    var topPos = posY - balloon2.offsetHeight - 15;
    if ( (leftPos<3) && (topPos<3) )
    {
        topPos = 3;
        leftPos = posX + 15;
    }
    else if (leftPos<3)
        leftPos = 3;
    else if (topPos<3)
        topPos = 3;
        
    leftPos += body[0].scrollLeft;
    topPos += body[0].scrollTop;

    obj.style.left = leftPos + 'px';
    obj.style.width = balloon2.style.width;
    obj.style.top = topPos + 'px';
}

function displayMarker(cell)
{
    var mainDiv = document.getElementById("mainDiv");
    if (mainDiv == null) return;
    var mainDiv0 = document.getElementById("mainDiv0");
    
    var topPos = cell.offsetTop - mainDiv.scrollTop + mainDiv0.offsetTop;
          
    var objLineTop = document.getElementById('balloon_lineTop');
    objLineTop.style.width = (mainDiv.clientWidth + 20) + 'px';
    objLineTop.style.top = topPos + 'px';
    
    if ( topPos <= mainDiv0.offsetTop )
      objLineTop.style.display = 'none';
    else
      objLineTop.style.display = 'block';
    
    var objLineBottom = document.getElementById('balloon_lineBottom');
    objLineBottom.style.width = objLineTop.style.width;
    objLineBottom.style.top = (topPos + cell.offsetHeight) + 'px';
    
    if ( topPos + cell.offsetHeight >= mainDiv0.offsetTop + mainDiv.offsetHeight )
      objLineBottom.style.display = 'none';
    else
      objLineBottom.style.display = 'block';
}

function showTipNow(cell)
{
    if (bObj == false)
    {
        if (prevCell == cell)
        {
          obj.style.display = 'block';
          var desc2 = cell.getAttribute('desc2');
          if ((desc2) && (desc2.length > 0))
          {
            displayMarker(cell);
          }
          moveToolTip(posX, posY);
        }
        else
        {
          obj = document.getElementById('balloon_tooltip');
          balloon2 = document.getElementById('balloon_tooltip2');
          var bDesc3 = false;
          var desc2 = cell.getAttribute('desc2');
          var desc3 = cell.getAttribute('desc3');
          if ((desc2) && (desc2.length > 0))
          {
            displayMarker(cell);
  
            if (desc3 && (desc3.length > 0))
            {
              bDesc3 = true;
              balloon2.innerHTML = desc2 + '<table id="tDesc3" align="center" cellpadding="2" style="FONT-SIZE: 90%; Border:1px solid white;"><tr><td>' + desc3 + '</td></tr></table>';
            }
            else
            {
              balloon2.innerHTML = desc2;
            }
          }
          else
          {
              balloon2.innerHTML = cell.innerHTML;
          }
          
          if (bDesc3)
          {
            var objDesc3 = document.getElementById('tDesc3');
            balloon2.style.width = objDesc3.width;
          }
          else
          {
            var width = balloon2.innerHTML.length;
            balloon2.style.width = width + 'px';
          }

          if (balloon2.clientWidth > 300)
            balloon2.style.width = 300;
          else if (balloon2.clientWidth < 150)
            balloon2.style.width = 150;
          
          bObj = true;
          prevCell = cell;
          moveToolTip(posX, posY);
          obj.innerHTML = balloon2.innerHTML;
          obj.style.display = 'block';
        }
    }
    else
    {
      moveToolTip(posX, posY);
    }
}

var curCell = null;
var iTimerID = null;

function showTip(e,cell,delay)
{
    posX = e.clientX;
    posY = e.clientY;
    curCell = cell;
    
    if (delay == 0)
      showTipNow(cell);
    else if (prevCell == cell)
    {
      showTipNow(cell);
    }
    else
    {
      prevCell = null;
      if (iTimerID)
        window.clearTimeout(iTimerID);

      iTimerID = window.setTimeout(showTipTimer, delay);
    }
}

function showTipTimer()
{
    iTimerID = null;
    showTipNow(curCell);
}

function hideTip()
{
    if (iTimerID)
    {
      window.clearTimeout(iTimerID);
      iTimerID = null;
    }
  	document.getElementById('balloon_tooltip').style.display = 'none';
    bObj = false;
}

function hideMarker()
{
  	document.getElementById('balloon_lineTop').style.display = 'none';
  	document.getElementById('balloon_lineBottom').style.display = 'none';
}

function hideInput()
{
  	document.getElementById('balloon_input').style.display = 'none';
  	inputID = '';
}

function hideAllTip()
{
    hideTip();
    hideMarker();
    hideInput();
}

var inputID = '';
var inputIndex;
var inputDuration, inputStopHour, inputStopMinute;

function savePosition(e)
{
	posX = e.clientX;
	posY = e.clientY;
}

function inputForm(id, duration, stopHour, stopMinute, index)
{
	if ( (inputID == id) && (inputIndex == index) )
	{
		hideInput();
	}
	else
	{
		inputID = id;
		inputIndex = index;
		inputDuration = duration;
		inputStopHour = stopHour;
		inputStopMinute = stopMinute;

    var leftPos = posX - 120;
    if (leftPos<0)
        leftPos = posX + 25;

    var body = document.getElementsByTagName('body');
    var objInputForm = document.getElementById('balloon_input');
    objInputForm.style.left = (body[0].scrollLeft + leftPos) + 'px';
    objInputForm.style.top = (body[0].scrollTop + posY - 10) + 'px';
    objInputForm.style.display = 'block';
    var objDuration = document.getElementById('stopHour');
    objDuration.value = stopHour;
    objDuration = document.getElementById('stopMinute');
    objDuration.value = (stopMinute <= 9) ? ('0' + stopMinute) : stopMinute;
    objDuration = document.getElementById('duration');
    objDuration.value = duration;
    objDuration.select();
    objDuration.focus();
	}
}

function inputOk()
{
    var objDuration = document.getElementById('duration');
    var duration = parseInt(objDuration.value, 10);
    
    // Check if a number.
    if (isNaN(duration))
    	return;

    if ( (duration < 1) || (duration == inputDuration) )
    	return;

	if ( inputIndex > -1 )
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&duration=' + duration + '&index=' + inputIndex + '&dari=' + encodeURIComponent(document.location.href);
	else
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&duration=' + duration + '&dari=' + encodeURIComponent(document.location.href);
}

function inputOkStopTime()
{
    var objStopTime = document.getElementById('stopHour');
    var stopHour = parseInt(objStopTime.value, 10);
    var objStopTime = document.getElementById('stopMinute');
    var stopMinute = parseInt(objStopTime.value, 10);
    
    // Check if a number.
    if ( isNaN(stopHour) || isNaN(stopMinute) )
    	return;

    if ( (stopHour < 0) || (stopMinute < 0) || ((stopHour == inputStopHour) && (stopMinute == inputStopMinute)) )
    	return;

	if ( inputIndex > -1 )
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&stopHour=' + stopHour + '&stopMinute=' + stopMinute + '&index=' + inputIndex + '&dari=' + encodeURIComponent(document.location.href);
	else
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&stopHour=' + stopHour + '&stopMinute=' + stopMinute + '&dari=' + encodeURIComponent(document.location.href);
}

function showTitle(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');
  
  var w = screen.availWidth;
  var h = screen.availHeight;

  var popW = 650;
  var popH = 550;

  var leftPos = (w - popW) / 2;
  var topPos = (h - popH) / 2;

  var newWindow = window.open('/servlet/EpgDataRes?action=06&id=' + id + '&channel=' + encodeURIComponent(channel) ,'popup','width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos +',scrollbars=yes,resizable=yes');
  newWindow.focus();
}

function schedTitle(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  document.location.href = '/servlet/ScheduleDataRes?action=12&id=' + id + '&channel=' + encodeURIComponent(channel) + '&dari=' + encodeURIComponent(document.location.href);
}

function schedTitleCap(obj, captureType)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  document.location.href = '/servlet/ScheduleDataRes?action=12&id=' + id + '&channel=' + encodeURIComponent(channel) + '&captype=' + captureType + '&dari=' + encodeURIComponent(document.location.href);
}

function newSchedule(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  document.location.href = '/servlet/ScheduleDataRes?action=18&id=' + id + '&channel=' + encodeURIComponent(channel) + '&dari=' + encodeURIComponent(document.location.href);
}

function autoAdd(obj)
{
  //if(confirm("Are you sure you want to add an Auto-Add item based on this show?"))
  {
    var id = obj.getAttribute('id');
    var channel = obj.getAttribute('channel');

    document.location.href = '/servlet/EpgAutoAddDataRes?action=14&itemID=' + id + '&chan=' + encodeURIComponent(channel) + '&dari=' + encodeURIComponent(document.location.href);
  }
}

function toggleExcludeAutoAdd(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  document.location.href = '/servlet/EpgDataRes?action=27&id=' + id + '&channel=' + encodeURIComponent(channel) + '&dari=' + encodeURIComponent(document.location.href);
}

// Menu section
var menuObj = null;
var iTimerID2 = null;

function showMenu(object, event)
{
    menuObj = object;
    var body = document.getElementsByTagName('body');
    var obj = document.getElementById("menu");
    
    var leftPos = event.clientX - 10;
    var topPos = event.clientY - 10;

    if ( (leftPos + obj.offsetWidth + 5) > body[0].clientWidth )
    {
        leftPos -= obj.offsetWidth - 20;
        if (leftPos<3)
            leftPos = 3;
    }
    if ( (topPos + obj.offsetHeight + 5) > body[0].clientHeight )
    {
        topPos -= obj.offsetHeight - 20;
        if (topPos<3)
            topPos = 3;
    }
    
    leftPos += body[0].scrollLeft;
    topPos += body[0].scrollTop;

    obj.style.left = leftPos + 'px';
    obj.style.top = topPos + 'px';
    obj.style.visibility = 'visible';
}

function cancelHideMenu()
{
    if (iTimerID2)
      window.clearTimeout(iTimerID2);
}

function hideMenu()
{
    var obj = document.getElementById("menu");
    obj.style.visibility = 'hidden';
}

function hideMenuDelay()
{
    iTimerID2 = window.setTimeout(hideMenu, 250);
}

var menuObj2 = null;
var iTimerID22 = null;
var objMenu = null;

function showMenu2(object, event)
{
    hideInput();
    menuObj2 = object;
    var state = object.getAttribute('state');
    if (state == 2)
      objMenu = document.getElementById("menu3");
    else if (object.getAttribute('skip') == 1)
      objMenu = document.getElementById("menu2b");
    else
      objMenu = document.getElementById("menu2");

    var body = document.getElementsByTagName('body');
    
    var leftPos = event.clientX - 10;
    var topPos = event.clientY - 10;

    if ( (leftPos + objMenu.offsetWidth + 5) > body[0].clientWidth )
    {
        leftPos -= objMenu.offsetWidth - 20;
        if (leftPos<3)
            leftPos = 3;
    }
    if ( (topPos + objMenu.offsetHeight + 5) > body[0].clientHeight )
    {
        topPos -= objMenu.offsetHeight - 20;
        if (topPos<3)
            topPos = 3;
    }
    
    leftPos += body[0].scrollLeft;
    topPos += body[0].scrollTop;

    objMenu.style.left = leftPos + 'px';
    objMenu.style.top = topPos + 'px';
    objMenu.style.visibility = 'visible';
}

function cancelHideMenu2()
{
    if (iTimerID22)
      window.clearTimeout(iTimerID22);
}

function hideMenu2()
{
    objMenu.style.visibility = 'hidden';
}

function hideMenuDelay2()
{
    iTimerID22 = window.setTimeout(hideMenu2, 250);
}

function showInEpgSchedule()
{
  document.location.href = '/servlet/EpgDataRes?action=25&id=' + menuObj2.getAttribute('id');
}

function stopSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=09&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function stopScheduleDelFile()
{
  if ( confirm("Are you sure?") )
    document.location.href = '/servlet/ScheduleDataRes?action=09&delfile=1&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function delSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=04&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function changeDateSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=01&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function editSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=02&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function changeDurationSchedule()
{
  inputForm(menuObj2.getAttribute('id'), menuObj2.getAttribute('duration'), menuObj2.getAttribute('stopHour'), menuObj2.getAttribute('stopMinute'), -1) + '&dari=' + encodeURIComponent(document.location.href);
}

function addTimeSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=05&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function skipToNextSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=06&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function showLogSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=07&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}
