var text, obj, balloon2;
var bObj = false;
var prevCell = null;

var posX, posY;

function moveToolTip()
{
    var body = document.getElementsByTagName('body');
    var leftPos = posX - balloon2.offsetWidth - 15;
    var topPos = posY - balloon2.offsetHeight - 15;
    if ( (leftPos<3) && (topPos<3) )
    {
        topPos = 3;
        leftPos = posX + 15;
    }
    else if (leftPos<3)
        leftPos = 3;
    else if (topPos<3)
        topPos = 3;
        
    leftPos += body[0].scrollLeft;
    topPos += body[0].scrollTop;

    obj.style.left = leftPos + 'px';
    obj.style.width = balloon2.style.width;
    obj.style.top = topPos + 'px';
}

function displayMarker(cell)
{
    var mainDiv = document.getElementById("mainDiv");
    if (mainDiv == null) return;
    if (!cell.getAttribute('duration')) return;
    var mainDiv0 = document.getElementById("mainDiv0");
    
    var topPos = cell.offsetTop - mainDiv.scrollTop + mainDiv0.offsetTop;
          
    var objLineTop = document.getElementById('balloon_lineTop');
    objLineTop.style.width = (mainDiv.clientWidth + 20) + 'px';
    objLineTop.style.top = topPos + 'px';
    
    if ( topPos <= mainDiv0.offsetTop )
      objLineTop.style.display = 'none';
    else
      objLineTop.style.display = 'block';
    
    var objLineBottom = document.getElementById('balloon_lineBottom');
    objLineBottom.style.width = objLineTop.style.width;
    objLineBottom.style.top = (topPos + cell.offsetHeight) + 'px';
    
    if ( topPos + cell.offsetHeight >= mainDiv0.offsetTop + mainDiv.offsetHeight )
      objLineBottom.style.display = 'none';
    else
      objLineBottom.style.display = 'block';
}

function showTipNow(cell)
{
    if (bObj == false)
    {
        if (prevCell == cell)
        {
          obj.style.display = 'block';
          var desc2 = cell.getAttribute('desc2');
          if ((desc2) && (desc2.length > 0))
          {
            displayMarker(cell);
          }
          moveToolTip(posX, posY);
        }
        else
        {
          obj = document.getElementById('balloon_tooltip');
          balloon2 = document.getElementById('balloon_tooltip2');
          var bDesc3 = false;
          var desc2 = cell.getAttribute('desc2');
          var desc3 = cell.getAttribute('desc3');
          if ((desc2) && (desc2.length > 0))
          {
            displayMarker(cell);
  
            if (desc3 && (desc3.length > 0))
            {
              bDesc3 = true;
              balloon2.innerHTML = desc2 + '<table id="tDesc3" align="center" cellpadding="2" style="FONT-SIZE: 90%; Border:1px solid white;"><tr><td>' + desc3 + '</td></tr></table>';
            }
            else
            {
              balloon2.innerHTML = desc2;
            }
          }
          else
          {
              balloon2.innerHTML = cell.innerHTML;
              balloon2.getElementsByTagName('span')[2].style.display = 'block';
          }
          
          if (bDesc3)
          {
            var objDesc3 = document.getElementById('tDesc3');
            balloon2.style.width = objDesc3.width;
          }
          else
          {
            var width = balloon2.innerHTML.length;
            balloon2.style.width = width + 'px';
          }

          if (balloon2.clientWidth > 300)
            balloon2.style.width = 300;
          else if (balloon2.clientWidth < 150)
            balloon2.style.width = 150;
          
          bObj = true;
          prevCell = cell;
          moveToolTip(posX, posY);
          obj.innerHTML = balloon2.innerHTML;
          obj.style.display = 'block';
        }
    }
    else
    {
      moveToolTip(posX, posY);
    }
}

var curCell = null;
var iTimerID = null;

function showTip(e,cell,delay)
{
    posX = e.clientX;
    posY = e.clientY;
    curCell = cell;
    
    if (delay == 0)
      showTipNow(cell);
    else if (prevCell == cell)
    {
      showTipNow(cell);
    }
    else
    {
      prevCell = null;
      if (iTimerID)
        window.clearTimeout(iTimerID);

      iTimerID = window.setTimeout(showTipTimer, delay);
    }
}

function showTipTimer()
{
    iTimerID = null;
    showTipNow(curCell);
}

function hideTip()
{
    if (iTimerID)
    {
      window.clearTimeout(iTimerID);
      iTimerID = null;
    }
  	document.getElementById('balloon_tooltip').style.display = 'none';
    bObj = false;
}

function hideMarker()
{
  	document.getElementById('balloon_lineTop').style.display = 'none';
  	document.getElementById('balloon_lineBottom').style.display = 'none';
}

function hideInput()
{
  	document.getElementById('balloon_input').style.display = 'none';
  	inputID = '';
}

function hideAllTip()
{
    hideTip();
    hideMarker();
    hideInput();
}

var inputID = '';
var inputIndex;
var inputDuration, inputStopHour, inputStopMinute;

function savePosition(e)
{
	posX = e.clientX;
	posY = e.clientY;
}

function inputForm(id, duration, stopHour, stopMinute, index)
{
	if ( (inputID == id) && (inputIndex == index) )
	{
		hideInput();
	}
	else
	{
		inputID = id;
		inputIndex = index;
		inputDuration = duration;
		inputStopHour = stopHour;
		inputStopMinute = stopMinute;

    var leftPos = posX - 120;
    if (leftPos<0)
        leftPos = posX + 25;

    var body = document.getElementsByTagName('body');
    var objInputForm = document.getElementById('balloon_input');
    objInputForm.style.left = (body[0].scrollLeft + leftPos) + 'px';
    objInputForm.style.top = (body[0].scrollTop + posY - 10) + 'px';
    objInputForm.style.display = 'block';
    var objDuration = document.getElementById('stopHour');
    objDuration.value = stopHour;
    objDuration = document.getElementById('stopMinute');
    objDuration.value = (stopMinute <= 9) ? ('0' + stopMinute) : stopMinute;
    objDuration = document.getElementById('duration');
    objDuration.value = duration;
    objDuration.select();
    objDuration.focus();
	}
}

function inputOk()
{
    var objDuration = document.getElementById('duration');
    var duration = parseInt(objDuration.value, 10);
    
    // Check if a number.
    if (isNaN(duration))
    	return;

    if ( (duration < 1) || (duration == inputDuration) )
    	return;

	if ( inputIndex > -1 )
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&duration=' + duration + '&index=' + inputIndex + '&dari=' + encodeURIComponent(document.location.href);
	else
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&duration=' + duration + '&dari=' + encodeURIComponent(document.location.href);
}

function inputOkStopTime()
{
    var objStopTime = document.getElementById('stopHour');
    var stopHour = parseInt(objStopTime.value, 10);
    var objStopTime = document.getElementById('stopMinute');
    var stopMinute = parseInt(objStopTime.value, 10);
    
    // Check if a number.
    if ( isNaN(stopHour) || isNaN(stopMinute) )
    	return;

    if ( (stopHour < 0) || (stopMinute < 0) || ((stopHour == inputStopHour) && (stopMinute == inputStopMinute)) )
    	return;

	if ( inputIndex > -1 )
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&stopHour=' + stopHour + '&stopMinute=' + stopMinute + '&index=' + inputIndex + '&dari=' + encodeURIComponent(document.location.href);
	else
		document.location.href = '/servlet/ScheduleDataRes?action=15' + '&id=' + inputID + '&stopHour=' + stopHour + '&stopMinute=' + stopMinute + '&dari=' + encodeURIComponent(document.location.href);
}

var objResize = null;
var startResizePos = -1;
var resizeOrgStart = -1;
var resizeOrgSize = -1;
var bResizeDuration = true;

function showResize(event, obj)
{
  if (startResizePos > -1)
    return;
  
  var pos = GetElementAbsolutePos(obj);
  
  if ( (pos.y-event.clientY < 0) && (pos.y-event.clientY > -10) )
  {
    obj.style.cursor = 'n-resize';
  }
  else if ( (obj.offsetHeight+pos.y-event.clientY < 5) && (obj.offsetHeight+pos.y-event.clientY > 0) )
  {
    obj.style.cursor = 's-resize';
  }
  else
    obj.style.cursor = 'auto';
}

function startResize(event, obj)
{
  var pos = GetElementAbsolutePos(obj);
  
  if ( (pos.y-event.clientY < 5) && (pos.y-event.clientY > -10) )
  {
    if (obj.getAttribute('state') == 2)
      return;

    bResizeDuration = false;
    objResize = obj;
    resizeOrgStart = obj.offsetTop;
    resizeOrgSize = obj.offsetHeight;
    startResizePos = event.clientY;
  }
  else if ( (obj.offsetHeight+pos.y-event.clientY < 5) && (obj.offsetHeight+pos.y-event.clientY > 0) )
  {
    bResizeDuration = true;
    objResize = obj;
    resizeOrgSize = obj.offsetHeight;
    startResizePos = event.clientY;
  }
  else
    startResizePos = -1;
}

function trackResize(event)
{
  if (startResizePos > -1)
  {
    if (bResizeDuration)
    {
      var temp = resizeOrgSize + event.clientY - startResizePos;
      if (temp > 5)
        objResize.style.height = temp;
    }
    else
    {
      var temp = resizeOrgSize - event.clientY + startResizePos;
      if (temp > 5)
      {
        objResize.style.top = resizeOrgStart + event.clientY - startResizePos;
        objResize.style.height = temp;
      }
    }
  }
}

function endResize(event)
{
  if (startResizePos > -1)
  {
    if (bResizeDuration)
    {
      var endBuff = resizeOrgSize + event.clientY - startResizePos ? Math.round((event.clientY - startResizePos) * 60 / cellHeight) : -9999;
      document.location.href = '/servlet/ScheduleDataRes?action=15&id=' + objResize.getAttribute('id') + '&startbuff=0&endbuff=' + endBuff + '&dari=' + encodeURIComponent(document.location.href);
    }
    else
    {
      var startBuff = resizeOrgSize - event.clientY + startResizePos ? Math.round((event.clientY - startResizePos) * 60 / cellHeight) : 9999;
      document.location.href = '/servlet/ScheduleDataRes?action=15&id=' + objResize.getAttribute('id') + '&endbuff=0&startbuff=' + startBuff + '&dari=' + encodeURIComponent(document.location.href);
    }
    
    startResizePos = -1;
    resizeOrgSize = -1;
  }
}

// Menu section
var menuObj = null;
var iTimerID2 = null;

function showMenu(object, event)
{
    menuObj = object;

    var body = document.getElementsByTagName('body');
    var obj = document.getElementById("menu");
    
    var leftPos = event.clientX - 10;
    var topPos = event.clientY - 10;

    if ( (leftPos + obj.offsetWidth + 5) > body[0].clientWidth )
    {
        leftPos -= obj.offsetWidth - 20;
        if (leftPos<3)
            leftPos = 3;
    }
    if ( (topPos + obj.offsetHeight + 5) > body[0].clientHeight )
    {
        topPos -= obj.offsetHeight - 20;
        if (topPos<3)
            topPos = 3;
    }
    
    leftPos += body[0].scrollLeft;
    topPos += body[0].scrollTop;

    obj.style.left = leftPos + 'px';
    obj.style.top = topPos + 'px';
    obj.style.visibility = 'visible';
}

function cancelHideMenu()
{
    if (iTimerID2)
      window.clearTimeout(iTimerID2);
}

function hideMenu()
{
    var obj = document.getElementById("menu");
    obj.style.visibility = 'hidden';
}

function hideMenuDelay()
{
    iTimerID2 = window.setTimeout(hideMenu, 250);
}

var menuObj2 = null;
var iTimerID22 = null;
var objMenu = null;

function showMenu2(object, event)
{
    hideInput();
    menuObj2 = object;
    var state = object.getAttribute('state');
    if (state == 2)
      objMenu = document.getElementById("menu3");
    else if (object.getAttribute('skip') == 1)
      objMenu = document.getElementById("menu2b");
    else
      objMenu = document.getElementById("menu2");

    var body = document.getElementsByTagName('body');
    
    var leftPos = event.clientX - 10;
    var topPos = event.clientY - 10;

    if ( (leftPos + objMenu.offsetWidth + 5) > body[0].clientWidth )
    {
        leftPos -= objMenu.offsetWidth - 20;
        if (leftPos<3)
            leftPos = 3;
    }
    if ( (topPos + objMenu.offsetHeight + 5) > body[0].clientHeight )
    {
        topPos -= objMenu.offsetHeight - 20;
        if (topPos<3)
            topPos = 3;
    }
    
    leftPos += body[0].scrollLeft;
    topPos += body[0].scrollTop;

    objMenu.style.left = leftPos + 'px';
    objMenu.style.top = topPos + 'px';
    objMenu.style.visibility = 'visible';
}

function cancelHideMenu2()
{
    if (iTimerID22)
      window.clearTimeout(iTimerID22);
}

function hideMenu2()
{
    objMenu.style.visibility = 'hidden';
}

function hideMenuDelay2()
{
    iTimerID22 = window.setTimeout(hideMenu2, 250);
}

function showInEpgSchedule()
{
  document.location.href = '/servlet/EpgDataRes?action=25&id=' + menuObj2.getAttribute('id');
}

function stopSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=09&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function stopScheduleDelFile()
{
  if ( confirm("Are you sure?") )
    document.location.href = '/servlet/ScheduleDataRes?action=09&delfile=1&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function delSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=04&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function changeDateSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=01&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function editSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=02&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function changeDurationSchedule()
{
  inputForm(menuObj2.getAttribute('id'), menuObj2.getAttribute('duration'), menuObj2.getAttribute('stopHour'), menuObj2.getAttribute('stopMinute'), -1) + '&dari=' + encodeURIComponent(document.location.href);
}

function addTimeSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=05&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function skipToNextSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=06&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

function showLogSchedule()
{
  document.location.href = '/servlet/ScheduleDataRes?action=07&id=' + menuObj2.getAttribute('id') + '&dari=' + encodeURIComponent(document.location.href);
}

// Navigation menu.
var menuHierarchy = [
  ['<img src="/images/home.png" align="absmiddle" border="0" width="24" height="24">', '/', 
  	["<img border=0 src='/images/epg16.png' align='absmiddle' width='16' height='16'> EPG", '/servlet/EpgDataRes?action=12&scrollto=-1', 
  		['Search EPG', '/servlet/EpgDataRes?action=22'],
  		['Favorites', '/servlet/EpgDataRes?action=29&search=yes&flag=matched'],
  		['Show Now and Next', '/servlet/EpgDataRes?action=21'],
  		['Auto-Add List', '/servlet/EpgAutoAddDataRes?action=01'],
  		['Epg Match Lists', '/servlet/EpgAutoAddDataRes?action=05'],
  		['Refresh Favorites', '/servlet/EpgAutoAddDataRes?action=28'],
  		['Run Auto-Add Scan', "javascript:confirmMenuAction('/servlet/EpgAutoAddDataRes?action=15')"],
  		['Auto-Add Conflicts', '/servlet/EpgAutoAddDataRes?action=25'],
  		['Auto-Add Exclusions', '/servlet/EpgDataRes?action=30&search=yes&flag=excluded'],
  		['ReLoad Data', "javascript:confirmMenuAction('/servlet/EpgDataRes?action=03')"],
  		['Data Source Settings', '/servlet/EpgDataRes?action=16'],
  		['Channel Mapping', '/servlet/EpgDataRes?action=04'],
  		['EPG Data Report', '/servlet/EpgDataRes?action=02']
  	],
  	["<img border=0 src='/images/schedule16.png' align='absmiddle' width='16' height='16'> Schedules", '/servlet/ScheduleDataRes', 
  		['New Schedule', '/servlet/ScheduleDataRes?action=01' + '&dari=' + encodeURIComponent(document.location.href)],
  		['Channel Surf', '/servlet/ScheduleDataRes?action=22']
  	],
  	["<img border=0 src='/images/settings16.png' align='absmiddle' width='16' height='16'> System", '/settings.html',
  		['Select Devices', '/servlet/SystemDataRes?action=04'],
  		['Channel Settings', '/servlet/ChannelDataRes'],
  		['Surf Channel Order', '/servlet/ChannelDataRes?action=14'],
  		['Manage Files', "/servlet/FileManagementDataRes"],
  		['Auto Deletable File', '/servlet/SystemDataRes?action=06'],
  		['System Config', '/servlet/SystemDataRes?action=02'],
  		['System Info', '/servlet/SystemDataRes'],
  		['Edit Tasks', '/servlet/SystemDataRes?action=08'],
  		['Active Tasks', "/servlet/TaskManagementDataRes"],
  		['Keyboard Interface', "/servlet/ApplyTransformRes?xml=null&amp;xsl=kb-root"],
  		['Interface Theme', '/servlet/SystemDataRes?action=19'],
  		['Suspend Computer', "javascript:confirmMenuAction('/servlet/SystemDataRes?action=37' + '&dari=' + encodeURIComponent(document.location.href))"],
  		['Hibernate Computer', "javascript:confirmMenuAction('/servlet/SystemDataRes?action=38 + '&dari=' + encodeURIComponent(document.location.href)')"],
  		['Shutdown Computer', "javascript:confirmMenuAction('/servlet/SystemDataRes?action=39 + '&dari=' + encodeURIComponent(document.location.href)')"]
  	]
	]
];

var menuConfig = [
{
	'height':  24,
	'width' : 24,
	'firstX' : 1,
	'firstY' : 1,
	'hideAfter' : 200,
	'css' : 'menulogo',
	'trace' : true
},
{
	'height':  23,
	'width' : 90,
	'firstY' : 24,
	'firstX' :  0,
	'nextX' : 1,
	'css' : 'menumain'
},
{
  'width' : 135,
	'firstX' : 0,
	'firstY' : 24,
	'nextY' : -1
}
];

function confirmMenuAction(url)
{
    if (confirm('Are you sure?'))
        document.location.href = url;
}

// Product title: Gurt JavaScript Menu
// Product version details: 1.1, 01-25-2006 (mm-dd-yyyy) [compressed version]
// Product URL: http://gurtom.com/products/menus/js
// Contact info: gurt-feedback@gurtom.com (specify product title in subject line)
// Notes: This script is free. Feel free to copy, use and change this script as 
// long as this head part remains unchanged. Visit official site for details.
// Copyright: (c) 2006 by Gurtom.Com

var menus=[],_m3=window.external?[' style="width:100%;height:100%"','div onclick="','div']:['','a href="javascript:','a'],_mC=document.getElementById?function(_mR){return document.getElementById(_mR)}:function(_mR){return document.all[_mR]};function menu(_m1,_mO){var _=this,i;_._m1=_m1;_._mO=_mO;_._mS='';_.id=menus.length;_._m0=[];_._m2=[];_._m4=[0,0];_._mO[-1]={'firstX':20,'firstY':20,'nextX':15,'nextY':15,'width':100,'height':22,'hideAfter':200,'target':'_self','trace':0,'css':''};for(i=0;i<_._m1.length;i++)if(_._m1[i])new _mE(0,_,_,_._m1[i]);for(i=0;i<_._m2.length;i++)_mA(_._m2[i],1);menus[_.id]=_;}function _mD(_mK){var i,a=menus[_mK]._m0;for(i=0;i<a.length;i++){_mA(a[i],0);_mB(a[i],'norm');}}function _mF(_mK,_mI){var m=menus[_mK],_=m._m0[_mI]._m1[1];_mB(m._m0[_mI],'clck');if(_)open(_,_m9(m._m0[_mI]._m8,m._mO,'target'));}function _mG(_mK,_mI){var m=menus[_mK];m._mL=setTimeout('_mD('+_mK+')',_m9(m._mN._m8,m._mO,'hideAfter'));if(m._mN.id==_mI)m._mN=null;}function _mH(_mK,_mI){var m=menus[_mK],_,_m7,i;m._mN=_=m._m0[_mI];if(m._mL)clearTimeout(m._mL);for(i=0;i<m._m0.length;i++){_=m._m0[i];_m7=!m._mN._mS.indexOf(_._mT);if(_m7)_mB(_,_==m._mN?'over':'norm');_mA(_,_m7);}if(m._mN._m6)for(i=m._mN;i&&i._m5;i=i._mP)_mB(i,'over');}function _mE(l,p,m,_m1){var _=this,i,c=p._m2.length,_mO=m._mO;_._m1=_m1;_._mP=p;_._mT=p._mS;_._mS=p._mS+c+':';_._m8=l;_.id=m._m0.length;m._m0[_.id]=_;p._m2[c]=_;var id=m.id+','+_.id,nX,nY;_._m6=_m9(l,_mO,'trace');for(i=l;i>=-1;i--){if(_mO[i]&&_mO[i]['nextX']!=null)nX=_mO[i]['nextX'];if(_mO[i]&&_mO[i]['nextY']!=null)nY=_mO[i]['nextY'];if(nX!=null||nY!=null)break;}_._m4=[p._m4[0]+_m9(l,_mO,'firstX')+(nX!=null?nX*c+_m9(l,_mO,'width')*c:0),p._m4[1]+_m9(l,_mO,'firstY')+(nY!=null?nY*c+_m9(l,_mO,'height')*c:0)];document.write('<',_m3[1],'_mF(',id,')" id="me',id,'" style="position:absolute;top:',_._m4[1],'px;left:',_._m4[0],'px;width:',_m9(l,_mO,'width'),'px;height:',_m9(l,_mO,'height'),'px;visibility:hidden;z-index:',l,';text-decoration:none" onmouseout="_mG(',id,')" onmouseover="_mH(',id,')"><div',_m3[0],' id="mi',id,'" class="',_m9(l,_mO,'css'),'norm">',_m1[0],'</div></',_m3[2],'>');_._m5=[_mC('me'+m.id+','+_.id),_mC('mi'+m.id+','+_.id),_m9(l,_mO,'css')];if(_m1.length>2){_._m2=[];for(i=2;i<_m1.length;i++)if(_m1[i])new _mE(l+1,_,m,_m1[i]);}}function _mA(_,_mJ){if(_._mQ==_mJ)return;_._mQ=_mJ;if(_mJ)_._m5[0].style.visibility='visible';else if(_._m8)_._m5[0].style.visibility='hidden';}function _mB(_,_mM){if(_._m5[3]==_mM)return;_._m5[3]=_mM;_._m5[1].className=_._m5[2]+_mM}function _m9(l,_mO,k){for(var i=l;i>=-1;i--)if(_mO[i]&&_mO[i][k]!=null)return _mO[i][k];}
