var m_sliderWidth = 710;
var m_sliderMin = 0;
var m_sliderMax = 100;
var m_sliderValue;
var m_vlcMaxAudioVol = 100;

function setSlider(width)
{
  m_sliderWidth = width - 10;
}

function setSliderValues(min, max, value)
{
  m_sliderMin = min;
  m_sliderMax = max;
  m_sliderValue = value;
  
  if (m_sliderValue < m_sliderMin)
    m_sliderValue = m_sliderMin;
  else if (m_sliderValue > m_sliderMax)
    m_sliderValue = m_sliderMax;
  
  var sliderBar = document.getElementById("sliderBar");
  
  sliderBar.style.left = m_sliderValue / (m_sliderMax - m_sliderMin) * m_sliderWidth;
}

function getSliderValue()
{
  return m_sliderValue;
}

function sliderSeek(e)
{
  if ( !bSliderSeekable || ((m_sliderMax - m_sliderMin) <= 0) )
    return;
  
  var vlc = document.getElementById("vlc");
  
  if ( (vlc.input.state != 3) && (vlc.input.state != 4) )
    return;

  var sliderLine = document.getElementById("sliderLine");
  var sliderBar = document.getElementById("sliderBar");

  var newPosX = e.clientX - sliderLine.offsetLeft - 5;
  if (newPosX < 0)
    newPosX = 0;
  else if (newPosX > m_sliderWidth)
    newPosX = m_sliderWidth;
  
  m_sliderValue = m_sliderMin + newPosX / m_sliderWidth * (m_sliderMax - m_sliderMin);
  sliderBar.style.left = newPosX;
  sliderStartDrag();
  
  try {vlc.input.position = m_sliderValue > 0.99 ? 0.99 : m_sliderValue;} catch(e) {}
  //try {vlc.input.position = m_sliderValue;} catch(e) {}
}

var m_bSliderDrag = false;

function sliderStartDrag()
{
  m_bSliderDrag = true;
}

function sliderDrag(e)
{
  if (!m_bSliderDrag)
  {
    return;
  }
  
  sliderSeek(e);
}

function sliderStopDrag()
{
  m_bSliderDrag = false;
}

// Audio sliders
var m_sliderValue2 = 50;

function setSliderValues2(value)
{
  m_sliderValue2 = value;

  if (m_sliderValue2 < 0)
    m_sliderValue2 = 0;
  else if (m_sliderValue2 > m_vlcMaxAudioVol)
    m_sliderValue2 = m_vlcMaxAudioVol;
    
  var sliderLine = document.getElementById("sliderLine2");
  sliderLine.style.width = 56 * m_sliderValue2 / m_vlcMaxAudioVol;
}

function sliderSeek2(e)
{
  var vlc = document.getElementById("vlc");
  var sliderLine = document.getElementById("sliderLine2");

  var newPosX = e.clientX - GetElementAbsolutePos(sliderLine).x;
  if (newPosX < 0)
    newPosX = 0;
  else if (newPosX > 56)
    newPosX = 56;
  
  m_sliderValue2 = m_vlcMaxAudioVol * newPosX / 56;
  try
  {
    vlc.audio.volume = m_sliderValue2;
  }
  catch(e) {}

  prevAudioVolume = vlc.audio.volume;
  sliderLine.style.width = newPosX;
  sliderStartDrag2();
}

var m_bSliderDrag2 = false;

function sliderStartDrag2()
{
  m_bSliderDrag2 = true;
}

function sliderDrag2(e)
{
  if (!m_bSliderDrag2)
  {
    return;
  }
  
  sliderSeek2(e);
}

function sliderStopDrag2()
{
  m_bSliderDrag2 = false;
}
