<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>Auto-Add List</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
<script language="JavaScript">
function confirmAction(action)
{
  return true;
	//return confirm("Are you sure you want to " + action + "?");
}

function confirmDeleteAll()
{
	return confirm("Are you sure you want to delete all Auto-Add items (this will also delete the EPG Match list?)");
}

function doAction()
{
  var actionSelect = document.getElementById("actionSelect");
  if (actionSelect.selectedIndex > 0)
    document.location.href = '/servlet/EpgAutoAddDataRes?action=34&amp;actionSelect=' + actionSelect.options[actionSelect.selectedIndex].value;
}

function deleteAutoAdd(index)
{
  document.location.href = '/servlet/EpgAutoAddDataRes?action=32&amp;delSel=1&amp;sel=' + index + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function editAutoAdd(index)
{
  document.location.href = '/servlet/EpgAutoAddDataRes?action=03&amp;index=' + index + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function saveScrollPosition()
{
  var scroll = document.body.scrollTop;
  var items = document.getElementsByTagName("body");
  scroll = items[0].scrollTop;

  var cookieID = document.location.href;
  setCookie("AutoAddListScrollTo", scroll, 32);
}

function loadScrollPosition()
{
  var cookieID = document.location.href;
  var scrollTo = parseInt(readCookie("AutoAddListScrollTo"));
  if (!isNaN(scrollTo))
  {
    var items = document.getElementsByTagName("body");
    items[0].scrollTop = scrollTo;
  }
}
</script>
  </head>
<body onLoad="loadScrollPosition();" onUnload="saveScrollPosition();">
<center>
<a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a><br/>
<table border='0'>

<tr><td colspan='2'>
<table border='0' width="100%">
<tr>
<td width="100%">
</td><td></td></tr>
<tr><td>
<a href='/settings.html' class="noUnder">
<img border='0' src='/images/back.png' align='absmiddle' width='24' height='24'/>
<span class='areaTitle'>System Index</span></a>
</td>
<td nowrap='1'>
<a href='/servlet/EpgAutoAddDataRes?action=03' class='noUnder'>
<img border='0' src='/images/addsch.png' align='absmiddle' width='24' height='24'/>
 <span class='areaTitle'>Add New</span></a>
</td>
</tr>
<tr><td>
<span class='areaTitle'> Current Auto-Add List</span>
</td>
<td nowrap='1'>
<a href='#' class='noUnder' onClick="showHelp('AutoAddSystem');">
<img border='0' src='/images/help24.png' alt='help' align='absmiddle' width='24' height='24'/>
 <span class='areaTitle'>Help</span></a>
</td>
</tr>
</table>
</td>
</tr>

<tr><td colspan="2">
<table border="0" cellspacing="5" cellpadding="2">
<tr>
<td/>
<td nowrap="1" class='itemheading'><strong>Auto-Add</strong></td>
<td nowrap="1" class='itemheading'><strong>Favorite</strong></td>
<td nowrap="1" class='itemheading'><strong>Name</strong></td>
<td nowrap="1" class='itemheading'><strong>Match Lists</strong></td>
<td/>
</tr>
<form action='/servlet/EpgAutoAddDataRes' method='POST' accept-charset="UTF-8">
<input type='hidden' name='action' value='32'/>
<xsl:apply-templates select="//item" />
<xsl:choose>
  <xsl:when test="count(//item) > 0">
    <tr><td/><td colspan='3'><select id='actionSelect' name='actionSelect' onChange='doAction();'><option value='nothing'>Select Action:</option><option value='enableAllAutoAdd'>Enable all Auto-Adds</option><option value='disableAllAutoAdd'>Disable all Auto-Adds</option><option value='enableAllFavorite'>Enable all Favorites</option><option value='disableAllFavorite'>Disable all Favorites</option></select></td><td><a onClick='return confirmDeleteAll();' href='/servlet/EpgAutoAddDataRes?action=33' class='noUnder'><img border='0' src='/images/deleteAll.png' align='absmiddle' width='24' height='24'/> Delete All</a></td><td><input type='image' name='moveEnd' align='absmiddle' border='0' alt='Move selected items to end' title='Move selected items to end' src='/images/moveBefore.png' width='24' height='24' onMouseOver='lineTop(this, true)' onMouseOut='lineTop(this, false)'/><xsl:text> </xsl:text>
    <input type='image' name='delSel' align='absmiddle' border='0' alt='Delete selected items' title='Delete selected items' onClick='return confirmAction("delete the selected items");' src='/images/delete.png' width='24' height='24'/></td></tr>
  </xsl:when>
  <xsl:otherwise>
    <tr><td colspan='5'><center>No Auto-Add items</center></td></tr>
  </xsl:otherwise>
</xsl:choose>
</form>
</table>
</td></tr>

<tr><td colspan="2" align='right'>
<br/>
<a href='/servlet/EpgAutoAddDataRes?action=26' class='noUnder'>
<img border='0' src='/images/Download.png' align='absmiddle' width='24' height='24'/>
Export Auto-Add List</a>
</td></tr>
</table>

<br/><br/><br/>
</center>
</body>
  </html>
</xsl:template>

<xsl:template match="item">
<tr>
<td><input type='checkbox' name='sel'><xsl:attribute name="value"><xsl:value-of select="@index" /></xsl:attribute></input></td>
<td align='center'><a><xsl:attribute name="href">/servlet/EpgAutoAddDataRes?action=27&amp;index=<xsl:value-of select="@index" />&amp;enabled=2</xsl:attribute>
<xsl:choose>
  <xsl:when test="@enabled = 'true'">
    <img border='0' alt='Yes' title='Yes' src='/images/tick.png' width='24' height='24'/>
  </xsl:when>
  <xsl:otherwise>
    <img border='0' alt='No' title='No' src='/images/stop.png' width='24' height='24'/>
  </xsl:otherwise>
</xsl:choose>
</a></td>
<td align='center'><a><xsl:attribute name="href">/servlet/EpgAutoAddDataRes?action=27&amp;index=<xsl:value-of select="@index" />&amp;enabledMark=2</xsl:attribute>
<xsl:choose>
  <xsl:when test="@enabledMark = 'true'">
    <img border='0' alt='Yes' title='Yes' src='/images/tick.png' width='24' height='24'/>
  </xsl:when>
  <xsl:otherwise>
    <img border='0' alt='No' title='No' src='/images/stop.png' width='24' height='24'/>
  </xsl:otherwise>
</xsl:choose>
</a></td>
<td>
<xsl:choose>
  <xsl:when test="string-length(@name) > 0">
    <xsl:value-of select="@name" />
  </xsl:when>
  <xsl:otherwise>
    (None)
  </xsl:otherwise>
</xsl:choose>
</td>
<td>
<xsl:choose>
  <xsl:when test="count(matchList/matchListName) > 0">
    <xsl:apply-templates select="matchList/matchListName" />
  </xsl:when>
  <xsl:otherwise>
    (No Match List Assigned)
  </xsl:otherwise>
</xsl:choose>
</td>
<td align='center' nowrap="1">
<input type='image' align='absmiddle' border='0' alt='Move selected items above this item' title='Move selected items above this item' src='/images/moveBefore.png' width='24' height='24' onMouseOver='lineTop(this, true)' onMouseOut='lineTop(this, false)'><xsl:attribute name="name">move.<xsl:value-of select="@index" /></xsl:attribute> </input><xsl:text> </xsl:text>
<img onClick='deleteAutoAdd({@index})' align='absmiddle' src='/images/delete.png' class="hand" border='0' alt='Delete' title='Delete' width='24' height='24'/><xsl:text> </xsl:text>  
<img onClick="editAutoAdd({@index})" align='absmiddle' src='/images/edit.png' class="hand" border='0' alt='Edit' title='Edit' width='24' height='24'/><xsl:text> </xsl:text>
<a><xsl:attribute name="href">/servlet/EpgAutoAddDataRes?action=23&amp;id=<xsl:value-of select="@index" />&amp;dir=0</xsl:attribute><img border='0' alt='Up' title='Up' src='/images/up01.png' width='7' height='7'/></a><xsl:text> </xsl:text>
<a><xsl:attribute name="href">/servlet/EpgAutoAddDataRes?action=23&amp;id=<xsl:value-of select="@index" />&amp;dir=1</xsl:attribute><img border='0' alt='Down' title='Down' src='/images/down01.png' width='7' height='7'/></a>
</td></tr>
</xsl:template>

<xsl:template match="matchList/matchListName">
<table>
<tr><td><xsl:value-of select="." /><br/>
<em><xsl:choose>
  <xsl:when test="string-length(@days) > 0">
    <xsl:value-of select="@days" />. 
  </xsl:when>
  <xsl:otherwise>
    Any day. 
  </xsl:otherwise>
</xsl:choose>
<xsl:choose>
  <xsl:when test="string-length(@spans) > 0">
    <xsl:value-of select="@spans" /> 
  </xsl:when>
  <xsl:otherwise>
    Any time
  </xsl:otherwise>
</xsl:choose></em>
</td></tr>
</table>
</xsl:template>

</xsl:stylesheet>
