<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>File Manager</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>

<script language="JavaScript">
function changeDir(obj)
{
  var path = obj.getAttribute('path');
  document.location.href = '/servlet/FileManagementDataRes?path=' + encodeURIComponent(path);
}

function delFile(obj)
{
  var path = obj.parentNode.getAttribute('path');
  if ( confirm("Are you sure you want to delete the following file?\n" + path) )
  {
    document.location.href = '/servlet/FileManagementDataRes?action=01&amp;file=' + encodeURIComponent(path) + '&amp;dari=' + encodeURIComponent(document.location.href);
  }
}

function runTask(obj)
{
  var path = obj.parentNode.getAttribute('path');
  document.location.href = '/servlet/FileManagementDataRes?action=02&amp;file=' + encodeURIComponent(path);
}

function downloadFile(obj)
{
  var path = obj.parentNode.getAttribute('path');
  document.location.href = '/servlet/FileManagementDataRes?action=09&amp;file=' + encodeURIComponent(path);
}

function addAutoDel(obj)
{
  var path = obj.parentNode.getAttribute('path');
  document.location.href = '/servlet/FileManagementDataRes?action=04&amp;file=' + encodeURIComponent(path) + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function removeAutoDel(obj)
{
  var path = obj.parentNode.getAttribute('path');
  var id = obj.parentNode.getAttribute('autoDeleteId');
  document.location.href = '/servlet/FileManagementDataRes?action=05&amp;id=' + id + '&amp;file=' + encodeURIComponent(path) + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function saveScrollPosition()
{
  var scroll = document.body.scrollTop;
  var items = document.getElementsByTagName("body");
  scroll = items[0].scrollTop;

  var cookieID = document.location.href;
  setCookie("FileListScrollTo", scroll, 32);
}

function loadScrollPosition()
{
  var cookieID = document.location.href;
  var scrollTo = parseInt(readCookie("FileListScrollTo"));
  if (!isNaN(scrollTo))
  {
    var items = document.getElementsByTagName("body");
    items[0].scrollTop = scrollTo;
  }
}
</script>
  </head>
<body onLoad="loadScrollPosition();" onUnload="saveScrollPosition();">
<center>
<a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a><br/>
<br/>
<table>
<tr><td>
<table width="100%" border="0" cellspacing="2" cellpadding="2">
<tr><td width="100%">
<a href='/settings.html' class="noUnder"><img border='0' src='/images/back.png' align='absmiddle' width='24' height='24'/> 
<span class="areaTitle">System Index</span></a> 
</td>
<td nowrap='1'>
<a href="/servlet/FileManagementDataRes?action=10" class="noUnder">
<img border="0" src="/images/playlist.png" align="absmiddle" width="24" height="24"/> 
<span class="areaTitle">Download Playlist</span></a>
</td>
</tr>
</table>
</td></tr>
<tr><td>
<table width="100%" border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td class="itemheading"><strong>Capture Path</strong></td>
    <td class="itemheading" align="right"><strong>Free Space</strong></td>
  </tr>

<xsl:apply-templates select="//directories/directory" />  
  
</table>
<br/><br/>
<table width="100%" border="0" cellspacing="2" cellpadding="2">

<tr>
<td width="99%"> <strong><xsl:value-of select="//files/@currentDirectory" /></strong> </td>
<td width="1%" align="right" nowrap='1'><strong>(<span><xsl:if test="number(//@minFreeSpace) > number(//@freeSpace)"><xsl:attribute name="class">warning</xsl:attribute></xsl:if><xsl:value-of select="format-number(floor(number(//@freeSpace) div (1024*1024)),'###,###')" /> MB</span> free)</strong></td>
</tr>

</table>
<table width="100%" border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td class="itemheading"><strong>Name</strong></td>
    <td class="itemheading" align="right"><strong>Size</strong></td>
    <td class="itemheading"><strong>Action</strong></td>
  </tr>

<xsl:apply-templates select="//files/file" />    
</table>
</td></tr></table>

</center>
</body>
  </html>
</xsl:template>

<xsl:template match="directories/directory">
<xsl:choose>
  <xsl:when test="@selected">
<tr><td><strong><span class="hand" path="{@name}" onClick="changeDir(this)"><xsl:value-of select="@name"/></span></strong></td>
<td nowrap='1' align="right"><xsl:if test="number(@minFreeSpace) > number(@freeSpace)"><xsl:attribute name="class">warning</xsl:attribute></xsl:if><strong><xsl:value-of select="format-number(floor(number(@freeSpace) div (1024*1024)),'###,###')" /> MB</strong></td></tr>
  </xsl:when>
  <xsl:otherwise>
<tr><td><span class="hand" path="{@name}" onClick="changeDir(this)"><xsl:value-of select="@name"/></span></td>
<td nowrap='1' align="right"><xsl:if test="number(@minFreeSpace) > number(@freeSpace)"><xsl:attribute name="class">warning</xsl:attribute></xsl:if><xsl:value-of select="format-number(floor(number(@freeSpace) div (1024*1024)),'###,###')" /> MB</td></tr>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="files/file">
<xsl:choose>
  <xsl:when test="@type = '0'">
<tr><td><xsl:value-of select="@name" /></td><td nowrap='1' align="right"><xsl:value-of select="format-number(ceiling(number(@size) div 1024),'###,###')" /> KB</td>
<td path="{@path}" autoDeleteId="{@autoDeleteId}" nowrap='1'>
<img onClick="delFile(this)" class='hand' align='absmiddle' src='/images/delete.png' border='0' alt='Delete' title='Delete' width='24' height='24'/><xsl:text> </xsl:text>
<img onClick="runTask(this)" class='hand' align='absmiddle' src='/images/RunTaskSmall.png' border='0' alt='Run Task' title='Run Task' width='24' height='24'/><xsl:text> </xsl:text>
<img onClick="downloadFile(this)" class='hand' align='absmiddle' src='/images/Download.png' border='0' alt='Download File' title='Download File' width='24' height='24'/><xsl:text> </xsl:text>
  <xsl:choose>
    <xsl:when test="@autoDeleteId">
      <img onClick="removeAutoDel(this)" class='hand' align='absmiddle' src='/images/removeAutoDel.png' border='0' alt='Remove from Auto-Delete' title='Remove from Auto-Delete' width='24' height='24'/>
    </xsl:when>
    <xsl:otherwise>
      <img onClick="addAutoDel(this)" class='hand' align='absmiddle' src='/images/addAutoDel.png' border='0' alt='Add to Auto-Delete' title='Add to Auto-Delete' width='24' height='24'/>
    </xsl:otherwise>
  </xsl:choose>
</td></tr>
  </xsl:when>
  <xsl:otherwise>
<tr><td colspan='3'><strong><span class="hand" path="{@path}" onClick="changeDir(this)">&lt;<xsl:value-of select="@name"/>&gt;</span></strong></td></tr>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>
