<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

   <xsl:template match="/">
     
     
      <html>
      <head>
      <title>Timer Control</title>
      <link rel="stylesheet" type="text/css" href="/css/kb.css"/>
      
      <SCRIPT language="JavaScript">
   
      var currentSelection = 0;
      var destination = "";
      var maxItem = 0;
      
      function addEvent(objObject, strEventName, fnHandler)
      {
         if (objObject.addEventListener) // DOM-compliant way to add an event listener
         {
            objObject.addEventListener(strEventName, fnHandler, false);
         }
         else if (objObject.attachEvent) // IE/windows way to add an event listener
         {
            objObject.attachEvent("on" + strEventName, fnHandler);
         }
      }
      
      function Initialize()
      {
        addEvent(document, "keydown", onKeyDownEvent);
      	setActiveButton(0);
      	maxItem = findMaxItem();
      	document.title = "page ready";
      }
      
      function onKeyDownEvent(nKeyCode)
      {
      	var keyCode = nKeyCode.keyCode;
      
      	if	(keyCode == 40) // Down
      	{
            setActiveButton(1);
      	}
      	else if	(keyCode == 38) // Up
      	{
            setActiveButton(-1);
      	}
      	else if (keyCode == 13) // enter
      	{
      	   if(destination.length > 0)
      	      document.location.href = destination;
      	   else
      	      document.location.href = "/servlet/ApplyTransformRes?xml=root&amp;xsl=kb-buttons";
      	   //alert(destination);
      	}
      	else if (keyCode == 36 || keyCode == 27) // back
      	{
      	   document.location.href = "/servlet/ApplyTransformRes?xml=root&amp;xsl=kb-buttons";
      	}
      
      	return false;
      }
      
      function setActiveButton(amount)
      {
         var item = document.getElementById("item_" + currentSelection);
         if(item)
         {
            item.className = item.getAttribute("defaultClass");
         }
      
         currentSelection += amount;
         if(currentSelection &lt; 0) currentSelection = maxItem;
      
         item = document.getElementById("item_" + currentSelection);
         if(item)
         {
            item.className = item.getAttribute("activeClass");
            destination = item.getAttribute("value");
         }
         else
         {
            currentSelection = 0;
            item = document.getElementById("item_" + currentSelection);
            if(item)
            {
               item.className = item.getAttribute("activeClass");
               destination = item.getAttribute("value");
            }
         }
      }
      
      function findMaxItem()
      {
         for(var x = 0; x &lt; 1000; x++)
         {
            var item = document.getElementById("item_" + x);
            if(!item)
               return x-1;   
         } 
      }
      
      </SCRIPT>
      </head>
      <body onload="Initialize();">
      
      <table width="100%" height="100%"><tr><td align="center" valign="middle">
      
      <div class='PageTitle'> <xsl:value-of select="//@start + 1" /> to <xsl:value-of select="//@total" /> of <xsl:value-of select="//@total" /> Auto-Add Items</div>
        
        <table width='80%' class='KBscheduletable' border='0' cellspacing='2' cellpadding='0' >
        
        
         <xsl:if test="number(//@start) = 0">
            <tr>
            <td activeClass='ActiveRow' defaultClass='Row' class='Row' colspan='4'>
            <xsl:attribute name="id">item_0</xsl:attribute>
            <xsl:attribute name="value">/servlet/ApplyTransformRes?xml=root&amp;xsl=kb-buttons</xsl:attribute>
            <span class='solidText'>Main Menu</span>
            </td>
            </tr>
        </xsl:if>  
         
        <xsl:if test="number(//@start) > 0">
           <tr>
           <td activeClass='ActiveRow' defaultClass='Row' class='Row' colspan='3'>
           <xsl:attribute name="id">item_0</xsl:attribute>
            <xsl:if test="number(//@start) - number(//@show) > -1">
               <xsl:attribute name="value"><xsl:value-of select="//mainurl" />start=<xsl:value-of select="number(//@start) - number(//@show)" />&amp;show=<xsl:value-of select="//@show" /></xsl:attribute>
            </xsl:if>
            
            <xsl:if test="number(//@start) - number(//@show) &lt; 0">
               <xsl:attribute name="value"><xsl:value-of select="//mainurl" />start=0&amp;show=<xsl:value-of select="//@show" /></xsl:attribute>
            </xsl:if>           
           <span class='solidText'>Back</span>
           </td>
           </tr>
        </xsl:if>

 
        <xsl:apply-templates select="//aaitem" mode="rows">
           <xsl:with-param name="start" select="//@start" />
           <xsl:with-param name="show" select="//@show" />
        </xsl:apply-templates> 


         <xsl:if test="number(//@start) + number(//@show) &lt; count(//aaitem)">
            <tr>
            <td activeClass='ActiveRow' defaultClass='Row' class='Row' colspan='3'>
            <xsl:attribute name="id">item_<xsl:value-of select="//@show + 1" /></xsl:attribute>
            <xsl:attribute name="value"><xsl:value-of select="//mainurl" />start=<xsl:value-of select="//@start + //@show" />&amp;show=<xsl:value-of select="//@show" /></xsl:attribute>
            <span class='solidText'>Next</span>
            </td>
            </tr>
         </xsl:if>          
 
        
        </table>
        
        
      </td></tr></table>  
      </body>
      </html>     
     
   </xsl:template>



   <xsl:template match="aaitem" mode="rows">

      <xsl:param name="start"/>
      <xsl:param name="show"/>
      
      <xsl:if test="position() &gt; number($start)">
      <xsl:if test="position() &lt; number($start) + number($show) + 1">

         <tr>
   
         <td style="padding-left:20px;" width="100%" activeClass='ActiveRow' defaultClass='Row' class='Row'>
         <xsl:attribute name="id">item_<xsl:value-of select="position() - number($start)" /></xsl:attribute>
         <xsl:attribute name="title"><xsl:value-of select="title" /></xsl:attribute>
         <xsl:attribute name="value"><xsl:value-of select="action" /></xsl:attribute>
         <span class='solidText'><xsl:value-of select="title" /></span>
         </td>
   
         <td class='Row'>
         <xsl:if test="enabled = 'true'">
            Enabled
         </xsl:if>
         <xsl:if test="enabled = 'false'">
            Disabled
         </xsl:if>      
         </td>
         
         </tr> 
      
      </xsl:if>
	   </xsl:if>      

   </xsl:template>         
   

   
</xsl:stylesheet>

