<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
   
      <html>
      <head>
      <title>Timer Control</title>
      <link rel="stylesheet" type="text/css" href="/css/kb.css"/>
      <script>
      
      var id = "<xsl:value-of select="//@id" />";
      var index = "<xsl:value-of select="//@index" />";
      var month = <xsl:value-of select="//@month" />;
      var year = <xsl:value-of select="//@year" />;
      var day = <xsl:value-of select="//@date" />;
      var name = "<xsl:value-of select="//name" />";

      </script>
      
      <script src="/javascript/kbform.js"></script>
      <script src="/javascript/jumpBack.js"></script>
      
      </head>
      <body onload="Initialize();">
      
      <table border="0" width="100%" height="95%">
      <tr><td align="center" valign="middle">
            
      <table border="0" cellpadding="0" cellspacing="0">

        <tr> 
          <td align="right" class="aidl">Name</td>
          <td colspan = "3">
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//name" mode="cell" />
                
              </tr>
          </table>
          </td>
        </tr>
            
        <tr> 
          <td align="right" class="aidl">Time</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2">
              <tr> 
              
                <xsl:apply-templates select="//startTimeHour" mode="cell" />
                
                <td align="right" class="aidl"> : </td>
                <xsl:apply-templates select="//startTimeMin" mode="cell" />
                
                <td class="aidl">Length</td>
                <xsl:apply-templates select="//duration" mode="cell" />
                
              </tr>
          </table>
          </td>
        </tr>
        
        <tr> 
          <td class="aidl">Channel</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//channel" mode="cell" />
                
              </tr>
          </table></td>
        </tr>
        
        <tr> 
          <td class="aidl">Type</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//type" mode="cell" />
                
              </tr>
          </table></td>
        </tr>
        
        <tr> 
          <td class="aidl">Capture Type</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//captureType" mode="cell" />
                
              </tr>
          </table></td>
        </tr> 
         
        <tr> 
          <td class="aidl">AutoDelete</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//autoDel" mode="cell" />
                
              </tr>
          </table></td>
        </tr> 
         
        <tr> 
          <td class="aidl">Keep For</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//keepfor" mode="cell" />
                
              </tr>
          </table></td>
        </tr>
        
        <tr> 
          <td class="aidl">Name Pattern</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//pattern" mode="cell" />
                
              </tr>
          </table></td>
        </tr> 

        <tr> 
          <td class="aidl">Post Task</td>
          <td>
          <table border="0" cellpadding="2" cellspacing="2" width="100%" >
              <tr> 
              
                <xsl:apply-templates select="//posttask" mode="cell" />
                
              </tr>
          </table></td>
        </tr> 

          
      </table>
      
      </td></tr>
      </table>
      
      
      <div id="keyboard" style="position:absolute; left:0; top:0; visibility: hidden; border: 3px solid #FFFFFF;">
         <table border="0" cellspacing="15" bgcolor="#386EB8">

         <tr>
         <td id="keyboardtext" colspan="10" height="40" class="FormInputSelected"></td>
         </tr>         
         
         <tr>
         <td width="25" align="center" id="0-0" value="a" class="FormInput">a</td>
         <td width="25" align="center" id="1-0" value="b" class="FormInput">b</td>
         <td width="25" align="center" id="2-0" value="c" class="FormInput">c</td>
         <td width="25" align="center" id="3-0" value="d" class="FormInput">d</td>
         <td width="25" align="center" id="4-0" value="e" class="FormInput">e</td>
         <td width="25" align="center" id="5-0" value="f" class="FormInput">f</td>
         <td width="25" align="center" id="6-0" value="g" class="FormInput">g</td>
         <td width="25" align="center" id="7-0" value="h" class="FormInput">h</td>
         <td width="25" align="center" id="8-0" value="i" class="FormInput">i</td>
         <td width="25" align="center" id="9-0" value="j" class="FormInput">j</td>
         </tr>
         
         <tr>
         
         <td width="25" align="center" id="0-1" value="k" class="FormInput">k</td>
         <td width="25" align="center" id="1-1" value="l" class="FormInput">l</td>
         <td width="25" align="center" id="2-1" value="m" class="FormInput">m</td>
         <td width="25" align="center" id="3-1" value="n" class="FormInput">n</td>
         <td width="25" align="center" id="4-1" value="o" class="FormInput">o</td>
         <td width="25" align="center" id="5-1" value="p" class="FormInput">p</td>
         <td width="25" align="center" id="6-1" value="q" class="FormInput">q</td>
         <td width="25" align="center" id="7-1" value="r" class="FormInput">r</td>
         <td width="25" align="center" id="8-1" value="s" class="FormInput">s</td>
         <td width="25" align="center" id="9-1" value="t" class="FormInput">t</td>
         </tr>         
         
         <tr>
         <td width="25" align="center" id="0-2" value="u" class="FormInput">u</td>
         <td width="25" align="center" id="1-2" value="v" class="FormInput">v</td>
         <td width="25" align="center" id="2-2" value="w" class="FormInput">w</td>
         <td width="25" align="center" id="3-2" value="x" class="FormInput">x</td>
         <td width="25" align="center" id="4-2" value="y" class="FormInput">y</td>
         <td width="25" align="center" id="5-2" value="z" class="FormInput">z</td>
         <td width="25" align="center" id="6-2" value=" " class="FormInput">_</td>
         <td width="25" align="center" id="7-2" value="&lt;" class="FormInput">&lt;</td>
         <td width="25" align="center" id="8-2" colspan="2" value="ok" class="FormInput">OK</td>
        
         </tr> 
         
         </table>
      </div>      
      
      
      
      <form action="/servlet/KBScheduleDataRes" method="POST" name="data" accept-charset="UTF-8">
      <input type="hidden" name="action" value="03"/>
      <input type="hidden" name="name" value=""/>
      <input type="hidden" name="hour" value=""/>
      <input type="hidden" name="min" value=""/>
      <input type="hidden" name="duration" value=""/>
      <input type="hidden" name="channel" value=""/>
      <input type="hidden" name="type" value=""/>
      <input type="hidden" name="captype" value=""/>
      <input type="hidden" name="month" value=""/>
      <input type="hidden" name="day" value=""/>
      <input type="hidden" name="year" value=""/>
      <input type="hidden" name="autoDel" value=""/>
      <input type="hidden" name="keepfor" value=""/>
      <input type="hidden" name="namePattern" value=""/>
      <input type="hidden" name="task" value=""/>
      <input type="hidden" name="id" value=""/>
      <input type="hidden" name="index" value=""/>
      </form>
      
      </body>
      </html>
   
	</xsl:template>

	<xsl:template match="name" mode="cell">

      <td id="name" class="FormInput" width="400">
      <xsl:value-of select="//name" />
      </td>

	</xsl:template>

	<xsl:template match="startTimeHour" mode="cell">

      <td id="hour" class="FormInput" width="50">
      <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
      <xsl:attribute name="max"><xsl:value-of select="@max" /></xsl:attribute>
      <xsl:attribute name="min"><xsl:value-of select="@min" /></xsl:attribute>
      <xsl:attribute name="amount"><xsl:value-of select="@amount" /></xsl:attribute>
      
      
      <span class="solidText">HH</span>
      </td>
   
	</xsl:template>

   
	<xsl:template match="startTimeMin" mode="cell">

      <td id="min" class="FormInput" width="50">
      <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
      <xsl:attribute name="max"><xsl:value-of select="@max" /></xsl:attribute>
      <xsl:attribute name="min"><xsl:value-of select="@min" /></xsl:attribute>
      <xsl:attribute name="amount"><xsl:value-of select="@amount" /></xsl:attribute>
   
      <span class="solidText">MM</span>
      </td>
   
	</xsl:template>
	
	<xsl:template match="duration" mode="cell">	
	
	   <td id="duration" class="FormInput" width="50">
      <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
      <xsl:attribute name="max"><xsl:value-of select="@max" /></xsl:attribute>
      <xsl:attribute name="min"><xsl:value-of select="@min" /></xsl:attribute>
      <xsl:attribute name="amount"><xsl:value-of select="@amount" /></xsl:attribute>	   
	   
	   <span class="solidText">DUR</span>
	   </td>
	   
	</xsl:template>	

	<xsl:template match="channel" mode="cell">	
	
	   <td id="channel" class="FormInput" width="250">
	   <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
	   
	   <xsl:apply-templates select="option" mode="option" />
	   
	   <span class="solidText">CHANNEL</span></td>
	   
	</xsl:template>
	
	
	<xsl:template match="type" mode="cell">	
	
	   <td id="type" class="FormInput" width="250">
      <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
      <xsl:attribute name="max"><xsl:value-of select="@max" /></xsl:attribute>
      <xsl:attribute name="min"><xsl:value-of select="@min" /></xsl:attribute>
      <xsl:attribute name="amount"><xsl:value-of select="@amount" /></xsl:attribute>
      
      <span class="solidText">TYPE</span>
      </td>
      
	</xsl:template>	

	<xsl:template match="captureType" mode="cell">	
	
	   <td id="captype" class="FormInput" width="250">
	   <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
	   
	   <xsl:apply-templates select="option" mode="option_value" />
	   
	   <span class="solidText">TYPE</span>
	   </td>
	   
	</xsl:template>  

	<xsl:template match="pattern" mode="cell">	
	
	   <td id="namePattern" class="FormInput" width="400">
	   <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
	   
	   <xsl:apply-templates select="option" mode="option" />
	   
	   <span class="solidText">%n</span>
	   </td>
	   
	</xsl:template>
	
	
	<xsl:template match="keepfor" mode="cell">	
	
	   <td id="keepfor" class="FormInput" width="400">
      <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
      <xsl:attribute name="max"><xsl:value-of select="@max" /></xsl:attribute>
      <xsl:attribute name="min"><xsl:value-of select="@min" /></xsl:attribute>
      <xsl:attribute name="amount"><xsl:value-of select="@amount" /></xsl:attribute>
      
      <span class="solidText">30 days</span>
      </td>
      
	</xsl:template>	
	
	<xsl:template match="autoDel" mode="cell">	
	
	   <td id="autoDel" class="FormInput" width="250">
      <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
      <xsl:attribute name="max"><xsl:value-of select="@max" /></xsl:attribute>
      <xsl:attribute name="min"><xsl:value-of select="@min" /></xsl:attribute>
      <xsl:attribute name="amount"><xsl:value-of select="@amount" /></xsl:attribute>
      
      <span class="solidText">true</span>
      </td>
      
	</xsl:template>		

	<xsl:template match="posttask" mode="cell">	
	
	   <td id="postTask" class="FormInput" width="400">
	   <xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute>
	   
	   <xsl:apply-templates select="option" mode="option" />
	   
	   <span class="solidText">none</span>
	   </td>
	   
	</xsl:template>   
   
	<xsl:template match="option" mode="option">	

	   <xsl:attribute name="option_{position()-1}"><xsl:value-of select="." /></xsl:attribute>
      
	</xsl:template>	
	
	<xsl:template match="option" mode="option_value">	

	   <xsl:attribute name="option_{position()-1}"><xsl:value-of select="." /></xsl:attribute>
	   
	   <xsl:attribute name="value_{position()-1}"><xsl:value-of select="." /></xsl:attribute>
      
	</xsl:template>		

	   
</xsl:stylesheet>

