<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

   <xsl:template match="/">
     
     
      <html>
      <head>
      <title>Timer Control</title>
      <link rel="stylesheet" type="text/css" href="/css/kb.css"/>
      
      <SCRIPT language="JavaScript">
   
      var currentSelection = 0;
      var destination = "";
      var maxItem = 0;
      
      function addEvent(objObject, strEventName, fnHandler)
      {
         if (objObject.addEventListener) // DOM-compliant way to add an event listener
         {
            objObject.addEventListener(strEventName, fnHandler, false);
         }
         else if (objObject.attachEvent) // IE/windows way to add an event listener
         {
            objObject.attachEvent("on" + strEventName, fnHandler);
         }
      }
      
      function Initialize()
      {
         addEvent(document, "keydown", onKeyDownEvent);
      	setActiveButton(0);
      	maxItem = findMaxItem();
      	document.title = "page ready";
      }
      
      function onKeyDownEvent(nKeyCode)
      {
      	var keyCode = nKeyCode.keyCode;
      
      	if	(keyCode == 40) // Down
      	{
            setActiveButton(1);
      	}
      	else if	(keyCode == 38) // Up
      	{
            setActiveButton(-1);
      	}
      	else if (keyCode == 13) // enter
      	{
      	   if(destination.length > 0)
      	      document.location.href = destination;
      	   else
      	      document.location.href = "/servlet/ApplyTransformRes?xml=sub-sch&amp;xsl=kb-buttons";
      	   //alert(destination);
      	}
      	else if (keyCode == 36 || keyCode == 27) // back
      	{
      	   document.location.href = "/servlet/ApplyTransformRes?xml=sub-sch&amp;xsl=kb-buttons";
      	}
      
      	return false;
      }
      
      function setActiveButton(amount)
      {
         var item = document.getElementById("item_" + currentSelection);
         if(item)
         {
            item.className = item.getAttribute("defaultClass");
         }
      
         currentSelection += amount;
         if(currentSelection &lt; 0) currentSelection = maxItem;
      
         item = document.getElementById("item_" + currentSelection);
         if(item)
         {
            item.className = item.getAttribute("activeClass");
            destination = item.getAttribute("value");
            setItemDetails(item);
         }
         else
         {
            currentSelection = 0;
            item = document.getElementById("item_" + currentSelection);
            if(item)
            {
               item.className = item.getAttribute("activeClass");
               destination = item.getAttribute("value");
               setItemDetails(item);
            }
         }
      }
      
      function findMaxItem()
      {
         for(var x = 0; x &lt; 1000; x++)
         {
            var item = document.getElementById("item_" + x);
            if(!item)
               return x-1;   
         } 
      }
      
      function setItemDetails(item)
      {
      
         var field = document.getElementById("schName");
         field.innerHTML = item.getAttribute("schName");
         
         field = document.getElementById("schDur");
         field.innerHTML = item.getAttribute("schDur") + " min";
         
         field = document.getElementById("schChannel");
         field.innerHTML = item.getAttribute("schChannel");
         
         field = document.getElementById("schType");
         field.innerHTML = item.getAttribute("schType");
      }
      
      </SCRIPT>
      </head>
      <body onload="Initialize();">
      
      <table width="100%" height="100%"><tr><td align="center" valign="middle">
      
      <xsl:if test="//@total = 0">
      <div class='PageTitle'>
       
        <xsl:if test="//@filter = 0">
        No Pending items to show
        </xsl:if>

        <xsl:if test="//@filter = 1">
        No Past items to show
        </xsl:if>      

      </div>
      </xsl:if>
      
      <xsl:if test="//@total > 0">
      <div class='PageTitle'> <xsl:value-of select="//@start + 1" /> to <xsl:value-of select="//@end" /> of <xsl:value-of select="//@total" />
      
        <xsl:if test="//@filter = 0">
        Pending Items
        </xsl:if>

        <xsl:if test="//@filter = 1">
        Past Items
        </xsl:if>
      
      </div>
      </xsl:if>
      
      <table width="80%" border="0" align="center" cellpadding="5" cellspacing="5">
      
        <tr class='Row' > 
          <td width="100%" class='itemdata' id='schName'><span class='solidText'>Name</span></td>
          <td class='itemdataNoWrap' id='schDur'><span class='solidText'>Duration</span></td>
        </tr>
        
        <tr class='Row'> 
          <td class='itemdata' id='schChannel'><span class='solidText'>Channel</span></td>
          <td class='itemdataNoWrap' id='schType'><span class='solidText'>Type</span></td>
        </tr>
        
      </table><br/>     
        
        
        <table width='80%' class='KBscheduletable' border='0' cellspacing='5' cellpadding='0' >
        
        
         <xsl:if test="//@start = 0">
                 
            <tr>
            <td activeClass='ActiveRow' defaultClass='Row' class='Row' colspan='2'>
            
            <xsl:attribute name="id">item_0</xsl:attribute>
            <xsl:attribute name="schType">NA</xsl:attribute>
            <xsl:attribute name="schStatus">NA</xsl:attribute>
            <xsl:attribute name="schDur">NA</xsl:attribute>
            <xsl:attribute name="schName">NA</xsl:attribute>
            <xsl:attribute name="schChannel">NA</xsl:attribute>
            <xsl:attribute name="value">/servlet/ApplyTransformRes?xml=sub-sch&amp;xsl=kb-buttons</xsl:attribute>
            <span class='solidText'>Back</span>
            </td>
            
            </tr>
      
         </xsl:if>     
         
         <xsl:if test="//@start > 0">
                 
            <tr>
            <td activeClass='ActiveRow' defaultClass='Row' class='Row' colspan='2'>
            
            <xsl:attribute name="id">item_0</xsl:attribute>
            <xsl:attribute name="schType">NA</xsl:attribute>
            <xsl:attribute name="schStatus">NA</xsl:attribute>
            <xsl:attribute name="schDur">NA</xsl:attribute>
            <xsl:attribute name="schName">NA</xsl:attribute>
            <xsl:attribute name="schChannel">NA</xsl:attribute>
            <xsl:attribute name="value">/servlet/KBScheduleDataRes?start=<xsl:value-of select="//@start - //@show" />&amp;show=<xsl:value-of select="//@show" />&amp;filter=<xsl:value-of select="//@filter" /></xsl:attribute>
            <span class='solidText'>Back</span>
            </td>
            
            </tr>
      
         </xsl:if>
        
        
        <xsl:apply-templates select="//schedule" mode="rows" />
        
        
         <xsl:if test="//@end != //@total">
                 
            <tr>
            <td activeClass='ActiveRow' defaultClass='Row' class='Row' colspan='2'>
            
            <xsl:attribute name="id">item_<xsl:value-of select="//@show + 1" /></xsl:attribute>
            <xsl:attribute name="schType">NA</xsl:attribute>
            <xsl:attribute name="schStatus">NA</xsl:attribute>
            <xsl:attribute name="schDur">NA</xsl:attribute>
            <xsl:attribute name="schName">NA</xsl:attribute>
            <xsl:attribute name="schChannel">NA</xsl:attribute>
            <xsl:attribute name="value">/servlet/KBScheduleDataRes?start=<xsl:value-of select="//@end" />&amp;show=<xsl:value-of select="//@show" />&amp;filter=<xsl:value-of select="//@filter" /></xsl:attribute>
            <span class='solidText'>Next</span>
            </td>
            
            </tr>
      
         </xsl:if>          
        
        
        </table>
        
        
        
      </td></tr></table>  
      </body>
      </html>     
     
   </xsl:template>

   
   
   <xsl:template match="schedule" mode="rows">

      <tr>
      <td activeClass='ActiveRow' defaultClass='Row' class='Row'>
      
      <xsl:attribute name="id">item_<xsl:value-of select="position()" /></xsl:attribute>
      <xsl:attribute name="schType"><xsl:value-of select="schType" /></xsl:attribute>
      <xsl:attribute name="schStatus"><xsl:value-of select="schStstus" /></xsl:attribute>
      <xsl:attribute name="schDur"><xsl:value-of select="schDur" /></xsl:attribute>
      <xsl:attribute name="schName"><xsl:value-of select="schName" /></xsl:attribute>
      <xsl:attribute name="schChannel"><xsl:value-of select="schChannel" /></xsl:attribute>
      <xsl:attribute name="value"><xsl:value-of select="action" /></xsl:attribute>
      <span class='solidText'><xsl:value-of select="@start" /></span>
      </td>
      
      <td class='itemdata'><span class='solidText'><xsl:value-of select="schStatus" /></span></td>
      
      </tr> 

   
	</xsl:template>
   
</xsl:stylesheet>

