<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:template match="/">
      <html>
      <head>
      <title>Timer Control</title>
      <link rel="stylesheet" type="text/css" href="/css/kb.css"/>
      <script>
      var back = "<xsl:value-of select="//@back" />";
      </script>
      <script src="/javascript/kbbuttons.js"></script>
      <script src="/javascript/jumpBack.js"></script>
      
      <style type="text/css">      
         td.name
         {
            text-align:right;
            padding:2px; 
            font-size: 24px;
            border: 3px solid #5E8AFF;              
         }
         td.value
         {
            font-size: 24px;
         }    
         td.description
         {
            font-size: 18px;
         	
            border: 3px solid #5E8AFF; 
         }               
      </style>      
      
      </head>
      <body onLoad="Initialize();">
      
      <table border="0" width="100%" height="100%">
      <tr height="50"><td align="center" valign="middle" width="100%"></td></tr>
      <tr><td align="center" valign="middle" width="100%">
      
      
      <table width="80%" border="0" cellspacing="5" id="itemTable">

         <tr>
         <td class="name" >
         Title
         </td>
         <td class="value">
         <xsl:value-of select="//title" />
         </td>
         </tr>
         
         <tr>
         <td class="name">
         Time
         </td>
         <td class="value">
         <xsl:value-of select="//start" />
         </td>
         </tr>      

         <tr>
         <td class="name">
         Length
         </td>
         <td class="value">
         <xsl:value-of select="//duration" /> min
         </td>
         </tr>       
         
         <tr>
         <td class="name">
         Channel
         </td>
         <td class="value">
         <xsl:value-of select="//channel" />
         </td>
         </tr>    
         
         <tr>
         <td class="description" colspan="2">
         Description:<br/>
         <xsl:value-of select="//description" />
         </td>
         </tr>                         

      </table>

      <table border="0" cellspacing="5" id="itemTable">
      
         <tr>
         <td activeClass="ActiveButton" defaultClass="Button" class="Button">
         <xsl:attribute name="value"><xsl:value-of select="//addURL" /></xsl:attribute>  
         <xsl:attribute name="id">item_<xsl:value-of select="0" /></xsl:attribute>
         <xsl:attribute name="confirm">false</xsl:attribute>
         <xsl:attribute name="width">400</xsl:attribute>
         Add to Schedules
         </td>
         </tr>
              
         <tr>
         <td activeClass="ActiveButton" defaultClass="Button" class="Button">
         <xsl:attribute name="value"><xsl:value-of select="//autoAddURL" /></xsl:attribute>  
         <xsl:attribute name="id">item_<xsl:value-of select="1" /></xsl:attribute>
         <xsl:attribute name="confirm">true</xsl:attribute>
         <xsl:attribute name="width">400</xsl:attribute>
         Create Auto-Add Item
         </td>
         </tr>               
               
         <tr>
         <td activeClass="ActiveButton" defaultClass="Button" class="Button">
         <xsl:attribute name="value">/servlet/KBEpgDataRes?action=01&amp;year=<xsl:value-of select="//@year" />&amp;month=<xsl:value-of select="//@month" />&amp;day=<xsl:value-of select="//@day" />&amp;start=<xsl:value-of select="//@hour" />&amp;selected=<xsl:value-of select="//title" /></xsl:attribute>  
         <xsl:attribute name="id">item_<xsl:value-of select="2" /></xsl:attribute>
         <xsl:attribute name="confirm">false</xsl:attribute>
         <xsl:attribute name="width">400</xsl:attribute>
         Show in EPG
         </td>
         </tr>  
                 
         <tr>
         <td activeClass="ActiveButton" defaultClass="Button" class="Button">
         <xsl:attribute name="value">/servlet/ApplyTransformRes?xml=epg-index&amp;xsl=kb-buttons</xsl:attribute>  
         <xsl:attribute name="id">item_<xsl:value-of select="3" /></xsl:attribute>
         <xsl:attribute name="confirm">false</xsl:attribute>
         <xsl:attribute name="width">400</xsl:attribute>
         Main EPG Menu
         </td>
         </tr>  
            
      </table>

      </td></tr>
      <tr height="50"><td align="center" valign="middle" width="100%"></td></tr>
      </table>
      
      <div id="confirm" style="position:absolute; left:0; top:0; visibility: hidden; border: 3px solid #FFFFFF;">
      
      <table border="0" cellspacing="15" bgcolor="#386EB8">
      <tr>
      <td colspan="2" class="questionText">
      <div id="confirmText">Please Confirm The Action!</div>
      </td>
      </tr>
      <tr>
      
      <td id="item2_0" value="yes"
      activeClass="ActiveButton" defaultClass="Button" class="Button" width="200px">
      Yes
      </td>
      
      <td id="item2_1" value="no"
      activeClass="ActiveButton" defaultClass="Button" class="Button" width="200px">
      No
      </td>

      </tr>
      
      </table>
      </div>
      
      </body>
      </html>
	</xsl:template>

</xsl:stylesheet>