<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
   
      <html>
      <head>
      <title>DV Scheduler System Status</title>
      <link rel="stylesheet" href="/css/main.css" type="text/css"/>
      <link rel="stylesheet" href="/css/colour.css" type="text/css" />
<style>
td.infoBar
{
  padding-right: 50px;
}
</style>
      <xsl:comment>[if lt IE 7.0]&gt;
      &lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
      &lt;![endif]</xsl:comment>
      <script src="/javascript/main.js"></script>
      <script src="/javascript/-epg.js"></script>
<script>
     function fnLeftClick(obj, event)
     {
        var id = obj.getAttribute('id');
        var channel = obj.getAttribute('channel');
        
        if ( (id == null) || (id.length == 0) || (channel == null) || (channel.length == 0) )
          return;

        <xsl:if test="//@leftClick = 'Add Schedule'">schedTitle(obj);</xsl:if>
        <xsl:if test="//@leftClick = 'New Schedule'">newSchedule(obj);</xsl:if>
        <xsl:if test="//@leftClick = 'Show Detail'">showTitle(obj);</xsl:if>
        <xsl:if test="//@leftClick = 'Show Menu'">showMenu(obj, event);</xsl:if>
     }
     
     function fnRightClick(obj, event)
     {
        var id = obj.getAttribute('id');
        var channel = obj.getAttribute('channel');
        
        if ( (id == null) || (id.length == 0) || (channel == null) || (channel.length == 0) )
          return;

        <xsl:if test="//@rightClick = 'Add Schedule'">schedTitle(obj);</xsl:if>
        <xsl:if test="//@rightClick = 'New Schedule'">newSchedule(obj);</xsl:if>
        <xsl:if test="//@rightClick = 'Show Detail'">showTitle(obj);</xsl:if>
        <xsl:if test="//@rightClick = 'Show Menu'">showMenu(obj, event);</xsl:if>
     }

function fnLeftClick2(obj, event)
{
  var id = obj.getAttribute('id');
  if ( (id == null) || (id.length == 0) )
    return;
}

function fnRightClick2(obj, event)
{
  var id = obj.getAttribute('id');
  if ( (id == null) || (id.length == 0) )
    return;

  showMenu2(obj, event);
}

function showSurfControl()
{
   var popW = 250;
   var popH = 500;

   var leftPos = 10;
   var topPos = 20;

   var popupWin = window.open('/servlet/ScheduleDataRes?action=22','surf_popup','width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos +',scrollbars=yes,resizable=yes');
   popupWin.focus();
}

function alertNP()
{
<xsl:choose>
  <xsl:when test="(//@preview = '0') and (//@local = '0')">
  alert('Channel Preview not available from remote machine');
  </xsl:when>
  <xsl:when test="(//@preview = '0') and (//@local = '1')">
  alert('Channel Preview not available from local machine');
  </xsl:when>
  <xsl:otherwise>
  </xsl:otherwise>
</xsl:choose>
}

function record(obj)
{
  var channel = obj.getAttribute('channel');
  document.location.href = '/servlet/ScheduleDataRes?action=25&amp;channel=' + encodeURIComponent(channel) + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function showPreview(obj)
{
  var channel = obj.getAttribute('channel');
  document.location.href = '/servlet/ScheduleDataRes?action=17&amp;channel=' + encodeURIComponent(channel) + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function gotoDir(obj)
{
  var path = obj.getAttribute('path');
  document.location.href = '/servlet/FileManagementDataRes?path=' + encodeURIComponent(path);
}
</script>
      </head>
      <body onScroll="hideInput()">
      <center>
      <br/><br/>
      <a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a>
      <br/>
      <br/>
      <xsl:if test="//@warningDevice = '1'"><span class='warning'>Warning: No capture device selected, click <a class='warning' href='/servlet/SystemDataRes?action=04'>here</a></span><br/></xsl:if>
      <xsl:if test="number(//directories/@totalBelowMin) = number(//directories/@total)"><span class='warning'>Warning: Free space below <a class='warning' href='/servlet/FileManagementDataRes'>minimum</a></span><br/></xsl:if>
      <xsl:if test="//@numRecordingError = '1'"><span class='warning'><a class='warning' href='/?action=02'>[Acknowledge]:</a>1 recording error has occurred</span><br/></xsl:if>
      <xsl:if test="//@numRecordingError > '1'"><span class='warning'><a class='warning' href='/?action=02'>[Acknowledge]:</a><xsl:value-of select="//@numRecordingError" /> recording errors have occurred</span><br/></xsl:if>
      <table cellpadding="5" border="0">
      <tr>
      <td valign="top" nowrap="1" rowspan="1">
      
      <a href="/servlet/ScheduleDataRes" class="noUnder">
      <img border="0" src="/images/schedule.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Schedules</span>
      </a>
      <p/>

      <a href="/servlet/FileManagementDataRes?action=10" class="noUnder">
      <img border="0" src="/images/playlist.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Playlist</span>
      </a>
      <p/>
      
      <p/>
      <a class="noUnder" href="/servlet/EpgDataRes?action=12&amp;scrollto=-1"> 
      <img border="0" src="/images/epg.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Show EPG</span>
      </a>
      <p/>      
      
      <p/>
      <a class="noUnder" href="/servlet/EpgDataRes?action=22">
      <img border="0" src="/images/search.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Search EPG</span>
      </a>
      <p/>     
           
      <p/> 
      <a class="noUnder" href="/servlet/EpgDataRes?action=29&amp;search=yes&amp;flag=matched"> 
      <img border="0" src="/images/favorite.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Favorites</span>
      </a>
      <p/>      
      
      <p/>
      <a class="noUnder" href="/servlet/ScheduleDataRes?action=22"> 
      <img border="0" src="/images/surf.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Channel Surf</span>      
      </a>
      <p/>

      <p/>
      <a class="noUnder" href="/servlet/EpgAutoAddDataRes?action=01"> 
      <img border="0" src="/images/auto_add.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Auto-Add</span>      
      </a>
      <p/>

      <p/>
      <a class="noUnder" href="/servlet/FileManagementDataRes">
      <img border="0" src="/images/ManageFiles.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Manage Files</span>      
      </a>
      <p/>

      <p/>
      <a href="/settings.html" class="noUnder">
      <img border="0" src="/images/settings.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">System</span>
      </a>
      <p/>
      
      </td>
      <td valign="top">
      
      <table width="100%">
      <tr><td>
      
      <table width="100%">
	   <tr>
      <td colspan="6" style="border: solid #FFFFFF 1px;">
      <b>Now Running:</b>     
      </td>
      </tr>	
      
      <xsl:if test="count(//now_running/item) > 0">
         <xsl:apply-templates select="//now_running/item" />
      </xsl:if>
      <xsl:if test="count(//now_running/item) = 0">
	      <tr>
         <td colspan="6">
         No running captures
         </td>
         </tr>	
      </xsl:if>
      
      </table>
      <p/>
      
      <table width="100%">
	   <tr>
      <td colspan="6" style="border: solid #FFFFFF 1px;">
      <b>Next Schedule:</b>     
      </td>
      </tr>	
      
      <xsl:if test="count(//next/item) > 0">
         <xsl:apply-templates select="//next/item" />
      </xsl:if>
      <xsl:if test="count(//next/item) = 0">
	      <tr>
         <td colspan="6">
         No pending schedules
         </td>
         </tr>	
      </xsl:if>
      
      </table>
      <p/>      
      
      
      
      <table width="100%">
      
	   <tr>
      <td colspan="1" style="border: solid #FFFFFF 1px;">  
      <b>EPG: <a class="under" href="/servlet/EpgDataRes?action=02#epgAge"><img src="/images/help2_16.png" border="0" align="absmiddle" width="16" height="16" onMouseOut="hideTip();" desc2="what" >
      <xsl:attribute name="onMouseMove">showTip(event,this,<xsl:value-of select="//@balloonDelay" />);</xsl:attribute>
      <xsl:attribute name="desc2"><xsl:value-of select="//@epgLoadDesc" /></xsl:attribute></img></a></b>  
      </td>	   
      <td colspan="2" style="border: solid #FFFFFF 1px;">    
      <b>Now</b>
      </td>
      <td></td>    
      <td colspan="2" style="border: solid #FFFFFF 1px;">    
      <b>Next</b>
      </td>      
      </tr>  
    
      
      <xsl:if test="count(//now_and_next/channel) > 0">
         <xsl:apply-templates select="//now_and_next/channel" />
      </xsl:if>
      <xsl:if test="count(//now_and_next/channel) = 0">
	      <tr>
         <td colspan="5">
         No EPG items
         </td>
         </tr>	
      </xsl:if>
      
      </table>
      <p/>   
      
      <table width="100%">
      <tr><td colspan="5" style="border: solid #FFFFFF 1px;">
       <b>Channel Preview</b> (Right-click to record)<b>:</b><br/>
      </td></tr>
      <xsl:choose>
        <xsl:when test="count(//channels/channel) = 0">
        <tr><td colspan="5">No channel defined</td></tr>
        </xsl:when>
        <xsl:otherwise>
        <xsl:apply-templates select="//channels/channel" />
        </xsl:otherwise>
      </xsl:choose>
      </table>
      <p/>

      <table width="100%">
      <tr><td style="border: solid #FFFFFF 1px;">
       <b>Capture Path:</b></td>
      <td style="border: solid #FFFFFF 1px;">    
      <b>	Free Space</b>
      </td></tr>
      <xsl:choose>
        <xsl:when test="count(//directories/directory) = 0">
        <tr><td colspan="5">No capture path selected</td></tr>
        </xsl:when>
        <xsl:otherwise>
        <xsl:apply-templates select="//directories/directory" />
        </xsl:otherwise>
      </xsl:choose>
      </table>
      <p/>

      <table width="100%">
      <tr><td colspan="1" style="border: solid #FFFFFF 1px;">
       <b>Device:</b></td>
      <td colspan="3" style="border: solid #FFFFFF 1px;">    
      <b>Status</b>
      </td></tr>
      <xsl:choose>
        <xsl:when test="//devices/@total = 0">
        <tr><td colspan="4">No capture device selected</td></tr>
        </xsl:when>
        <xsl:when test="//devices/@total_running = 0">
        <tr><td colspan="4">No device is running</td></tr>
        </xsl:when>
        <xsl:otherwise>
        <xsl:apply-templates select="//devices/device" />
        </xsl:otherwise>
      </xsl:choose>
      </table>
      <p/>

      <table width="100%">
      <tr>
      <td style="border: solid #FFFFFF 1px;">
      <b>Download:</b></td>
      <td style="border: solid #FFFFFF 1px;">
      <b>Size</b></td>
      <td style="border: solid #FFFFFF 1px;">
      <b>Speed</b></td>
      <td style="border: solid #FFFFFF 1px;">
      <b>Time Left</b></td>
      </tr>
      <xsl:choose>
        <xsl:when test="//downloads/@total = 0">
        <tr><td colspan="4" >No download</td></tr>
        </xsl:when>
        <xsl:otherwise>
        <xsl:apply-templates select="//downloads/download" />
        </xsl:otherwise>
      </xsl:choose>
      </table>
      <p/>

      </td></tr>
      </table>

      </td></tr>
      
<tr><td colspan="2" valign="bottom" align="right">
<table><tr>
<xsl:if test="number(//@taskWaiting)>0"><td class="infoBar"><a class="noUnder" href="/servlet/TaskManagementDataRes">Task queued: <xsl:value-of select="//@taskWaiting" /></a></td></xsl:if>
<xsl:if test="number(//@taskRunning)>0"><td class="infoBar"><a class="noUnder" href="/servlet/TaskManagementDataRes">Task running: <xsl:value-of select="//@taskRunning" /></a></td></xsl:if>
<xsl:apply-templates select="//time" />
</tr></table>      
</td>
</tr>

      </table>
      </center>
<div id="balloon_tooltip" align="left" style="font-family: Tahoma, Verdana, Arial, Helvetica; font-size: 90%; font-weight:normal; filter:alpha(opacity=95);KHTMLOpacity:0.95;MozOpacity:0.95;opacity:0.95; position:absolute; overflow:visible; BACKGROUND-COLOR: #306800; padding:5px; display:none; top:1px; left:1px;" />
<div id="balloon_tooltip2" align="left" style="font-family: Tahoma, Verdana, Arial, Helvetica; font-size: 90%; font-weight:normal; filter:alpha(opacity=95);KHTMLOpacity:0.95;MozOpacity:0.95;opacity:0.95; position:absolute; overflow:visible; BACKGROUND-COLOR: #306800; padding:5px; visibility:hidden; top:1px; left:1px;" />
<div id="balloon_input" style="position:absolute; display:none"><input name="duration" title="Duration in minutes" type="text" id="duration" size="1" maxlength="4"/><button onclick="inputOk();" type="button">Ok</button><br/><input name="stopHour" title="Stop hour" type="text" id="stopHour" size="1" maxlength="2"/>:<input name="stopMinute" title="Stop minute" type="text" id="stopMinute" size="1" maxlength="2"/><button onclick="inputOkStopTime();" type="button">Ok</button></div>
<div id="menu" style="position:absolute; visibility:hidden; top:1px; left:1px;" onMouseOver="cancelHideMenu()" onMouseOut="hideMenuDelay()">
<table cellpadding="0" cellspacing="0" >
<tr><td class="menunormal" nowrap="1" onClick="hideMenu(); showTitle(menuObj); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/blank.gif" border="0" align="absmiddle" width="16" height="16" /> Show Detail
</td></tr>
<tr><td class="menunormal" nowrap="1" onClick="hideMenu(); newSchedule(menuObj); className='menunormal';" onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/addsch16.png" border="0" align="absmiddle" width="16" height="16" /> New Schedule
</td></tr>
<tr><td class="menunormal" nowrap="1" onClick="hideMenu(); schedTitle(menuObj); className='menunormal';" onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/add16.png" border="0" align="absmiddle" width="16" height="16" /> Add Schedule
</td></tr>
<tr><td class="menunormal" nowrap="1" onClick="hideMenu(); autoAdd(menuObj); className='menunormal';" onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/reload16.png" border="0" align="absmiddle" width="16" height="16" /> Create Auto-Add Item
</td></tr>
<tr><td class="menunormal" nowrap="1" onClick="hideMenu(); toggleExcludeAutoAdd(menuObj); className='menunormal';" onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/toggleExclusion16.png" border="0" align="absmiddle" width="16" height="16" /> Toggle Auto-Add Exclusion
</td></tr>
<tr><td height="5px">
</td></tr>
<xsl:apply-templates select="//captureType" />
</table>
</div>
<div id="menu2" style="position:absolute; visibility:hidden; top:1px; left:1px;" onMouseOver="cancelHideMenu2()" onMouseOut="hideMenuDelay2()">
<table cellpadding="0" cellspacing="0" >
<tr><td id="menu2ShowLogSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); showLogSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/log.png" border="0" align="absmiddle" width="16" height="16" /> Show Log
</td></tr>
<tr><td id="menu2ShowInEpgSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); showInEpgSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/epglink.png" border="0" align="absmiddle" width="16" height="16" /> Show in EPG
</td></tr>
<tr><td id="menu2DelSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); delSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/delete.png" border="0" align="absmiddle" width="16" height="16" /> Delete
</td></tr>
<tr><td id="menu2ChangeDateSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); changeDateSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/editdate.png" border="0" align="absmiddle" width="16" height="16" /> Change Date
</td></tr>
<tr><td id="menu2EditSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); editSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/edit.png" border="0" align="absmiddle" width="16" height="16" /> Edit
</td></tr>
<tr><td id="menu2ChangeDurationSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); changeDurationSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/+52.png" border="0" align="absmiddle" width="16" height="16" /> Change Duration
</td></tr>
<tr><td id="menu2AddTimeSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); addTimeSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/+5.png" border="0" align="absmiddle" width="16" height="16" /> Add Time
</td></tr>
</table>
</div>
<div id="menu2b" style="position:absolute; visibility:hidden; top:1px; left:1px;" onMouseOver="cancelHideMenu2()" onMouseOut="hideMenuDelay2()">
<table cellpadding="0" cellspacing="0" >
<tr><td id="menu2ShowLogSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); showLogSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/log.png" border="0" align="absmiddle" width="16" height="16" /> Show Log
</td></tr>
<tr><td id="menu2ShowInEpgSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); showInEpgSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/epglink.png" border="0" align="absmiddle" width="16" height="16" /> Show in EPG
</td></tr>
<tr><td id="menu2DelSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); delSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/delete.png" border="0" align="absmiddle" width="16" height="16" /> Delete
</td></tr>
<tr><td id="menu2ChangeDateSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); changeDateSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/editdate.png" border="0" align="absmiddle" width="16" height="16" /> Change Date
</td></tr>
<tr><td id="menu2EditSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); editSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/edit.png" border="0" align="absmiddle" width="16" height="16" /> Edit
</td></tr>
<tr><td id="menu2ChangeDurationSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); changeDurationSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/+52.png" border="0" align="absmiddle" width="16" height="16" /> Change Duration
</td></tr>
<tr><td id="menu2AddTimeSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); addTimeSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/+5.png" border="0" align="absmiddle" width="16" height="16" /> Add Time
</td></tr>
<tr><td id="menu2SkipToNextSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); skipToNextSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/skip.png" border="0" align="absmiddle" width="16" height="16" /> Skip To Next
</td></tr>
</table>
</div>
<div id="menu3" style="position:absolute; visibility:hidden; top:1px; left:1px;" onMouseOver="cancelHideMenu2()" onMouseOut="hideMenuDelay2()">
<table cellpadding="0" cellspacing="0" >
<tr><td id="menu2ShowLogSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); showLogSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/log.png" border="0" align="absmiddle" width="16" height="16" /> Show Log
</td></tr>
<tr><td id="menu2ShowInEpgSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); showInEpgSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/epglink.png" border="0" align="absmiddle" width="16" height="16" /> Show in EPG
</td></tr>
<tr><td id="menu2StopSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); stopSchedule(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/stop.png" border="0" align="absmiddle" width="16" height="16" /> Stop
</td></tr>
<tr><td id="menu2StopScheduleDelFile" class="menunormal" nowrap="1" onClick="hideMenu2(); stopScheduleDelFile(); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/stopDelete.png" border="0" align="absmiddle" width="16" height="16" /> Stop and Delete File
</td></tr>
<tr><td id="menu2EditSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); editSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/edit.png" border="0" align="absmiddle" width="16" height="16" /> Edit
</td></tr>
<tr><td id="menu2ChangeDurationSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); changeDurationSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/+52.png" border="0" align="absmiddle" width="16" height="16" /> Change Duration
</td></tr>
<tr><td id="menu2AddTimeSchedule" class="menunormal" nowrap="1" onClick="hideMenu2(); addTimeSchedule(menuObj2); className='menunormal'; " onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
<img src="/images/+5.png" border="0" align="absmiddle" width="16" height="16" /> Add Time
</td></tr>
</table>
</div>
      </body>
      </html>
   
	</xsl:template>
	
	<xsl:template match="now_and_next/channel" >
	   <tr>
      <td nowrap="1" class="cellHi">
      <xsl:if test="//now_and_next/@channelImage = 1"><xsl:attribute name="align">center</xsl:attribute></xsl:if>
      <xsl:choose>
        <xsl:when test="//@preview = '0'">
      <xsl:if test="(@show = 1) or (@show = 2)">
          <img style="border:0px"><xsl:attribute name="title"><xsl:value-of select="@ws_channel" /></xsl:attribute><xsl:attribute name="src"><xsl:value-of select="@image-file" /></xsl:attribute><xsl:attribute name="width"><xsl:value-of select="@image-width" /></xsl:attribute></img>
      </xsl:if>
      <xsl:if test="(@show = 2)"><br/></xsl:if>
      <xsl:if test="(@show = 0) or (@show = 2)">
          <xsl:value-of select="@ws_channel" />
      </xsl:if>
        </xsl:when>
        <xsl:otherwise>
      <xsl:if test="(@show = 1) or (@show = 2)">
          <img class="handNoBorder" channel="{@ws_channel}" onClick="showPreview(this)"><xsl:attribute name="title">Live Preview - <xsl:value-of select="@ws_channel" /></xsl:attribute><xsl:attribute name="src"><xsl:value-of select="@image-file" /></xsl:attribute><xsl:attribute name="width"><xsl:value-of select="@image-width" /></xsl:attribute></img>
      </xsl:if>
      <xsl:if test="(@show = 2)"><br/></xsl:if>
      <xsl:if test="(@show = 0) or (@show = 2)">
          <span title="Live Preview" class="handNoBorder" channel="{@ws_channel}" onClick="showPreview(this)"><xsl:value-of select="@ws_channel" /></span>
      </xsl:if>
        </xsl:otherwise>
      </xsl:choose>
      </td>	   
      <td nowrap="1" class="cellLow">
      <xsl:if test="string-length(now/start/@hour_12) &gt; 0">    
	      <xsl:value-of select="now/start/@time2" /> (<xsl:value-of select="now/duration" />)
      </xsl:if>
      </td>
      <td class="cellLow">
      <b><span onMouseOut="hideTip();">
<xsl:attribute name="onContextMenu">fnRightClick(this, event); <xsl:if test="//@rightClick != 'No Action'">return false;</xsl:if></xsl:attribute>
<xsl:attribute name="onClick">fnLeftClick(this, event)</xsl:attribute>
<xsl:attribute name="onMouseMove">showTip(event,this,<xsl:value-of select="//@balloonDelay" />);</xsl:attribute>
<xsl:attribute name="desc2"><xsl:value-of select="now/desc" /></xsl:attribute>
<xsl:attribute name="id"><xsl:value-of select="now/id" /></xsl:attribute>
<xsl:attribute name="channel"><xsl:value-of select="@ws_channel" /></xsl:attribute>
<xsl:attribute name="class">programTitle 
<xsl:if test="now/name/@matchedAA = '1'">programTitleMatched </xsl:if>
<xsl:if test="now/name/@excludedAA = '1'">programTitleExcluded </xsl:if>
<xsl:if test="contains(now/desc, '~Err~ ')">programTitleError </xsl:if>
</xsl:attribute>
      <xsl:value-of select="now/name" />
      </span></b>
      </td>
      <td></td>    
      <td nowrap="1" class="cellLow">  
      <xsl:if test="string-length(next/start/@hour_12) &gt; 0">    
         <xsl:value-of select="next/start/@time2" /> (<xsl:value-of select="next/duration" />)
      </xsl:if>
      </td>    
      <td class="cellLow">
      <b><span onMouseOut="hideTip();">
<xsl:attribute name="onContextMenu">fnRightClick(this, event); <xsl:if test="//@rightClick != 'No Action'">return false;</xsl:if></xsl:attribute>
<xsl:attribute name="onClick">fnLeftClick(this, event)</xsl:attribute>
<xsl:attribute name="onMouseMove">showTip(event,this,<xsl:value-of select="//@balloonDelay" />);</xsl:attribute>
<xsl:attribute name="desc2"><xsl:value-of select="next/desc" /></xsl:attribute>
<xsl:attribute name="id"><xsl:value-of select="next/id" /></xsl:attribute>
<xsl:attribute name="channel"><xsl:value-of select="@ws_channel" /></xsl:attribute>
<xsl:attribute name="class">programTitle 
<xsl:if test="next/name/@matchedAA = '1'">programTitleMatched </xsl:if>
<xsl:if test="next/name/@excludedAA = '1'">programTitleExcluded </xsl:if>
<xsl:if test="contains(next/desc, '~Err~ ')">programTitleError </xsl:if>
</xsl:attribute>
      <xsl:value-of select="next/name" />
      </span></b>
      </td>
      </tr>	
	</xsl:template>
	
	
	<xsl:template match="next/item" >
	   <tr>
      <td nowrap="1">
<xsl:if test="number(schedule/@error) > 0">
      <a onClick="javascript:window.event.cancelBubble=true;" onMouseMove="savePosition(event);">
      <xsl:attribute name="href">
         <xsl:value-of select="schedule/actionUrl[@name='LL']/url" />
      </xsl:attribute>
      <img title="Item has error ({schedule/@error})" src="/images/exclaim24.png" border="0" align="center" width="24" height="24" />
      </a>
</xsl:if>
      <a onClick="javascript:window.event.cancelBubble=true;" onMouseMove="savePosition(event);">
      <xsl:attribute name="href">
         <xsl:value-of select="schedule/actionUrl[@name='EPG']/url" />
      </xsl:attribute>
      <img title="Show in EPG" src="/images/epglink.png" border="0" align="center" width="24" height="24" />
      </a>
      </td>
      <td nowrap="1" class="cellHi">
      <xsl:value-of select="start/@time2" /> (<xsl:value-of select="duration" />)
      </td>
      <td nowrap="1" class="cellHi"><xsl:value-of select="schedule/@channel" /></td>
      <td class="cellHi" width="100%" onMouseOut="hideTip();">  
	    <xsl:attribute name="id"><xsl:value-of select="id" /></xsl:attribute>
	    <xsl:attribute name="duration"><xsl:value-of select="duration" /></xsl:attribute>
	    <xsl:attribute name="stopHour"><xsl:value-of select="schedule/@stopHour" /></xsl:attribute>
	    <xsl:attribute name="stopMinute"><xsl:value-of select="schedule/@stopMinute" /></xsl:attribute>
	    <xsl:attribute name="state"><xsl:value-of select="schedule/itemState" /></xsl:attribute>
	    <xsl:attribute name="skip"><xsl:value-of select="schedule/@skip" /></xsl:attribute>
      <xsl:attribute name="onMouseMove">showTip(event,this,<xsl:value-of select="//@balloonDelay" />);</xsl:attribute>
      <xsl:attribute name="desc2"><xsl:value-of select="schedule/@start2" />-<xsl:value-of select="schedule/@stop2" /> (<xsl:value-of select="schedule/@duration" />) <xsl:value-of select="schedule/@channel" /> (<xsl:value-of select="schedule/@type" />)&lt;br&gt;<xsl:value-of select="schedule/@name" /></xsl:attribute>
	    <xsl:attribute name="onClick">fnLeftClick2(this, event);</xsl:attribute>	
      <xsl:attribute name="onContextMenu">fnRightClick2(this, event); <xsl:if test="//@rightClick != 'No Action'">return false;</xsl:if></xsl:attribute>
      <xsl:value-of select="name" />
      </td>
      <td nowrap="1" width="100%">
      <xsl:apply-templates select="schedule/actionUrl" />
      </td>
      <td nowrap="1"> 
      <xsl:value-of select="time_to_action/@days" /> d, <xsl:value-of select="time_to_action/@hours" /> h, <xsl:value-of select="time_to_action/@minutes" /> m, <xsl:value-of select="time_to_action/@seconds" /> s
      </td>
      </tr>	
	</xsl:template>		

	<xsl:template match="now_running/item" >
	   <tr>
      <td nowrap="1">
<xsl:if test="number(schedule/@error) > 0">
      <a onClick="javascript:window.event.cancelBubble=true;" onMouseMove="savePosition(event);">
      <xsl:attribute name="href">
         <xsl:value-of select="schedule/actionUrl[@name='LL']/url" />
      </xsl:attribute>
      <img title="Item has error ({schedule/@error})" src="/images/exclaim24.png" border="0" align="center" width="24" height="24" />
      </a>
</xsl:if>
      <a onClick="javascript:window.event.cancelBubble=true;" onMouseMove="savePosition(event);">
      <xsl:attribute name="href">
         <xsl:value-of select="schedule/actionUrl[@name='EPG']/url" />
      </xsl:attribute>
      <img title="Show in EPG" src="/images/epglink.png" border="0" align="center" width="24" height="24" />
      </a>
      </td>
      <td nowrap="1" class="cellHi">
      <xsl:value-of select="start/@time2" /> (<xsl:value-of select="duration" />)
      </td>
      <td nowrap="1" class="cellHi"><xsl:value-of select="schedule/@channel" /></td>
      <td class="cellHi" width="100%" onMouseOut="hideTip();">   
	    <xsl:attribute name="id"><xsl:value-of select="id" /></xsl:attribute>
	    <xsl:attribute name="duration"><xsl:value-of select="duration" /></xsl:attribute>
	    <xsl:attribute name="stopHour"><xsl:value-of select="schedule/@stopHour" /></xsl:attribute>
	    <xsl:attribute name="stopMinute"><xsl:value-of select="schedule/@stopMinute" /></xsl:attribute>
	    <xsl:attribute name="state"><xsl:value-of select="schedule/itemState" /></xsl:attribute>
	    <xsl:attribute name="skip"><xsl:value-of select="schedule/@skip" /></xsl:attribute>
      <xsl:attribute name="onMouseMove">showTip(event,this,<xsl:value-of select="//@balloonDelay" />);</xsl:attribute>
      <xsl:attribute name="desc2"><xsl:value-of select="schedule/@start2" />-<xsl:value-of select="schedule/@stop2" /> (<xsl:value-of select="schedule/@duration" />) <xsl:value-of select="schedule/@channel" /> (<xsl:value-of select="schedule/@type" />)&lt;br&gt;<xsl:value-of select="schedule/@name" /></xsl:attribute>   
	    <xsl:attribute name="onClick">fnLeftClick2(this, event);</xsl:attribute>	
      <xsl:attribute name="onContextMenu">fnRightClick2(this, event); <xsl:if test="//@rightClick != 'No Action'">return false;</xsl:if></xsl:attribute>
      <xsl:value-of select="name" />
      </td>
      <td nowrap="1" width="100%">
      <xsl:apply-templates select="schedule/actionUrl" />
      </td>
      <td nowrap="1"> 
      <xsl:value-of select="status" />
      </td>
      </tr>	
	</xsl:template>	

   <xsl:template match="actionUrl">
   
      <a onClick="javascript:window.event.cancelBubble=true;" onMouseMove="savePosition(event);">
      <xsl:attribute name="href">
         <xsl:value-of select="url" />
      </xsl:attribute>
      <xsl:if test="@name = 'D'"><img title="Delete" src="/images/delete.png" border="0" align="center" width="24" height="24" /></xsl:if>
      <xsl:if test="@name = 'E2'"><img title="Edit" src="/images/edit.png" border="0" align="center" width="24" height="24" /></xsl:if>
      <xsl:if test="@name = '+2'"><img title="Change Duration" src="/images/+52.png" border="0" align="center" width="24" height="24" /></xsl:if>
      <xsl:if test="@name = 'S'"><img title="Stop" src="/images/stop.png" border="0" align="center" width="24" height="24" /></xsl:if>
      </a>

   </xsl:template>
	
	<xsl:template match="time" >
   
 
      <td><a class="noUnder" href="/servlet/SystemDataRes">Server Time: <xsl:value-of select="@time2" /></a></td>
   
	</xsl:template>	
   
	<xsl:template match="channels/channel" >
    <td>
    <xsl:if test="//channels/@channelImage = 1"><xsl:attribute name="align">center</xsl:attribute></xsl:if>
    <xsl:attribute name="class">
      <xsl:choose>
        <xsl:when test="@group mod 2">cellLow</xsl:when>
        <xsl:otherwise>cellHi</xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
      <xsl:choose>
        <xsl:when test="//@preview = '0'">
          <xsl:if test="(@show = 1) or (@show = 2)">
          <img class="hand" style="border:0px" onClick="alertNP();" channel="{@ws_channel}" onContextMenu="record(this); return false"><xsl:attribute name="title"><xsl:value-of select="@ws_channel" /></xsl:attribute><xsl:attribute name="src"><xsl:value-of select="@image-file" /></xsl:attribute><xsl:attribute name="width"><xsl:value-of select="@image-width" /></xsl:attribute></img>
          </xsl:if>
          <xsl:if test="(@show = 2)"><br/></xsl:if>
          <xsl:if test="(@show = 0) or (@show = 2)">
    <a title="Live Preview not Available" style="text-decoration: none; color: #FFFFFF;" href="#" onClick="alertNP();return false;" channel="{@ws_channel}" onContextMenu="record(this); return false">
    <xsl:value-of select="@ws_channel" /></a>
          </xsl:if>
        </xsl:when>
        <xsl:otherwise>
          <xsl:if test="(@show = 1) or (@show = 2)">
          <img class="handNoBorder" channel="{@ws_channel}" onClick="showPreview(this)" onContextMenu="record(this); return false"><xsl:attribute name="title">Live Preview - <xsl:value-of select="@ws_channel" /></xsl:attribute><xsl:attribute name="src"><xsl:value-of select="@image-file" /></xsl:attribute><xsl:attribute name="width"><xsl:value-of select="@image-width" /></xsl:attribute></img>
          </xsl:if>
          <xsl:if test="(@show = 2)"><br/></xsl:if>
          <xsl:if test="(@show = 0) or (@show = 2)">
    <span class="handNoBorder" title="Live Preview" channel="{@ws_channel}" onClick="showPreview(this)" onContextMenu="record(this); return false">
    <xsl:value-of select="@ws_channel" /></span>
          </xsl:if>
        </xsl:otherwise>
      </xsl:choose>
    </td>
    <xsl:if test="(@group != following-sibling::*[1]/@group) or (@subgroup != following-sibling::*[1]/@subgroup)">
      <tr/>
    </xsl:if>
	</xsl:template>
	
	<xsl:template match="devices/device" >
    <xsl:choose>
      <xsl:when test="@status > 0">
	   <tr>
      <td class="cellHi">
      <xsl:value-of select="@name" />
      </td>
      <td class="cellHi">
      Running <xsl:value-of select="@setting" />
      </td>
      <xsl:choose>
        <xsl:when test="@total_capture = 0"><td nowrap="1" class="cellHi">idle</td><td align="right"><a href="/servlet/ScheduleDataRes?action=ScheduleStopIdleDevice&amp;index={@index}"><img title="Stop" src="/images/stop.png" border="0" align="center" width="24" height="24"/></a></td></xsl:when>
        <xsl:when test="@total_capture = 1"><td nowrap="1" colspan="2" class="cellHi">1 capture</td></xsl:when>
        <xsl:otherwise><td nowrap="1" colspan="2" class="cellHi"><xsl:value-of select="@total_capture" /> captures</td></xsl:otherwise>
      </xsl:choose>
      </tr>	
      </xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>
	</xsl:template>

	<xsl:template match="downloads/download" >
    <tr>
    <td class="cellHi"><xsl:value-of select="@name" /></td>
    <td class="cellHi"><xsl:value-of select="@completed" /></td>
    <td class="cellHi"><xsl:value-of select="@speed" /></td>
    <td class="cellHi"><xsl:value-of select="@timeRemaining" /></td>
    </tr>
	</xsl:template>

	<xsl:template match="captureType">
	  <tr><td class="menunormal" nowrap="1" onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
     <xsl:attribute name="onClick">hideMenu(); className='menunormal'; schedTitleCap(menuObj, '<xsl:value-of select="@name" />')</xsl:attribute>
     <img src="/images/blank.gif" border="0" align="absmiddle" width="16" height="16" /> <xsl:value-of select="@name" />
		</td></tr>
	</xsl:template>

<xsl:template match="directories/directory">
<tr><td class="cellHi"><span class="hand" path="{@name}" onClick="gotoDir(this)"><xsl:value-of select="@name"/></span></td>
<td class="cellHi"><span><xsl:if test="number(@minFreeSpace) > number(@freeSpace)"><xsl:attribute name="class">warning</xsl:attribute></xsl:if><xsl:value-of select="format-number(floor(number(@freeSpace) div (1024*1024)),'###,###')" /> MB</span></td></tr>
</xsl:template>	
</xsl:stylesheet>
