<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>DV Scheduler Surf</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
    <link rel="stylesheet" href="/css/colour.css" type="text/css" />
<style>
.disabled
{
	filter:alpha(opacity=35);
  KHTMLOpacity:0.35;
  MozOpacity:0.35;
  opacity:0.35;
  cursor:default;
}

.enabled
{
	filter:alpha(opacity=100);
  KHTMLOpacity:1.0;
  MozOpacity:1.0;
  opacity:1.0;
  cursor:hand;
  cursor:pointer;
}
</style>
<script src="/javascript/extra.js"></script>
<link rel="stylesheet" href="/css/slider.css" type="text/css" />
<script src="/javascript/slider.js" />
<script>
  function correctPNG2(img)
  {
  }
</script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
<script>
  var settings = new Array();
  var networkPaths = new Array();

  var busy = false;
  var bBusyStopRecording = false;
  var bCanStopRecording = false;
  var bCanRecordTimeShift = false;
  var scheduleID = null;
  var fileID = null;
  var recordingScheduleID = null;
  var recordingName = '';
  var prevCommand;
  var prevChannel;
  var currentChannel;
  var bSliderSeekable = false;
  var itemPlaying = null;
  var keepAliveTime = 10 * 1000;
  //var cache = '';
  var iframeHeight = '';
  var iframeFullHeight = 1000;
  var signalStatPeriod = 3000;
  var bRetry = false;
  var bIgnoreKey = false;

  function setSetting(key, value)
  {
    settings[key] = value;
  }
  
  function removeSetting(key)
  {
    delete settings[key];
  }
  
  function getSetting()
  {
    var text = '';
    for (var i in settings)
    {
      text += ':' + i + '=' + settings[i] + ' ';
    }
    
    return text;
  }

  function loadSetting()
  {
    var vlc = document.getElementById("vlc");
    var audioVolume = parseInt(readCookie("SurfAudioVolume"));
    if (isNaN(audioVolume))
      vlc.audio.volume = 50;
    else if (audioVolume &lt; 0)
      vlc.audio.volume = 0;
    else if (audioVolume &gt; m_vlcMaxAudioVol)
      vlc.audio.volume = m_vlcMaxAudioVol;
    else
      vlc.audio.volume = audioVolume;

    setSliderValues2(vlc.audio.volume);
    
    setCookie("SurfAudioVolume", vlc.audio.volume, 320);
    
    /*
    cache = parseInt(readCookie("SurfCacheAll"));
    if ( (cache.length == 0) || isNaN(cache) )
      cache = '';
    else
    {
      setSetting('http-caching', cache);
      setSetting('udp-caching', cache);
      setSetting('file-caching', cache);
    }
    
    var objCache = document.getElementById("cache");
    objCache.value = cache;
    setCookie("SurfCacheAll", cache, 320);
    */

    //setSetting('sub-track', 0);
    
    var deinterlace = readCookie("SurfDeinterlace");
    var objDeinterlace = document.getElementById("deinterlace");
    if (deinterlace.length > 0)
    {
      if ( (deinterlace == 'discard') || (deinterlace == 'blend') || (deinterlace == 'mean') || (deinterlace == 'bob') || (deinterlace == 'linear') || (deinterlace == 'x') || (deinterlace == 'yadif') || (deinterlace == 'yadif2x') )
      {
        //setSetting('vout-filter', 'deinterlace');
        //setSetting('deinterlace-mode', deinterlace);
        vlc.video.deinterlace.enable(deinterlace);
        objDeinterlace.value = deinterlace;
      }
      else
      {
        vlc.video.deinterlace.disable();
        objDeinterlace.value = 'disabled';
      }
    }
    else
    {
      //setSetting('vout-filter', 'deinterlace');
      //setSetting('deinterlace-mode', 'x');
      vlc.video.deinterlace.enable("x");
      objDeinterlace.value = 'x';
    }
    setCookie("SurfDeinterlace", objDeinterlace.value, 320);
    
    iframeHeight = parseInt(readCookie("SurfIFrameHeight"));
    if ( (iframeHeight.length == 0) || isNaN(iframeHeight) )
    {
      iframeHeight = '';
    }
    else
    {
      var frameList = document.getElementById("frameList");
      frameList.style.height = iframeHeight + "px";
      var objIframeHeight = document.getElementById("iframeHeight");
      objIframeHeight.value = iframeHeight;
    }
    setCookie("SurfIFrameHeight", iframeHeight, 320);
    
    signalStatPeriod = parseInt(readCookie("SurfSignalStatPeriod"));
    if ( isNaN(signalStatPeriod) || (signalStatPeriod &lt; 200) )
      signalStatPeriod = 3000;
    
    var objSignalStatPeriod = document.getElementById("signalStatPeriod");
    objSignalStatPeriod.value = signalStatPeriod;
    setCookie("SurfSignalStatPeriod", signalStatPeriod, 320);
    
    var structuredFileList = parseInt(readCookie("SurfStructuredFileList"));
    if ( (structuredFileList.length == 0) || isNaN(structuredFileList) )
    {
      structuredFileList = '';
    }
    else
    {
      var fileList = document.getElementById("structuredFileList");
      fileList.checked = structuredFileList == 1;
    }
    setCookie("SurfStructuredFileList", structuredFileList, 320);
    
    <xsl:if test="//@local != '1'">
    for (var i in networkPaths)
    {
      var path = readCookie("SurfNetworkPath" + i);
      if (path.length > 0)
      {
        var objNetworkPath = document.getElementById("networkPath" + i);
        if (objNetworkPath)
        {
          objNetworkPath.value = path;
          //setCookie("SurfNetworkPath" + i, path, 320);
          setNetworkPath(i, path);
        }
      }
    }
    </xsl:if>
  }

  function setup()
  {
    var vlc = document.getElementById("vlc");

    setSlider(<xsl:value-of select="//@videowidth" />);
    loadSetting();
    
    //setSliderValues2(vlc.audio.volume);
    
    if (document.attachEvent)
    {
      document.attachEvent("onmouseup", sliderStopDragAll);
      document.attachEvent("onkeydown", keyHandler);
    }
    
    if (document.addEventListener)
    {
      document.addEventListener("mouseup", sliderStopDragAll, false);
      document.addEventListener("keydown", keyHandler, false);
    }
    
    var number = document.getElementById("number");
    number.select();
    number.focus();
  }

  function sliderStopDragAll()
  {
    sliderStopDrag();
    sliderStopDrag2();
  }

  /*
  function setCache(obj)
  {
    if ( obj.value.length == 0 )
    {
      cache = '';
      removeSetting('http-caching');
      removeSetting('udp-caching');
      removeSetting('file-caching');
      setCookie("SurfCacheAll", cache, 320);
    }
    else if ( isNaN(obj.value) )
    {
      obj.value = cache;
    }
    else
    {
      cache = obj.value;
      setSetting('http-caching', cache);
      setSetting('udp-caching', cache);
      setSetting('file-caching', cache);
      setCookie("SurfCacheAll", cache, 320);
    }
  }
  */

  function setDeinterlace(obj)
  {
    var vlc = document.getElementById("vlc");
    var deinterlace = obj.value;
    if ( (deinterlace == 'discard') || (deinterlace == 'blend') || (deinterlace == 'mean') || (deinterlace == 'bob') || (deinterlace == 'linear') || (deinterlace == 'x') || (deinterlace == 'yadif') || (deinterlace == 'yadif2x') )
    {
      //setSetting('vout-filter', 'deinterlace');
      //setSetting('deinterlace-mode', deinterlace);
      vlc.video.deinterlace.enable(deinterlace);
      setCookie("SurfDeinterlace", deinterlace, 320);
    }
    else
    {
      //removeSetting('vout-filter');
      //removeSetting('deinterlace-mode');
      vlc.video.deinterlace.disable();
      setCookie("SurfDeinterlace", 'disabled', 320);
    }
  }
  
  function setIFrameHeight(obj)
  {
    if ( obj.value.length == 0 )
    {
      iframeHeight = "";
      var frameList = document.getElementById("frameList");
      frameList.style.height = iframeFullHeight;
      setCookie("SurfIFrameHeight", iframeHeight, 320);
    }
    else if ( !isNaN(obj.value) )
    {
      iframeHeight = obj.value;
      var frameList = document.getElementById("frameList");
      frameList.style.height = iframeHeight + "px";
      setCookie("SurfIFrameHeight", iframeHeight, 320);
    }
    else
      obj.value = iframeHeight;
  }

  function setIFrameFullHeight(height)
  {
    if (iframeHeight.length != 0)
      return;
    
    iframeFullHeight = height;
    var frameList = document.getElementById("frameList");
    frameList.style.height = height + "px";
  }
  
  function setSignalStatPeriod(obj)
  {
    if ( !isNaN(obj.value) &amp;&amp; (obj.value &gt;= 200) )
    {
      signalStatPeriod = obj.value;
      setCookie("SurfSignalStatPeriod", signalStatPeriod, 320);
    }
    else
      obj.value = signalStatPeriod;
  }
  
  function setNetworkPath(serverPath, networkPath)
  {
    setCookie("SurfNetworkPath" + serverPath, networkPath, 320);

    if (networkPath.length &lt;= 0)
      delete networkPaths[serverPath];
    else
    {
      var networkPath2 = networkPath.replace(/\\/g,"/");
      if ( networkPath2[networkPath2.length-1] != '/' )
        networkPath2 += '/';
      
      networkPaths[serverPath] = networkPath2;
    }
  
    var frameList = document.getElementById("frameList");
    frameList.src = "/servlet/ScheduleDataRes?action=28";
  }

  function setFileList(obj)
  {
    setCookie("SurfStructuredFileList", obj.checked ? 1 : 0, 320);

    var frameList = document.getElementById("frameList");
    frameList.src = "/servlet/ScheduleDataRes?action=28";
  }

  function playerPlay()
  {
    var vlc = document.getElementById("vlc");
    
    if (vlc.playlist.items.count != 0)
    {
      if (vlc.playlist.isPlaying)
      {
        try {vlc.playlist.stop();} catch(e) {}
      }
      
      if (itemPlaying)
        try {vlc.playlist.items.remove(itemPlaying);} catch(e) {}
      itemPlaying = null;
      vlc.playlist.items.clear();
    }

    var location = document.getElementById("location");
    if (location.value &amp;&amp; (location.value.length > 0) )
    {
      var setting = getSetting();
      if ( (setting == null) || (setting.length == 0) )
        itemPlaying = vlc.playlist.add(location.value);
      else
        itemPlaying = vlc.playlist.add(location.value, null, setting);
      vlc.playlist.playItem(itemPlaying);
    }
  }
  
  function playerStop()
  {
    var vlc = document.getElementById("vlc");
    
    setCookie("SurfAudioVolume", vlc.audio.volume, 320);
    
    if (vlc.playlist.items.count != 0)
    {
      if (vlc.playlist.isPlaying)
        try {vlc.playlist.stop();} catch(e) {}
      
      if (itemPlaying)
        try {vlc.playlist.items.remove(itemPlaying);} catch(e) {}
      itemPlaying = null;
      vlc.playlist.items.clear();
    }
  }
  
  function playerTogglePause()
  {
    var vlc = document.getElementById("vlc");
    
    if ( (vlc.playlist.items.count > 0) &amp;&amp; (vlc.input.state &gt;= 1) &amp;&amp; (vlc.input.state &lt;= 4) )
    {
      try {vlc.playlist.togglePause();} catch(e) {}
    }
    else
    {
      var number = document.getElementById('number');
      if ( !isNaN(number.value) )
        changeChannel(2, number.value);
      else
        changeChannel(9, null);
    }
  }

  function changeImage(obj, img)
  {
    obj.src = img;
    correctPNG2(obj);
  }

  var prevPlayPause = 1;
  var prevAudioVolume = -1;
  var prevAudioMute = false;

  setInterval(updateMedia, 500);
  
  function updateMedia()
  {
    var vlc = document.getElementById("vlc");
    var playpause = document.getElementById("playpause");
    var state = -1;
    try {state = vlc.input.state;} catch(e) {}

    if (state == 3)
    {
      setSliderValues(0.0, 1.0, vlc.input.position);
      
      if (prevPlayPause != 2)
      {
        changeImage(playpause, "/images/media-playback-pause.png");
        playpause.title = "Pause";
        prevPlayPause = 2;
      }
    }
    else if (prevPlayPause != 1)
    {
      changeImage(playpause, "/images/media-playback-start.png");
      playpause.title = "Play";
      prevPlayPause = 1;
    }
    
    if (vlc.audio.volume != prevAudioVolume)
    {
      prevAudioVolume = vlc.audio.volume;
      setSliderValues2(prevAudioVolume);
    }
    
    if (vlc.audio.mute != prevAudioMute)
    {
      prevAudioMute = vlc.audio.mute;
      if (prevAudioMute)
        changeImage(audiomute, "/images/audio-volume-muted.png");
      else
        changeImage(audiomute, "/images/audio-volume-high.png");
    }
  }
  
  var request4 = null;
  setTimeout(updateSignalStatistic, signalStatPeriod);
  
  function updateSignalStatistic()
  {
    if ( (scheduleID != null) &amp;&amp; (scheduleID != 'file') &amp;&amp; bSettingVisible )
    {
      request4 = new XMLHttpRequest();
      var url = '/servlet/ScheduleDataRes?action=27&amp;id=' + scheduleID + '&amp;nada=' + new Date().getTime();
      
      request4.open("GET", url, true);
      request4.onreadystatechange = onDownloadSignalStatDone;
      request4.send(null);
    }
    else
    {
      document.getElementById("signalTitle").innerHTML = "Signal:";
      var signalStat = document.getElementById("signalStat");
      signalStat.innerHTML = "Unavailable";
      setTimeout(updateSignalStatistic, signalStatPeriod);
    }
  }
  
  function onDownloadSignalStatDone()
  {
    if (request4.readyState == 4 &amp;&amp; request4.status == 200)
    {
      if (!request4.responseText || (request4.responseText.length &lt; 19) || (request4.responseText.length != request4.responseText.substr(0, 4)) || (request4.responseText.substr(4, 15) != "DVSchedulerSurf"))
      {
        setTimeout(updateSignalStatistic, signalStatPeriod);
        return;
      }
      
      var signalTitle = document.getElementById("signalTitle");
      var signalStat = document.getElementById("signalStat");
      var ss = request4.responseText.split("|");
      
      switch(ss[1])
      {
      case '600':
        signalTitle.innerHTML = "Signal:";
        signalStat.innerHTML = "Unavailable";
        break;
      case '601':
        signalTitle.innerHTML = ss[3] + ":";
        signalStat.innerHTML = ss[2];
        break;
      case '604':
        signalTitle.innerHTML = "Signal:";
        signalStat.innerHTML = ss[2];
        break;
      default:
        signalStat.innerHTML = "Unknown result: return " + ss[1];
      }
      
      setTimeout(updateSignalStatistic, signalStatPeriod);
    }
    else if (request4.readyState == 4)
    {
      signalTitle.innerHTML = "Signal:";
      signalStat.innerHTML = "Network error";
      setTimeout(updateSignalStatistic, signalStatPeriod);
    }
  }
  
  function volumeUp()
  {
    var vlc = document.getElementById("vlc");
    
    try
    {
      var newVol = vlc.audio.volume + 10;
      if (newVol &gt; m_vlcMaxAudioVol)
        vlc.audio.volume = m_vlcMaxAudioVol;
      else
        vlc.audio.volume = newVol;

      setSliderValues2(vlc.audio.volume);
    }
    catch(e) {}
  }
  
  function volumeDown()
  {
    var vlc = document.getElementById("vlc");
    
    try
    {
      var newVol = vlc.audio.volume - 10;
      if (newVol &lt; 0)
        vlc.audio.volume = 0;
      else
        vlc.audio.volume = newVol;

      setSliderValues2(vlc.audio.volume);
    }
    catch(e) {}
  }
  
  function toggleAudioMute()
  {
    var vlc = document.getElementById("vlc");
    var audiomute = document.getElementById("audiomute");

    vlc.audio.toggleMute();
    
    if (vlc.audio.mute)
      changeImage(audiomute, "/images/audio-volume-muted.png");
    else
      changeImage(audiomute, "/images/audio-volume-high.png");
  }
  
  function playerFullScreen()
  {
    var vlc = document.getElementById("vlc");
    
    if (vlc.playlist.items.count != 0)
      vlc.video.fullscreen=true;
  }
  
  function refreshIFrame()
  {
    document.getElementById('frameList').src = '/servlet/ScheduleDataRes?action=28';
  }
  
  function clearMessage()
  {
    var message = document.getElementById("messageDiv");
    message.innerHTML = "";
  }
  
  function formatMessage(text)
  {
    return text.replace(/&lt;/g,"&amp;lt;").replace(/&gt;/g,"&amp;gt;");
  }
  
  function setMessage(text)
  {
    var message = document.getElementById("messageDiv");
    
    message.innerHTML = formatMessage(text);
  }

  function addMessage(text)
  {
    var message = document.getElementById("messageDiv");
    
    message.innerHTML += formatMessage(text);
  }

  function addMessageLine(text)
  {
    var message = document.getElementById("messageDiv");
    
    if (message.innerHTML.length > 0)
      message.innerHTML += "<br/>";
    
    message.innerHTML += formatMessage(text)
  }
  
  var request3 = null;
  function keepAlive()
  {
    if ( (scheduleID == null) || (scheduleID == 'file') || (keepAliveTime &lt;= 0) )
    {
      return;
    }
    
    request3 = new XMLHttpRequest();
    var url = '/servlet/ScheduleDataRes?action=23&amp;id=' + scheduleID + '&amp;nada=' + new Date().getTime();
    
    request3.open("GET", url, true);
    request3.send(null);
    setTimeout(keepAlive, keepAliveTime);
  }
  
  var request2 = null;
  
  function changeChannel(command, newChannel)
  {
    if ( busy &amp;&amp; !bRetry )
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    busy = true;
    
    prevCommand = command;
    prevChannel = (newChannel == null) ? currentChannel : newChannel;

    if (!bRetry)
      clearMessage();
    
    addMessageLine("Changing channel ...");
    
    playerStop();
    
<xsl:if test="(//@local != '1') and (//@customPlayFile = '1')">
    stopFilePlay();
</xsl:if>

    request2 = new XMLHttpRequest();
    var url = '/servlet/ScheduleDataRes?';
    
    if ( (scheduleID == null) || (scheduleID == 'file') )
      url += 'action=19';
    else
      url += 'action=20&amp;id=' + scheduleID;
    
    switch (command)
    {
    case 1:
      url += '&amp;channel=' + encodeURIComponent(newChannel);
      break;
    case 2:
      url += '&amp;channelnumber=' + newChannel;
      break;
    case 3:
      url += '&amp;next=1&amp;channel=' + encodeURIComponent(prevChannel);
      break;
    case 4:
      url += '&amp;previous=1&amp;channel=' + encodeURIComponent(prevChannel);
      break;
    default:
      break;
    }

    url += '&amp;nada=' + new Date().getTime();

    request2.open("GET", url, true);
    request2.onreadystatechange = onDownloadDone;
    request2.send(null);
  }
  
  function stopRecording()
  {
    if (busy == true)
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    if (recordingScheduleID == null)
    {
      //addMessageLine("Nothing to stop");
      return;
    }

    busy = true;
    addMessageLine("Stopping recording ...");
    
    bBusyStopRecording = true;
    request2 = new XMLHttpRequest();
    var url = '/servlet/ScheduleDataRes?action=21&amp;id=' + recordingScheduleID + '&amp;nada=' + new Date().getTime();
    
    request2.open("GET", url, true);
    request2.onreadystatechange = onDownloadDone;
    request2.send(null);
  }
  
  function stopAll()
  {
    if (busy == true)
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    busy = true;
    
    setMessage("Stopping ...");
    
    playerStop();
    
    if (scheduleID == null)
    {
      if (recordingScheduleID)
      {
        bBusyStopRecording = true;
        request2 = new XMLHttpRequest();
        var url = '/servlet/ScheduleDataRes?action=21&amp;id=' + recordingScheduleID + '&amp;nada=' + new Date().getTime();
        
        request2.open("GET", url, true);
        request2.onreadystatechange = onDownloadDone;
        request2.send(null);
      }
      else
      {
        setMessage("Nothing to stop");
        busy = false;
      }
    }
    else if (scheduleID == 'file')
    {
<xsl:choose>
  <xsl:when test="(//@local != '1') and (//@customPlayFile = '1')">
      request2 = new XMLHttpRequest();
      request2.open("GET", '/servlet/FileManagementDataRes?action=08&amp;taskId=' + fileID + '&amp;nada=' + new Date().getTime(), true);
      request2.onreadystatechange = onDownloadDone;
      request2.send(null);
  </xsl:when>
  <xsl:otherwise>
      setMessage("Stopped");
      busy = false;
  </xsl:otherwise>
</xsl:choose>
    }
    else
    {
      request2 = new XMLHttpRequest();
      request2.open("GET", '/servlet/ScheduleDataRes?action=21&amp;id=' + scheduleID + '&amp;nada=' + new Date().getTime(), true);
      request2.onreadystatechange = onDownloadDone;
      request2.send(null);
    }
  }
  
  function setRecordTimeshift(enable)
  {
    var recordTimeShift = document.getElementById("recordTimeShift");
    if (enable)
    {
      bCanRecordTimeShift = true;
      recordTimeShift.className = 'enabled';
      recordTimeShift.disabled = false;
    }
    else
    {
      bCanRecordTimeShift = false;
      recordTimeShift.className = 'disabled';
      recordTimeShift.disabled = true;
    }
  }

  function setStopRecording(enable)
  {
    var stopRecording = document.getElementById("stopRecording");
    if (enable)
    {
      stopRecording.className = 'enabled';
      stopRecording.disabled = false;
    }
    else
    {
      stopRecording.className = 'disabled';
      stopRecording.disabled = true;
    }
  }
  
  function record(channel, start)
  {
    if ( busy &amp;&amp; !bRetry )
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    busy = true;
    
    addMessageLine("Submitting recording request ...");
    
    var number = document.getElementById("number");
    
    request2 = new XMLHttpRequest();
    var url = '/servlet/ScheduleDataRes?action=24';
    
    if (channel != null)
      url += '&amp;channel=' + encodeURIComponent(channel);
    else if ( (scheduleID != null) &amp;&amp; (scheduleID != 'file') )
      url += '&amp;id=' + scheduleID;
    else if ( !isNaN(number.value) )
      url += '&amp;channelnumber=' + number.value;
    
    if (start != null)
      url += '&amp;start=' + start;
    
    url += '&amp;nada=' + new Date().getTime();
    
    request2.open("GET", url, true);
    request2.onreadystatechange = onDownloadDone;
    request2.send(null);
  }
  
  function recordFromGuide(channel, guideID)
  {
    if ( busy &amp;&amp; !bRetry )
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    busy = true;
    
    addMessageLine("Submitting recording request ...");
    
    var number = document.getElementById("number");
    
    request2 = new XMLHttpRequest();
    var url = '/servlet/ScheduleDataRes?action=16';
    
    url += '&amp;channel=' + encodeURIComponent(channel);
    url += '&amp;id=' + guideID;
    
    url += '&amp;nada=' + new Date().getTime();
    
    request2.open("GET", url, true);
    request2.onreadystatechange = onDownloadDone;
    request2.send(null);
  }
  
  function onDownloadDone()
  {
    if (request2.readyState == 4 &amp;&amp; request2.status == 200)
    {
      var number = document.getElementById("number");
      var location = document.getElementById("location");
      
      if (!request2.responseText || (request2.responseText.length &lt; 19) || (request2.responseText.length != request2.responseText.substr(0, 4)) || ((request2.responseText.substr(4, 15) != "DVSchedulerSurf") &amp;&amp; (request2.responseText.substr(4, 11) != "EPGSchedule") &amp;&amp; (request2.responseText.substr(4, 15) != "DVSchedulerFile")))
      {
        addMessageLine("Error with DV Scheduler server connection");
        addMessageLine("Please check DV Scheduler server status before continuing");
        //busy = false;
        return;
      }
      
      var ss = request2.responseText.split("|");
      var value = "";
      
      if (ss[0].substr(4) == 'EPGSchedule')
      {
        if (ss[1] == 'ERROR:Already in list')
        {
          addMessageLine("Identical schedule already exists");
        }
        else
        {
          recordingScheduleID = ss[7];
          recordingName = ss[5];
          setStopRecording(true);
          addMessageLine("Scheduled " + ss[5]);
        }
      }
      else if (ss[0].substr(4) == 'DVSchedulerSurf')
      {
        switch(ss[1])
        {
        case '100':
          addMessageLine("Channel not available in DV Scheduler server: return " + ss[1]);
          break;
        case '101': case '201':
          scheduleID = ss[2];
          currentChannel = ss[3];
          setMessage("Showing " + ss[3]);
          number.value = ss[4];
          value = networkPaths[ss[9]];
          if (!value)
          {
            value = ss[9].replace(/\\/g,"/");
            if ( value[value.length-1] != '/' )
              value += '/';
          }
          location.value = ss[5].replace(/\$networkpath/,value);
          bSliderSeekable = ss[6] == '1' ? true : false;
          keepAliveTime = ss[7] * 1000;
          setRecordTimeshift(ss[8] == '1' ? true : false);
          playerPlay();
          keepAlive();
          break;
        case '102':
          scheduleID = ss[2];
          addMessageLine("Changing to " + ss[3] + " takes too long, unknown result");
          number.value = ss[4];
          //bSliderSeekable = false;
          playerPlay();
          keepAlive();
          break;
        case '104':
          scheduleID = null;
          addMessageLine("Error changing channel: " + ss[2]);
          break;
        case '200':
          scheduleID = null;
          addMessageLine("Surf schedule not running in DV Scheduler server");
          addMessageLine("Submitting a new request ...");
          bRetry = true;
          changeChannel(prevCommand, prevChannel);
          return;
        case '202':
          addMessageLine("New channel not available in DV Scheduler server: return " + ss[1]);
          addMessageLine("Showing " + prevChannel);
          playerPlay();
          break;
        case '203':
          scheduleID = null;
          addMessageLine("Cannot change channel due to active schedule");
          addMessageLine("Trying another device ...");
          bRetry = true;
          changeChannel(prevCommand, prevChannel);
          return;
        case '204':
          scheduleID = null;
          addMessageLine("Error changing channel: " + ss[2]);
          break;
        case '205':
          scheduleID = null;
          addMessageLine("Cannot change channel due to setting");
          addMessageLine("Submitting a new request ...");
          bRetry = true;
          changeChannel(prevCommand, prevChannel);
          return;
        case '206':
          scheduleID = null;
          addMessageLine("Cannot change channel due to active schedule");
          addMessageLine("Submitting a new request ...");
          bRetry = true;
          changeChannel(prevCommand, prevChannel);
          return;
        case '207':
          scheduleID = null;
          addMessageLine("Cannot change channel due to different surf type");
          addMessageLine("Submitting a new request ...");
          bRetry = true;
          changeChannel(prevCommand, prevChannel);
          return;
        case '301':
          if (bBusyStopRecording)
          {
            bBusyStopRecording = false;
            recordingScheduleID = null;
            setStopRecording(false);
            addMessageLine("Recording " + recordingName + " stopped at DV Scheduler server");
          }
          else
          {
            scheduleID = null;
            setMessage("Surf stopped at DV Scheduler server");
            setRecordTimeshift(false);
          }
          break;
        case '302':
          if (bBusyStopRecording)
          {
            bBusyStopRecording = false;
            recordingScheduleID = null;
            setStopRecording(false);
            addMessageLine("Recording schedule not found in DV Scheduler server");
          }
          else
          {
            scheduleID = null;
            addMessageLine("Surf schedule not found in DV Scheduler server");
            setRecordTimeshift(false);
          }
          break;
        case '303':
          bBusyStopRecording = false;
          addMessageLine("Stopping takes too long, unknown result");
          break;
        case '304':
          if (bBusyStopRecording)
          {
            bBusyStopRecording = false;
            addMessageLine("Recording was not running");
          }
          else
          {
            addMessageLine("Surf was not running");
          }
          break;
        case '500':
          addMessageLine("Channel for recording not found in DV Scheduler server");
          break;
        case '501':
          recordingScheduleID = ss[2];
          recordingName = ss[3];
          setStopRecording(true);
          addMessageLine("Recording " + ss[3] + ' for ' + ss[5] + ' minutes');
          break;
        case '502':
          addMessageLine("Starting recording of " + ss[3] + " takes too long, unknown result");
          break;
        case '503':
          addMessageLine("A recording of " + ss[2] + " already exists");
          break;
        case '504':
          addMessageLine("Error starting recording: " + ss[2]);
          break;
        case '505':
          addMessageLine("Recording from start of time-shift with filename " + ss[2]);
          break;
        default:
          addMessageLine("Unknown result: return " + ss[1]);
        }
        refreshIFrame();
      }
      else if (ss[0].substr(4) == 'DVSchedulerFile')
      {
        switch(ss[1])
        {
        case '100':
          addMessageLine("File not found in DV Scheduler server: return " + ss[1]);
          break;
        case '101':
          scheduleID = 'file';
          fileID = ss[2];
          setMessage("Playing " + ss[3]);
          location.value = ss[4].replace(/\\/g,"/");
          bSliderSeekable = ss[5] == '1' ? true : false;
          setRecordTimeshift(false);
          playerPlay();
          break;
        case '102':
          scheduleID = null;
          addMessageLine("Error with play command");
          bSliderSeekable = false;
          setRecordTimeshift(false);
          break;
        case '104':
          scheduleID = null;
          addMessageLine("Error playing file");
          bSliderSeekable = false;
          setRecordTimeshift(false);
          break;
        case '301':
          scheduleID = null;
          setMessage("File play stopped at DV Scheduler server");
          setRecordTimeshift(false);
          break;
        case '302':
          scheduleID = null;
          addMessageLine("File play not found in DV Scheduler server");
          setRecordTimeshift(false);
          break;
        default:
          addMessageLine("Unknown result: return " + ss[1]);
        }
      }
      else
      {
        addMessageLine("Error with DV Scheduler server connection");
        addMessageLine("Please check DV Scheduler server status before continuing");
        //busy = false;
        return;
      }
      
      bRetry = false;
      busy = false;
      number.select();
      number.focus();
    }
    else if (request2.readyState == 4)
    {
      addMessageLine("A network connection error has occurred");
      addMessageLine("Please check DV Scheduler server status before continuing");
    }
    else
    {
      addMessage(" ...");
    }
  }
  
  function stopChannelShow()
  {
    if ( (scheduleID == null) || (scheduleID == 'file') )
      return;
    
    request2 = new XMLHttpRequest();
    request2.open("GET", '/servlet/ScheduleDataRes?action=21&amp;id=' + scheduleID + '&amp;nada=' + new Date().getTime(), true);
    request2.send(null);
  }
  
<xsl:choose>
<xsl:when test="(//@local != '1') and (//@customPlayFile = '1')">
  function stopFilePlay()
  {
    if ( scheduleID != 'file' )
      return;
    
    request2 = new XMLHttpRequest();
    request2.open("GET", '/servlet/FileManagementDataRes?action=08&amp;taskId=' + fileID + '&amp;nada=' + new Date().getTime(), true);
    request2.send(null);
  }

  function stopExit()
  {
    setCookie("SurfAudioVolume", vlc.audio.volume, 320);
    
    if ( scheduleID == null )
      return;
    
    request2 = new XMLHttpRequest();
    
    if ( scheduleID == 'file' )
      request2.open("GET", '/servlet/FileManagementDataRes?action=08&amp;taskId=' + fileID + '&amp;nada=' + new Date().getTime(), true);
    else 
      request2.open("GET", '/servlet/ScheduleDataRes?action=21&amp;id=' + scheduleID + '&amp;nada=' + new Date().getTime(), true);
    
    request2.send(null);
  }

  function playFile(name, path, directory, relativePath)
  {
    if ( busy &amp;&amp; !bRetry )
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    busy = true;
    
    setMessage("Opening file ...");
    
    playerStop();
    stopChannelShow();
    stopFilePlay();

    request2 = new XMLHttpRequest();
    request2.open("GET", '/servlet/FileManagementDataRes?action=06&amp;filePath=' + encodeURIComponent(path) + '&amp;nada=' + new Date().getTime(), true);
    request2.onreadystatechange = onDownloadDone;
    request2.send(null);
  }
</xsl:when>
<xsl:otherwise>
  function stopExit()
  {
    setCookie("SurfAudioVolume", vlc.audio.volume, 320);
    
    if ( (scheduleID == null) || (scheduleID == 'file') )
      return;
    
    request2 = new XMLHttpRequest();
    request2.open("GET", '/servlet/ScheduleDataRes?action=21&amp;id=' + scheduleID + '&amp;nada=' + new Date().getTime(), true);
    request2.send(null);
  }

  function playFile(name, path, directory, relativePath)
  {
<xsl:if test="//@local != '1'">
    var networkPath = networkPaths[directory];
    if ( !networkPath || (networkPath.length &lt;= 0) )
    {
      alert("Network path must first be set in Setting.");
      return;
    }
</xsl:if>

    if ( busy &amp;&amp; !bRetry )
    {
      addMessageLine('Please wait, still processing previous request ...');
      return;
    }
    
    busy = true;
    
    playerStop();
    stopChannelShow();

    scheduleID = 'file';
    setMessage("Playing " + name);

<xsl:choose>
  <xsl:when test="//@local = '1'">
    document.getElementById("location").value = 'file:///' + path;
  </xsl:when>
  <xsl:otherwise>
    document.getElementById("location").value = 'file:///' + networkPath + relativePath;
  </xsl:otherwise>
</xsl:choose>

    bSliderSeekable = true;
    setRecordTimeshift(false);
    playerPlay();
    bRetry = false;
    busy = false;
    number.select();
    number.focus();
  }
</xsl:otherwise>
</xsl:choose>
  
  function checkNumber(e)
  {
    var keyCode = window.event ? e.keyCode : e.which;
    if ( (((keyCode &gt;= 32) &amp;&amp; (keyCode &lt;= 47)) || ((keyCode &gt;= 58) &amp;&amp; (keyCode != 127) &amp;&amp; (keyCode &lt;= 255))) &amp;&amp; !e.ctrlKey &amp;&amp; !e.altKey )
      return false;
    
    return true;
  }
  
  function checkChannelNumber(e)
  {
    var keyCode = window.event ? e.keyCode : e.which;
    var number = document.getElementById('number');
    if ( (keyCode == 13) &amp;&amp; !isNaN(number.value) )
    {
      changeChannel(2, number.value);
      return true;
    }
    else if ( (((keyCode &gt;= 32) &amp;&amp; (keyCode &lt;= 47)) || ((keyCode &gt;= 58) &amp;&amp; (keyCode != 127) &amp;&amp; (keyCode &lt;= 255))) &amp;&amp; !e.ctrlKey &amp;&amp; !e.altKey )
      return false;
    
    return true;
  }
  
  var bSettingVisible = false;
  function toggleSettingVisible()
  {
    bSettingVisible = !bSettingVisible;
    var settingDiv = document.getElementById("settingDiv");
    
    if (bSettingVisible)
      settingDiv.style.display = 'block';
    else
      settingDiv.style.display = 'none';
  }
  
  function keyHandler(e)
  {
    if (bIgnoreKey)
      return;
    
    var keyCode = window.event ? e.keyCode : e.which;
    
    if (e.ctrlKey || e.altKey || e.shiftKey)
      return;
    
    switch(keyCode)
    {
    case 188:
      changeChannel(4,null);  // Previous
      break;
    case 190:
      changeChannel(3,null);  // Next
      break;
    case 80:
      playerTogglePause();  // Play/Pause
      break;
    case 81:
      stopAll();  // Stop
      break;
    case 83:
      if (recordingScheduleID)
      {
        stopRecording();  // Stop recording
      }
      break;
    case 82:
      record(null, null);  // Record
      break;
    case 84:
      if (bCanRecordTimeShift)
      {
        record(null, 'all');  // Record from start of time-shift
      }
      break;
    case 77:
      toggleAudioMute();  // Audio mute
      break;
    case 109: case 189:
      volumeDown();  // Volume down
      break;
    case 107: case 187:
      volumeUp();  // Volume up
      break;
    case 70:
      playerFullScreen();  // Full screen
      break;
    case 86:
      refreshIFrame();  // Refresh IFrame
      break;
    case 67:
      setMessage('');  // Clear message div
      break;
    default:
    }
  }
<xsl:if test="//@local != '1'">
  <xsl:apply-templates select="//directories/directory" mode="save" />
</xsl:if>
</script>
  </head>
  <body onload="setup();" onbeforeunload="stopExit()">
  <center>
  <xsl:choose>
    <xsl:when test="contains(//@User-Agent,'MSIE') or contains(//@User-Agent,'Trident')">
 <OBJECT classid="clsid:9BE31822-FDAD-461B-AD51-BE1D1C159921"
    id="vlc" events="True"><xsl:attribute name="width"><xsl:value-of select="//@videowidth" /></xsl:attribute><xsl:attribute name="height"><xsl:value-of select="//@videoheight" /></xsl:attribute>
    <xsl:if test="//@protocol != 'HTTPS'"><xsl:attribute name="codebase">http://downloads.videolan.org/pub/videolan/vlc/latest/win32/axvlc.cab</xsl:attribute></xsl:if>
  <param name="AutoLoop" value="True" /> 
 </OBJECT>
    </xsl:when>
    <xsl:otherwise>
  <embed type="application/x-vlc-plugin" pluginspage="http://www.videolan.org" version="VideoLAN.VLCPlugin.2"
    loop="yes" id="vlc"><xsl:attribute name="width"><xsl:value-of select="//@videowidth" /></xsl:attribute><xsl:attribute name="height"><xsl:value-of select="//@videoheight" /></xsl:attribute>
  </embed>
    </xsl:otherwise>
  </xsl:choose>
<div align="left" class="sliderArea" onmousemove="sliderDrag(event);"><xsl:attribute name="style">width:<xsl:value-of select="//@videowidth" />px</xsl:attribute>
<div class="sliderLine" id="sliderLine" onmousedown="sliderSeek(event);"><table><tr><td class="sliderLine"><xsl:attribute name="style">width:<xsl:value-of select="//@videowidth" />px</xsl:attribute>x</td></tr></table></div>
<div class="sliderBar" id="sliderBar" onmousedown="sliderStartDrag();" onmouseup="sliderStopDrag();" onmousemove="sliderDrag(event);" />
</div>
  <table>
  <tr>
  <td class="cellHi"><img border="0" src="/images/go-previous.png" title="Previous Channel" alt="Previous Channel" align="absmiddle" width="32" height="32" style='cursor:hand;cursor:pointer;' onClick="changeChannel(4,null)" />
  <input name="number" type="text" id="number" size="2" maxlength="5" title="Channel Number" onkeypress="return checkChannelNumber(event);" />
  <img border="0" src="/images/go-next.png" title="Next Channel" alt="Next Channel" align="absmiddle" width="32" height="32" style='cursor:hand;cursor:pointer;' onClick="changeChannel(3,null)" /></td>
  <td class="cellHi"><img id="playpause" border="0" src="/images/media-playback-start.png" title="Play" alt="Play" align="absmiddle" width="32" height="32" style='cursor:hand;cursor:pointer;' onClick="playerTogglePause();" />
  <img border="0" src="/images/media-playback-stop.png" title="Stop" alt="Stop" align="absmiddle" width="32" height="32" style='cursor:hand;cursor:pointer;' onClick="stopAll();" /></td>
  <td class="cellHi"><img border="0" src="/images/media-record.png" title="Record" alt="Record" align="absmiddle" width="32" height="32" style='cursor:hand;cursor:pointer;' onClick="record(null, null);" />
  <input type="image" disabled="true" class="disabled" id="recordTimeShift" border="0" src="/images/add.png" title="Record from start of time-shift" alt="Record from start of time-shift" align="absmiddle" width="24" height="24" onClick="record(null, 'all');" />&#160;&#160;<input type="image" disabled="true" class="disabled" id="stopRecording" border="0" src="/images/stop.png" title="Stop Recording" alt="Stop Recording" align="absmiddle" width="24" height="24" onClick="stopRecording();" /></td>
  <td class="cellHi"><img id="audiomute" border="0" src="/images/audio-volume-high.png" title="Audio Mute" alt="Audio Mute" align="absmiddle" width="32" height="32" style='cursor:hand;cursor:pointer;' onClick="toggleAudioMute()" /></td>
  <td class="sliderLine2" onmousedown="sliderSeek2(event);" onmouseup="sliderStopDrag2();" onmousemove="sliderDrag2(event);"><div class="sliderLine2" id="sliderLine2"></div></td>
  <td class="cellHi"><button onclick="playerFullScreen();" type="button" >Full Screen</button></td>
  <td class="cellHi">MRL:<input type="text" id="location" size="15" title="Address of Stream" readonly="true" value="" /></td>
  <td class="cellHi"><img style='cursor:hand;cursor:pointer;' border='0' src='/images/view-refresh.png' title='Refresh List' alt='Refresh IFrame' align='absmiddle' onClick="refreshIFrame()" width='24' height='24' /></td>
  <td class="cellHi"><img style='cursor:hand;cursor:pointer;' border='0' src='/images/edit.png' title='Setting' alt='Setting' align='absmiddle' onClick="toggleSettingVisible();" width='24' height='24' /></td>
  <td class="cellHi"><img style='cursor:hand;cursor:pointer;' border='0' src='/images/help24.png' title='Help' alt='Help' align='absmiddle' onClick="showHelp('ChannelSurf');" width='24' height='24' /></td>
  </tr>
  </table>
  <div id='settingDiv' style="display:none">
  <table>
  <tr>
  <!--td class="cellHi">Cache:<input type="text" id="cache" size="2" title="Caching value in ms" value="" onfocus="bIgnoreKey=true" onblur="bIgnoreKey=false" onkeypress="return checkNumber(event);" onChange="setCache(this);" />ms</td-->
  <td class="cellHi">Deinterlace:<select id='deinterlace' onfocus="bIgnoreKey=true" onblur="bIgnoreKey=false" onChange="setDeinterlace(this);">
<option value='disabled'>Disabled</option>
<option value='discard'>Discard</option>
<option value='blend'>Blend</option>
<option value='mean'>Mean</option>
<option value='bob'>Bob</option>
<option value='linear'>Linear</option>
<option value='x'>X</option>
<option value='yadif'>Yadif</option>
<option value='yadif2x'>Yadif2X</option>
</select></td>
  <td class="cellHi">List height:<input type="text" id="iframeHeight" size="2" title="IFrame height" value="" onfocus="bIgnoreKey=true" onblur="bIgnoreKey=false" onkeypress="return checkNumber(event);" onChange="setIFrameHeight(this);" /></td>
  <td class="cellHi">Structured file list<input type="checkbox" id="structuredFileList" onChange="setFileList(this);"><xsl:if test="//@structuredFileList='1'"><xsl:attribute name="checked"/></xsl:if></input></td>
</tr></table>
<table><tr><td class="cellHi"><table>
  <tr><td id="signalTitle">Signal:</td><td id="signalStat">Unavailable</td></tr>
  <tr><td align="center" colspan="2">Update every <input type="text" id="signalStatPeriod" size="3" title="Signal statistic period in ms" value="3000" onfocus="bIgnoreKey=true" onblur="bIgnoreKey=false" onkeypress="return checkNumber(event);" onChange="setSignalStatPeriod(this);" />ms</td></tr>
</table></td></tr></table>
<xsl:if test="//@local != '1'">
<table><tr><td class="cellHi"><table>
  <tr><th>Server path</th><th>Network path</th></tr>
  <xsl:apply-templates select="//directories/directory" mode="list" />
</table></td></tr></table>
</xsl:if>
</div>
<br/>
  <div id='messageDiv' style="border: solid #FFFFFF 1px;">
    <xsl:choose>
      <xsl:when test="//@surf = '1'">
      Click on a channel to start, Right-click to record
      </xsl:when>
      <xsl:otherwise>
      Warning: Surf command not available
      </xsl:otherwise>
    </xsl:choose>
  </div>
  </center>
  <iframe id="frameList" src="/servlet/ScheduleDataRes?action=28" frameborder="0" width="100%" scrolling="auto"/>
  </body>
  </html>

</xsl:template>

<xsl:template match="directories/directory" mode="list">
<tr><td><xsl:value-of select="@name" /></td><td><input type="text" size="20" value="" onfocus="bIgnoreKey=true" onblur="bIgnoreKey=false"><xsl:attribute name="id">networkPath<xsl:value-of select="@name" /></xsl:attribute><xsl:attribute name="onChange">setNetworkPath("<xsl:value-of select="@name" />",value);</xsl:attribute></input></td></tr>
</xsl:template>

<xsl:template match="directories/directory" mode="save">
networkPaths["<xsl:value-of select="@name" />"] = "";
</xsl:template>
</xsl:stylesheet>
