<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>DV Scheduler Surf Channel Order</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
    <link rel="stylesheet" href="/css/colour.css" type="text/css" />
<script src="/javascript/extra.js"></script>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
<script>
var bDataChanged = false;

function setChanged()
{
  bDataChanged = true;
}

function isDataChanged()
{
  if (bDataChanged == true)
  {
    alert('Data has changed, please save it first');
    return true;
  }
  return false;
}

function sortCustom(sort)
{
  if (sort == 0)
    return;

  if (isDataChanged())
    return;

  document.location.href = '/servlet/ChannelDataRes?action=16&amp;sort=' + sort;
}
</script>
  </head>
  <body>
  <center>
  <br/><br/>
  <a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a>
  <br/>
  <br/>
  <a href='/servlet/ChannelDataRes' class="noUnder"> <img border='0' src='/images/back.png' align='absmiddle' width='24' height='24' /> 
Channel Setup</a>
  <br/><br/>
<span class='areaTitle'>Channel Surf Order</span>
<br/>Channels in Channel Surf will be listed in the order set here. Either use default channel ordering, or use custom channel ordering as shown on "Selected Channels".
<form action='/servlet/ChannelDataRes' method='POST' accept-charset="UTF-8" name="settings" onSubmit='listSubmit()'>
<table>
    <tr>
      <td><input type='radio' name='useDefault' value='1' onClick="setChanged()"><xsl:if test="//orders/@use != 'custom'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if></input>Use default channel ordering</td>
    </tr>
    <tr>
      <td><input type='radio' name='useDefault' value='0' onClick="setChanged()"><xsl:if test="//orders/@use = 'custom'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if></input>Use custom channel ordering below</td></tr>
</table>
<table cellspacing="6" cellpadding="6">
<tr><td>
Available Channels<br/>
<select name='chanAll' type='test' id="chanAll" multiple="True" size='16' style="width:200px">
  <xsl:apply-templates select="//orders/channelorder" />
</select>
<br/>
<font size='-1'>(Hold down CTRL to select<br/>multiple items)</font>
</td>
<td align="center">
<button type="button" onclick="listItemsAdd();setChanged();" style="width:100px">-&gt;</button><br/><br/>
<button type="button" onclick="listItemsRemove();setChanged();" style="width:100px">&lt;-</button><br/><br/><br/><br/>
<button type="button" onclick="listItemsTop();setChanged();" style="width:100px">Top</button><br/>
<button type="button" onclick="listItemsPageUp();setChanged();" style="width:100px">Page Up</button><br/>
<button type="button" onclick="listItemsUp();setChanged();" style="width:100px">Up</button><br/><br/>
<button type="button" onclick="listItemsDown();setChanged();" style="width:100px">Down</button><br/>
<button type="button" onclick="listItemsPageDown();setChanged();" style="width:100px">Page Down</button><br/>
<button type="button" onclick="listItemsBottom();setChanged();" style="width:100px">Bottom</button>
</td>
<td>
Selected Channels<br/>
<select name='chanSelected' type='test' id="chanSelected" multiple="True" size='16' style="width:200px">
  <xsl:apply-templates select="//selected/channelorder" />
</select>
<br/>
<font size='-1'>(Hold down CTRL to select<br/>multiple items)</font>
</td>
</tr>
</table>
<table><tr><td>
<img border='0' src='/images/sort.png' align='absmiddle' width='24' height='24' /> Sort according to
<select onchange="sortCustom(this.selectedIndex)">
<option></option>
<option>Channel name, Ascending</option>
<option>Channel name, Descending</option>
<option>Channel number, Ascending</option>
<option>Channel number, Descending</option>
</select>
<br/>
<a href='/servlet/ChannelDataRes?action=18' class='noUnder' onClick='return !isDataChanged()'>
<img border='0' src='/images/Download.png' align='absmiddle' width='24' height='24' /> Add missing channels</a>
<br/>
<a href='/servlet/ChannelDataRes?action=15' class='noUnder' onClick='return !isDataChanged()'>
<img border='0' src='/images/view-refresh.png' align='absmiddle' width='24' height='24' /> Reset to default channel ordering</a>
</td></tr></table>
<input type="submit" name="Submit" value="Submit" /> 
<input name="action" type="hidden" id="action" value="17" />
<input type='hidden' name='chanMatch' id='chanMatch'/>
</form>

<br/>
<span class='areaTitle'>Default Values</span>
<br/>These values will be used when a channel's "Demodulator Data" or "User Data" is blank.
<form action='/servlet/ChannelDataRes' method='POST' accept-charset="UTF-8">
<table>
<input type='hidden' name='action' value='26' />
<tr><td align="right">Demodulator Data:</td><td><textarea id='defaultDemodulatorData' name='defaultDemodulatorData' wrap='off' style="overflow:auto; height:80; width:325;" xml:space="preserve">
<xsl:value-of select="//defaultDemodulatorData"/></textarea></td></tr>
<tr><td align="right">Channel's User Data:</td><td><textarea id='defaultUserData' name='defaultUserData' wrap='off' style="overflow:auto; height:80; width:325;" xml:space="preserve">
<xsl:value-of select="//defaultUserData"/></textarea></td></tr>
</table>
<input type="submit" value="Submit" />
</form>

</center>
</body>
</html>

</xsl:template>

<xsl:template match="orders/channelorder">
<xsl:if test="not(@selected)"><option><xsl:attribute name="value"><xsl:value-of select="@name" /></xsl:attribute><xsl:value-of select="@name" /></option></xsl:if>
</xsl:template>
<xsl:template match="selected/channelorder">
<option><xsl:attribute name="value"><xsl:value-of select="@name" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>
</xsl:stylesheet>
