<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>Task Edit</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>

<script language="JavaScript">
function checkID()
{
  if(document.settings.sessionID.value.length != 6)
  {
    alert("Please enter the security ID at the bottom of the form!");
    return false;
  }
  else
    return true;
}
function setSecurityImage()
{
  var thisDate = new Date();
  var securityImageURL = "/servlet/ImageDataRes?sessionID=1&amp;time=" + thisDate.toGMTString();
  var image = document.getElementById("SecurityImage");
  if(image)
  {
    image.src = securityImageURL;
    setTimeout("setSecurityImage();", 180000);
  }
}
</script>
  </head>
<body onLoad="setSecurityImage();" onpageshow="if (event.persisted) setSecurityImage();">
<center>
<a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a><br/>
<br/>
<a href='/servlet/SystemDataRes?action=08' class="noUnder"><img border='0' src='/images/back.png' align='absmiddle' width='24' height='24'/> 
<span class='areaTitle'>Task List</span></a> 
<form name='settings' method="POST" action="/servlet/SystemDataRes" accept-charset="UTF-8"><xsl:if test="//@checkId='1'"><xsl:attribute name="onSubmit">return checkID();</xsl:attribute></xsl:if>
<input type="hidden" name="action" value="23"/>
<input type="hidden" name="oldName" value="{//@name}"/>

  <table border="0" cellspacing="2" cellpadding="2">
    <tr> 
      <td class="itemheading" colspan="2"><strong>Edit Task : <xsl:value-of select="//@name"/></strong></td>
    </tr>
       
    <tr> 
      <td nowrap="1" valign="center">
      
<table border='0' width="100%">
<tr><td nowrap="1" align="right">Name</td><td width="100%"><input style="width:25%" type="text" name="name" value="{//@name}"/></td></tr>
<tr><td nowrap="1" align="right">Command To Run</td><td width="100%"><input style="width:100%" maxlength="250" type="text" name="command" value="{//command}"/></td></tr>
<tr><td nowrap="1" align="right">Delay</td><td width="100%"><input style="width:30px" type="text" name="delay" max-char="3" value="{//delay}"/> seconds before running task</td></tr>
<tr><td nowrap="1" align="right">When not capturing</td><td width="100%"><input style="" type="checkbox" name="whenNotCapturing" value="true"><xsl:if test="//whenIdle='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size="-1">(task will wait for current schedules to finish before running)</font></td></tr>
<tr><td nowrap="1" align="right">Maximum</td><td width="100%"><input style="width:30px" type="text" name="concurrentTasks" max-char="3" value="{//maxConcurrentTask}"/> concurrent tasks</td></tr>
<tr><td nowrap="1" align="right">Don't run within</td><td width="100%"><input style="width:30px" type="text" name="timeToNextSchedule" max-char="3" value="{//minIdleTime}"/> minutes of a scheduled action</td></tr>
<tr><td nowrap="1" align="right">Allow suspend</td><td width="100%"><input style="" type="checkbox" name="allowSuspend" value="true"><xsl:if test="//allowSuspend='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size="-1">(Allow system to sleep/standby)</font></td></tr>
<tr><td nowrap="1" align="right">Auto-Remove</td><td width="100%"><input style="" type="checkbox" name="autoRemove" value="true"><xsl:if test="//autoRemove='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size="-1">(Remove from active task list when finished)</font></td></tr>
<tr><xsl:if test="//@checkId='0'"><xsl:attribute name="style">visibility:hidden</xsl:attribute></xsl:if><td nowrap="1" align="right">Security ID</td><td width="100%"><input type="text" size="6" maxlength="6" name="sessionID" value=""/> enter the number from the following image <img id='SecurityImage' align='absmiddle' src='/images/secure-blank.png'/></td></tr>
<tr><td></td><td><input value="Update Task" type="submit"/></td></tr>
</table>      
      
      </td>
    </tr>
    
  </table>
  </form>
</center>
<br/><br/>
      <strong>Command To Run</strong><br/>
        The task command line can have keywords that will be replaced when the task is run. Common keywords are shown below. For a full list of keywords please see the file "util\Readme.txt" in the directory where DV Scheduler is installed.<br/><br/>
<table>
<tr><td>$deviceID</td><td>will be substituted with the capture device number that was used for post capture tasks or that is about to be used for Pre-Capture tasks.</td></tr>
<tr><td>$devicename</td><td>will be substituted with the capture device name that was used for post capture tasks or that is about to be used for Pre-Capture tasks.</td></tr>
<tr><td>$deviceuniquename</td><td>will be substituted with the capture device unique name that was used for post capture tasks or that is about to be used for Pre-Capture tasks.</td></tr>
<tr><td>$capturepath</td><td>will be substituted with the capture path of the capture (e.g. "C:\TV").</td></tr>
<tr><td>$filename</td><td>will be substituted with the full path and file name of the capture (e.g. "C:\TV\Recording.ts").</td></tr>
<tr><td>$name</td><td>will be substituted with the full path and name of the capture without the file extension (e.g. "C:\TV\Recording").</td></tr>
<tr><td>$originalname</td><td>if a capture is interrupted and restarted the final filename will have "-n" appended to it. $originalname will give the original name (e.g. $name gives "C:\TV\Recording-2", while $originalname gives "C:\TV\Recording"). This is useful for wildcard matching of all the recording files.</td></tr>
<tr><td>$capType or $capturetype</td><td>will be substituted with the capture type of this capture.</td></tr>
</table><br/>
       <strong>Delay</strong><br/>
        This is the amount of time that a task will delay before executing the command. This is useful 
        for post capture tasks to allow the next schedule, if there is one,  to start capturing before 
        starting a heavy CPU or Disk IO command.<br/><br/>
      <strong>When not capturing</strong><br/>
        This makes the task wait for any current schedules to finish before the command is executed.<br/><br/>
      <strong>Maximum X concurrent tasks</strong><br/>
        The task will not run while there are more then X number of other tasks running, if you set this
        to 1 it means that only one of these tasks will be run at a time. This is useful for high disk I/O
        commands that you only want to run one at a time. Task wait for the other tasks
        to finish before executing.<br/><br/>
      <strong>Don't run within X minutes of a scheduled action</strong><br/>
        Some tasks may interrupt with starting captures or running captures, this option allows 
        you to set how far out the next capture is before the task has to wait for that task to start
        and finish.<br/><br/>
      <strong>Auto-Remove</strong><br/>
        The task will automatically be removed form the active task list when it finishes.
</body>
  </html>
</xsl:template>

<xsl:template match="directories/directory">
<tr><td class='systemkey'><xsl:value-of select="position()"/>. Capture To</td><td class='systemdata'><xsl:value-of select="@name"/></td></tr>
<tr><td class='systemkey'><xsl:value-of select="position()"/>. Free Space</td><td class='systemdata'>
<xsl:choose>
  <xsl:when test="number(@freeSpace) > 0">
<xsl:value-of select="format-number(floor(number(@freeSpace) div (1024*1024)),'###,###')" /> MB
  </xsl:when>
  <xsl:otherwise>
Error Capture Drive May Not Exist
  </xsl:otherwise>
</xsl:choose>
</td></tr>
</xsl:template>

</xsl:stylesheet>
