import java.io.Serializable;
import java.util.Collections;
import java.util.Comparator;
import java.util.Vector;

public class ChannelMapGroup implements Serializable
{
	private static final long serialVersionUID = 1106694434768639143L;

	public String m_channelName;
	public int m_sort;
	public Vector<ChannelMap> m_channelMaps = new Vector<ChannelMap>();

	public ChannelMap getChannelMap(String epgChannelId)
	{
		for (int i=0; i<m_channelMaps.size(); i++)
		{
			ChannelMap map = m_channelMaps.get(i);

			if (map.m_epgChannelId.equals(epgChannelId))
				return map;
		}
		return null;
	}

	public boolean isExistEpgChannelId(String epgChannelId)
	{
		for (int i=0; i<m_channelMaps.size(); i++)
		{
			ChannelMap map = m_channelMaps.get(i);

			if (map.m_epgChannelId.equals(epgChannelId))
				return true;
		}
		return false;
	}

	public boolean isExistEpgChannelIds(String epgChannelId, String epgChannelId2)
	{
		int priority = -1;
		int priority2 = -2;
		for (int i=0; i<m_channelMaps.size(); i++)
		{
			ChannelMap map = m_channelMaps.get(i);

			if (map.m_epgChannelId.equals(epgChannelId))
				priority = map.m_priority;
			else if (map.m_epgChannelId.equals(epgChannelId2))
				priority2 = map.m_priority;

			if (priority == priority2)
				return true;
		}
		return false;
	}

	public boolean isExistChannelSetting(String setting)
	{
		for (int i=0; i<m_channelMaps.size(); i++)
		{
			ChannelMap map = m_channelMaps.get(i);

			if (map.m_setting.equals(setting))
				return true;
		}
		return false;
	}

	public void sortChannelMaps()
	{
		Comparator<ChannelMap> comparator = new Comparator<ChannelMap>() {
			public int compare(ChannelMap g1, ChannelMap g2) {
				if (g1.m_priority == g2.m_priority)
					return g1.m_epgChannelId.compareTo(g2.m_epgChannelId);
				else
					return g1.m_priority - g2.m_priority;
			}
		};
		Collections.sort(m_channelMaps, comparator);
	}
}