/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.io.*;

class FileTypeFilter implements FileFilter
{
	private String fileMasks = ".log,.mpg,.mpeg,.bin,.mpv,.mpa,.ts,.tp,.dvr-ms,.rec,.pva,.avi,.mp4,.mkv,.xml,.srt";
	private int nFileOrDirectory = 2;

	// fileOrDirectory, value of
	// 0	files only
	// 1	directories only
	// 2	files and directories
	public FileTypeFilter(String filter, int fileOrDirectory)
	{
		fileMasks = filter;
		nFileOrDirectory = fileOrDirectory;
	}

	public boolean accept(File pathname)
	{
		if(pathname == null)
			return false;

		if (pathname.isDirectory())
		{
			if ( (nFileOrDirectory == 1) || (nFileOrDirectory == 2) )
				return true;
			else
				return false;
		}
		else if (nFileOrDirectory == 1)
			return false;
		
		if (fileMasks.isEmpty())
			return true;

		String[] acceptable = fileMasks.split(",");

		for(int x = 0; x < acceptable.length; x++)
		{
			if(pathname.getName().toLowerCase().endsWith(acceptable[x].toLowerCase()))
			{
				return true;
			}
		}

		return false;
	}    
}