import java.io.UnsupportedEncodingException;
import java.net.*;
import java.util.Vector;

class Formatter
{
	public static final int TYPE_UNFORMATTED = 0;
	public static final int TYPE_ASCII = 1;
	public static final int TYPE_ASCII2 = 2;
	public static final int TYPE_URL_UTF8 = 3;
	public static final int TYPE_ASCII23 = 4;	// For VLC.

	// Default may be changed later.
	public static String format(String text)
	{
		return formatBasic(text);
	}

	// Default may be changed later.
	public static boolean isOk(String text)
	{
		return isBasic(text);
	}

	public static String formatAscii(String text)
	{
		StringBuffer finalName = new StringBuffer(256);
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if (charAt >= ' ' && charAt <= 126)
				finalName.append(charAt);
			else
				finalName.append('-');
		}

		return finalName.toString();
	}

	public static String formatAscii2(String text)
	{
		StringBuffer finalName = new StringBuffer(256);
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if (charAt >= ' ' && charAt != 127 && charAt <= 255)
				finalName.append(charAt);
			else
				finalName.append('-');
		}

		return finalName.toString();
	}

	// For VLC.
	public static String formatAscii23(String text)
	{
		StringBuffer finalName = new StringBuffer(256);
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if (charAt >= ' ' && charAt != '\''  && charAt != ',' && charAt != '{' && charAt != '}' && charAt != 127 && charAt <= 255)
				finalName.append(charAt);
			else
				finalName.append('-');
		}

		return finalName.toString();
	}

	public static boolean isAscii2(String text)
	{
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if ( !(charAt >= ' ' && charAt != 127 && charAt <= 255) )
				return false;
		}

		return true;
	}

	public static String formatBasic(String text)
	{
		StringBuffer finalName = new StringBuffer(256);
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if ((charAt >= 'a' && charAt <= 'z') || (charAt >= 'A' && charAt <= 'Z') 
					|| (charAt >= '0' && charAt <= '9') 
					|| charAt == '.' || charAt == '-' || charAt == '_' || charAt == ' ' || charAt == ',')
				finalName.append(charAt);
			else
				finalName.append('-');
		}

		return finalName.toString();
	}

	public static boolean isBasic(String text)
	{
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if (!((charAt >= 'a' && charAt <= 'z') || (charAt >= 'A' && charAt <= 'Z') 
					|| (charAt >= '0' && charAt <= '9') 
					|| charAt == '.' || charAt == '-' || charAt == '_' || charAt == ' ' || charAt == ','))
			{
				return false;
			}
		}

		return true;
	}

	public static String decodeURL_UTF8E(String text) throws Exception
	{
		return URLDecoder.decode(text.replace("+", "%2B"), "UTF-8");
	}
	
	public static String encodeURL_UTF8(String text)
	{
		try
		{
			text = URLEncoder.encode(text, "UTF-8");
		}
		catch (UnsupportedEncodingException e)
		{
			e.printStackTrace();
		}
		return text.replace("+", "%20");
		// Also .replace("\\%21", "!").replace("\\%27", "'").replace("\\%28", "(").replace("\\%29", ")").replace("\\%7E", "~");
	}

	public static String encodeURL_UTF8E(String text) throws Exception
	{
		return URLEncoder.encode(text, "UTF-8").replace("+", "%20");
	}

	// encoding should only be UTF-8.
	public static String encodeURL(String text, String encoding) throws Exception
	{
		return URLEncoder.encode(text, encoding).replace("+", "%20");
	}

	/*
	public static String encodeURL_UTF82(String text)
	{
		try
		{
			text = URLEncoder.encode(text, "UTF-8");
		}
		catch (UnsupportedEncodingException e)
		{
			e.printStackTrace();
		}
		return text;
	}

	public static String encodeURL_UTF82E(String text) throws Exception
	{
		return URLEncoder.encode(text, "UTF-8");
	}

	public static String encodeURL_UTF83E(String text) throws Exception
	{
		return URLEncoder.encode(text, "UTF-8").replace("+", " ");
	}
	 */

	public static String formatCommand(String text)
	{
		StringBuffer finalName = new StringBuffer(256);
		for (int x = 0; x < text.length(); x++)
		{
			char charAt = text.charAt(x);

			if ( (charAt == 13) || (charAt == 10) || 
					(charAt >= ' ' && charAt != 127 && charAt <= 255) )
				finalName.append(charAt);
			else
				finalName.append('-');
		}

		return finalName.toString();
	}

	public static String formatFilename(String text)
	{
		text = text.trim();

		char[] notAllowed = {'\\','/',':','*','?','\"','<','>','|'};
		char[] replaceWith = {'-', '-','-','#','#','\'','-','-','!'};

		for(int x = 0; x < notAllowed.length; x++)
		{
			text = text.replace(notAllowed[x], replaceWith[x]);
		}

		return text;
	}

	public static String formatDirectory(String text)
	{
		text = text.trim();

		char[] notAllowed = {':','*','?','\"','<','>','|'};
		char[] replaceWith = {'-','#','#','\'','-','-','!'};

		for(int x = 0; x < notAllowed.length; x++)
		{
			text = text.replace(notAllowed[x], replaceWith[x]);
		}

		return text;
	}

	public static String formatDriveDirectory(String text)
	{
		text = text.trim();

		char[] notAllowed = {'*','?','\"','<','>','|'};
		char[] replaceWith = {'#','#','\'','-','-','!'};

		for(int x = 0; x < notAllowed.length; x++)
		{
			text = text.replace(notAllowed[x], replaceWith[x]);
		}

		return text;
	}

	public static String[] parseCommand(String command)
	{
		if (command == null)
			return null;
		String command2 = command.trim();
		if (command2.length() < 2)
			return null;
		char[] src = command2.toCharArray();
		int length = src.length;

		Vector<String> dest = new Vector<String>();
		String tmp = "";
		int i = 0;
		boolean bText = false;
		while (i < length)
		{
			if (src[i] == '\"')
			{
				if (bText)
				{
					// Double quote.
					if ( ((i+1) < length) && (src[i+1] == '\"') )
					{
						tmp += '\"';
						i += 2;
					}
					// End of quote.
					else
					{
						bText = false;
						i++;
					}
				}
				// Start of quote.
				else
				{
					bText = true;
					i++;
				}
			}
			else if (bText)
			{
				tmp += src[i++];
			}
			else if (src[i] == ' ')
			{
				// java (at least java 7 update 21) seems to exclude empty arg, so add space instead.
				if (src[i-1] != ' ')
				{
					if (tmp.isEmpty())
						dest.add(" ");
					else
					{
						dest.add(tmp);
						tmp = "";
					}
				}
				i++;
			}
			else
			{
				tmp += src[i++];
			}
		}

		// java (at least java 7 update 21) seems to exclude empty arg, so add space instead.
		dest.add(tmp.isEmpty() ? " " : tmp);

		tmp = "parseCommand: ";
		for (int j=0; j<dest.size(); j++)
		{
			tmp += "[" + j + "]" + dest.get(j);
		}
		DVScheduler.log(tmp);

		return dest.toArray(new String[0]);
	}

	public static String encode(String text, int encoding)
	{
		switch (encoding)
		{
		case TYPE_UNFORMATTED:
			return text;

		case TYPE_URL_UTF8:
			return Formatter.encodeURL_UTF8(text);

		case TYPE_ASCII2:
			return Formatter.formatAscii2(text);

		case TYPE_ASCII23:
			return Formatter.formatAscii23(text);

		case TYPE_ASCII: default:
			return Formatter.formatAscii(text);
		}
	}

	public static String decoded(String text, int encoding)
	{
		switch (encoding)
		{
		case TYPE_UNFORMATTED: case TYPE_URL_UTF8:
			return text;

		case TYPE_ASCII2:
			return Formatter.formatAscii2(text);

		case TYPE_ASCII23:
			return Formatter.formatAscii23(text);

		case TYPE_ASCII: default:
			return Formatter.formatAscii(text);
		}		
	}

	public static int getEncoding(String text, int defaultEncoding)
	{
		String enc = text.trim();

		if (enc.equalsIgnoreCase("URL_UTF8"))
			return TYPE_URL_UTF8;
		else if (enc.equalsIgnoreCase("ASCII"))
			return TYPE_ASCII;
		else if (enc.equalsIgnoreCase("ASCII2"))
			return TYPE_ASCII2;
		else if (enc.equalsIgnoreCase("ASCII23"))
			return TYPE_ASCII23;

		return defaultEncoding;
	}
}