import java.io.File;

/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

class SchGuideLoaderTread implements Runnable
{
	private DataStore m_store = null;
	private boolean m_bInternal = false;
	private File m_file;

	public SchGuideLoaderTread(boolean bInternal, File file)
	{
		try
		{
			m_store = DataStore.getInstance();
			m_bInternal = bInternal;
			m_file = file;
		}
		catch(Exception e)
		{
			DVScheduler.log("ERROR: Exception in Scheduled Guide Data Loader");
			e.printStackTrace();
		}
	}

	public void run()
	{
		DVScheduler.log("SchGuideLoaderTread started.");
		try
		{
			GuideStore guide = GuideStore.getInstance();
			if (m_bInternal)
			{
				guide.loadInternalXmltv(m_file);
			}
			else
			{
				StringBuffer buff = new StringBuffer();
				guide.loadXmltv(buff, 0, 1);

				//
				// Now send email if required
				//
				if ( m_store.getProperty("email.epgLoaded", "No").equals("Yes") )
				{
					EmailSender sender = new EmailSender();
					sender.setSubject("DV Scheduler EPG Reload Results");
					sender.setBody("EPG Reload Result:\n\n" + buff.toString());

					try
					{
						Thread mailThread = new Thread(Thread.currentThread().getThreadGroup(), sender, sender.getClass().getName());
						mailThread.start();
					}
					catch(Exception e)
					{
						e.printStackTrace();
					}
				}
			}
		}
		catch(Exception e)
		{
			DVScheduler.log("ERROR: Exception in Scheduled Guide Data Loader");
			e.printStackTrace();
		}
	}
}
