/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.io.*;
import java.util.*;
import java.text.*;
import java.net.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

class ScheduleDataRes extends HTTPResponse {
	private DateFormat dtf = DateFormat.getDateTimeInstance(DateFormat.FULL,
			DateFormat.FULL);

	public ScheduleDataRes(Map<String, String> headers, HTTPurl urlData, OutputStream outStream) throws Exception {
		super(headers, urlData, outStream);
	}

	public void getResponse()
			throws Exception {
		String action = m_urlData.getParameter("action");
		if ("01".equals(action)) {
			m_outStream.write(showCalendar());
			return;
		} else if ("02".equals(action)) {
			m_outStream.write(showAddForm(false));
			return;
		} else if ("03".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(addUpdateItem());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}

			return;
		} else if ("04".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(deleteSchedule());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("05".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(addTime());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("06".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(skipToNext());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("07".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(showItemInfo());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("08".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(resetItemLog());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("09".equals(action)) {
			m_outStream.write(stopRunningTask(true));
			return;
		} else if ("10".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(addTestSchedules());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("12".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(addScheduleFromGuideItem(true));
			} finally {
				ThreadLock.getInstance().releaseLock();
			}

			return;
		} else if ("13".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(deleteSchedules());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}

			return;
		} else if ("14".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(updateDeleteAfter());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}

			return;
		} else if ("15".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(changeDuration());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("16".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(addScheduleFromGuideItem(false));
			} finally {
				ThreadLock.getInstance().releaseLock();
			}

			return;
		} else if ("17".equals(action)) {
			addPreview(true);
			return;
		} else if ("18".equals(action)) {
			m_outStream.write(showAddForm(true));
			return;
		} else if ("19".equals(action)) {
			m_outStream.write(addSurf());
			return;
		} else if ("20".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(changeRunningTask());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("21".equals(action)) {
			m_outStream.write(stopRunningTask(false));
			return;
		} else if ("22".equals(action)) {
			m_outStream.write(showSurfControl("surf.xsl"));
			return;
		} else if ("23".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(keepAliveRunningTask());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("24".equals(action)) {
			m_outStream.write(addSchedule(false));
			return;
		} else if ("25".equals(action)) {
			m_outStream.write(addSchedule(true));
			return;
		} else if ("26".equals(action)) {
			addPreview(false);
			return;
		} else if ("27".equals(action)) {
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(getSignalStatistic());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			return;
		} else if ("28".equals(action)) {
			m_outStream.write(showSurfControl("surfList.xsl"));
			return;
		} else if ("29".equals(action)) {
			m_outStream.write(serveFile());
			return;
		} else if ("30".equals(action)) {
			m_outStream.write(logRequest());
			return;
		} else if ("31".equals(action)) {
			m_outStream.write(addPlay(false));
			return;
		} else if ("ScheduleAddPlayPreview".equals(action)) {
			m_outStream.write(addPlay(true));
			return;
		} else if ("ScheduleAdd".equals(action)) {
			addSchedule();
			return;
		} else if ("ScheduleStopIdleDevice".equals(action)) {
			m_outStream.write(stopDevice());
			return;
		} else {
			m_outStream.write(getScheduleTable());
			/*
			ThreadLock.getInstance().getLock();
			try {
				m_outStream.write(getScheduleTable());
			} finally {
				ThreadLock.getInstance().releaseLock();
			}
			 */
			return;
		}
	}

	public void getResponse2() throws Exception
	{
		String action = m_urlData.getParameter("parameter0");
		if ("stream".equals(action))
			m_outStream.write(addPlay(m_urlData.getParameter("parameter1"), false));
		else if ("stream2".equals(action))
			m_outStream.write(addPlay(m_urlData.getParameter("parameter1"), true));
		else if ("playlist".equals(action))
			addPreview(true, m_urlData.getParameter("parameter1"));
		else
			m_outStream.write("Error occurred".getBytes("UTF-8"));
	}

	private byte[] updateDeleteAfter() throws Exception {
		int deleteAfter = m_urlData.getParameterInt("deleteafter", 180);

		m_store.setProperty("sch.autodel", new Integer(deleteAfter).toString());

		String redirect = "HTTP/1.0 302 Moved Temporarily\n";
		redirect += "Location: /servlet/ScheduleDataRes\n\n";
		return redirect.getBytes("UTF-8");
	}

	private byte[] deleteSchedules() throws Exception {
		String older = m_urlData.getParameter("older");
		String status = m_urlData.getParameter("status");
		DVScheduler.log("older=" + older + "status=" + status);

		int minutesOffset = 0;
		int statusInt = -1;
		try {
			minutesOffset = Integer.parseInt(older);
			statusInt = Integer.parseInt(status);
		} catch (Exception e) {
		}

		long timeLimit = (new Date().getTime()) - (minutesOffset * 60 * 1000);

		DVScheduler.log("Time offset = " + minutesOffset + " limit = "
				+ timeLimit + " status=" + statusInt);

		HashMap<String, ScheduleItem> schedules = m_store.getScheduleList();
		String[] keys = (String[]) schedules.keySet().toArray(new String[0]);
		boolean deletedItem = false;

		for (int x = 0; x < keys.length; x++) {
			ScheduleItem item = (ScheduleItem) schedules.get(keys[x]);
			DVScheduler.log("Schedule time = " + item.getStart().getTime()
					+ " status = " + item.getState());

			if ((item.getStart().getTime() < timeLimit || minutesOffset == -1)
					&& (item.getState() == statusInt || statusInt == -1)) {
				if (item.getState() == ScheduleItem.WAITING
						|| item.getState() == ScheduleItem.FINISHED
						|| item.getState() == ScheduleItem.SKIPPED
						|| item.getState() == ScheduleItem.ERROR) {
					schedules.remove(item.toString());
					deletedItem = true;
				}
			}
		}

		if (deletedItem)
			m_store.saveSchedules(null);

		String redirect = "HTTP/1.0 302 Moved Temporarily\n";
		redirect += "Location: /servlet/ScheduleDataRes\n\n";
		return redirect.getBytes("UTF-8");
	}

	private byte[] addTestSchedules() throws Exception {
		/*
		 * /servlet/ScheduleDataRes?action=10&type=1&number=20&duration=5&gap=10
		 */
		StringBuffer out = new StringBuffer(4096);
		String type = m_urlData.getParameter("type");
		int number = m_urlData.getParameterInt("number", 1);
		int duration = m_urlData.getParameterInt("duration", 1);
		int gap = m_urlData.getParameterInt("gap", 1);

		Calendar start = Calendar.getInstance();
		start.set(Calendar.SECOND, 0);
		start.set(Calendar.MILLISECOND, 0);
		start.add(Calendar.MINUTE, 1);

		HashMap<String, Channel> channels = m_store.getChannels();
		String[] keys = (String[]) channels.keySet().toArray(new String[0]);

		for (int y = 0; y < number; y++) {
			for (int x = 0; x < keys.length; x++) {
				start.add(Calendar.MINUTE, duration + gap);
				ScheduleItem item = new ScheduleItem(m_store.m_rand.nextLong());

				item.setCapType(type);

				item.setType(ScheduleItem.ONCE);

				// Set the initial status
				item.setState(ScheduleItem.WAITING);
				item.setStatus("Waiting");

				// Set the start/stop and duration
				item.setStart(start);
				item.setDuration(duration);

				// Set the channel to capture
				item.setChannel(keys[x]);

				// Set autoDel
				item.setAutoDeletable(false);

				// Set Post task
				item.setPostTask("");

				// Set filename pattern
				String[] namePatterns = m_store.getNamePatterns();
				item.setFilePattern(namePatterns[0]);

				// Log the add action
				item.log("New TEST Schedule added/edited");

				// Store the new Schedule Item
				m_store.addScheduleItemAndSave(item);
			}
		}

		out.append("HTTP/1.0 302 Moved Temporarily\n");
		out.append("Location: " + "/servlet/" + m_urlData.getServletClass()
				+ "\n\n");

		return out.toString().getBytes("UTF-8");
	}

	private byte[] stopRunningTask(boolean bHTML) throws Exception {
		String deleteFile = m_urlData.getParameter("delfile");
		boolean bDeleteFile = (deleteFile != null) && (deleteFile.equals("1")) ? true : false;

		String id = m_urlData.getParameter("id");

		ScheduleItem si = null;
		boolean bRunning = true;

		ThreadLock.getInstance().getLock();
		try {
			CaptureTask task = m_store.m_captureTasks.get(id);
			if ( (task != null) && task.isLiveToNormal() )
			{
				ScheduleItem item = task.getScheduleItem();
				task.setLiveToNormal(false);
				item.setName("Surf Recording");
				item.setType2(0);
				item.setAutoDeletable(false);
				int duration = 60;
				try
				{
					duration = Integer.parseInt(m_store.getProperty("Capture.defaultDuration", "60"));
				}
				catch (Exception e) {}
				item.setDuration(duration + item.getDuration());
				item.log("Changed to normal recording");
				item.setRunningStatus(new Date());
				m_store.saveSchedules(item);

				if (bHTML)
				{
					return getRedirUrlRedir(null).getBytes("UTF-8");
				}
				else
					return addLength("DVSchedulerSurf|301").getBytes("UTF-8");
			}

			si = m_store.getScheduleItem(id);
			Calendar now = Calendar.getInstance();
			now.setTime(new Date());

			if (si != null)
			{
				if (si.getState() == ScheduleItem.RUNNING)
				{
					si.abort();
					si.setStatus("Aborting");
					si.setState(bDeleteFile ? ScheduleItem.ABORTED_DELETEFILES : ScheduleItem.ABORTED);
					si.log("Item marked for abortion");
				}
				else
					bRunning = false;
			}
		} finally {
			ThreadLock.getInstance().releaseLock();
		}

		// wait for the item to be stopped before returning
		if ( (si != null) && bRunning )
		{
			m_store.setToDoWake();
			int counts = 100;
			while ( (si.getState() == ScheduleItem.ABORTED || (si.getState() == ScheduleItem.ABORTED_DELETEFILES)) && counts > 0 ) {
				counts--;
				si.waitResponse();
				//Thread.sleep(100);
			}
		}

		if (bHTML)
		{
			return getRedirUrlRedir(null).getBytes("UTF-8");
		}
		else if (si == null)
			return addLength("DVSchedulerSurf|302").getBytes("UTF-8");
		else if (!bRunning)
			return addLength("DVSchedulerSurf|304").getBytes("UTF-8");
		else if (si.getState() == ScheduleItem.ABORTED || si.getState() == ScheduleItem.ABORTED_DELETEFILES)
			return addLength("DVSchedulerSurf|303").getBytes("UTF-8");
		else
			return addLength("DVSchedulerSurf|301").getBytes("UTF-8");
	}

	private byte[] resetItemLog() throws Exception {
		StringBuffer out = new StringBuffer(4096);
		String id = m_urlData.getParameter("id");

		ScheduleItem si = m_store.getScheduleItem(id);
		if (si != null) {
			si.resetLog();
			m_store.saveSchedules(si);
		}

		out.append("HTTP/1.0 302 Moved Temporarily\n");
		out.append("Location: /servlet/" + m_urlData.getServletClass()
				+ "?action=07&id=" + id + "\n\n");

		return out.toString().getBytes("UTF-8");
	}

	private String getScheduleInfo(ScheduleItem item, HTTPurl m_urlData) {
		StringBuffer data = new StringBuffer(2048);

		data.append("Current State : " + HTMLEncoder.encode(item.getStatus()) + " ("
				+ item.getState() + ")<p>");

		String type = item.getTypeStr();
		data.append("This Scheduled Item is set to trigger " + type + " <p>");

		data.append("<table>");
		data.append("<tr><td>Start</td><td>" + dtf.format(item.getStart())
				+ "</td></tr>");
		data.append("<tr><td>Stop</td><td>" + dtf.format(item.getStop())
				+ "</td></tr>");
		data.append("<tr><td>Duration</td><td>" + item.getDuration()
				+ "</td></tr>");
		data.append("<tr><td>Channel</td><td>" + HTMLEncoder.encode(item.getChannel())
				+ "</td></tr>");
		data.append("</table><p>");

		data.append("Time to next trigger : " + getTimeLeft(item.getStart())
				+ "<p>");
		data.append("Name Pattern : " + HTMLEncoder.encode(item.getFilePattern()) + "<br>");

		CaptureFile cap = item.getFileName();
		//data.append("File : " + cap.getFullPath() + "<br>");
		data.append("File : " + HTMLEncoder.encode(cap.getUnformattedName()) + "<br>");
		data.append("<p>");

		if (item.getCreatedFrom() != null) {
			data.append("Created From :<pre>");

			data.append("Title      : " + HTMLEncoder.encode(item.getCreatedFrom().getName())
					+ "\n");
			data.append("Sub Title  : " + HTMLEncoder.encode(item.getCreatedFrom().getSubName())
					+ "\n");
			data.append("Start      : "
					+ item.getCreatedFrom().getStart().toString() + "\n");
			data.append("Duration   : " + item.getCreatedFrom().getDuration()
					+ "\n");

			data.append("</pre><p>");
		}

		data.append("Capture Type : " + HTMLEncoder.encode(item.getCapType()) + "<p>");

		data.append("Is Auto Deletable : " + item.isAutoDeletable());
		if (item.isAutoDeletable())
			data.append("<br>Keep for : " + item.getKeepFor() + " day(s) before auto deleting.<p>");
		else
			data.append("<p>");

		data.append("Post Capture Task : " + HTMLEncoder.encode(item.getPostTask()) + "<p>");

		/*
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm");
		data.append("Child Count : " + item.getChildren().size() + "<p>");
		ScheduleItem[] childs = (ScheduleItem[]) item.getChildren().toArray(
				new ScheduleItem[0]);
		Arrays.sort(childs);
		for (int x = 0; x < childs.length; x++) {
			ScheduleItem child = childs[x];
			data.append("Child " + x + " : " + sdf.format(child.getStart())
					+ " (" + child.getDuration() + ") " + child.getName());
			data.append("<br>");
		}
		 */

		String log = item.getLog();
		data.append("<pre class='log'>Summary Log (for more detailed logs go to \"log\" directory of where DV Scheduler is installed):\n" + HTMLEncoder.encode(log) + "</pre>");

		if (log.length() > 1)
			data.append("<a href='/servlet/" + m_urlData.getServletClass()
					+ "?action=08&id=" + item + "'>Reset Log</a>");

		return data.toString();
	}

	private String getTimeLeft(Date start) {
		Date now = new Date();
		long timeLeft = start.getTime() - now.getTime();

		long days = timeLeft / (1000 * 60 * 60 * 24);
		long hours = (timeLeft - (days * 1000 * 60 * 60 * 24))
				/ (1000 * 60 * 60);
		long min = (timeLeft - (days * 1000 * 60 * 60 * 24) - (hours * 1000 * 60 * 60))
				/ (1000 * 60);
		long seconds = (timeLeft - (days * 1000 * 60 * 60 * 24)
				- (hours * 1000 * 60 * 60) - (min * 1000 * 60)) / 1000;

		return days + ":days " + hours + ":hours " + min + ":min " + seconds
				+ ":sec";
	}

	private byte[] showItemInfo() throws Exception
	{
		ScheduleItem si = m_store.getScheduleItem(m_urlData.getParameter("id"));

		if (si != null) {
			PageTemplate template = new PageTemplate(m_headers, m_urlData, "info.html");

			template.replace("$info", getScheduleInfo(si, m_urlData));
			return template.getPageBytes();
		} else {
			return getRedirUrlRedir(null).getBytes("UTF-8");
		}
	}

	private byte[] skipToNext() throws Exception {
		String id = m_urlData.getParameter("id");
		ScheduleItem item = m_store.getScheduleItem(m_urlData.getParameter("id"));

		// Only allow update to waiting schedules
		if (id != null && id.length() > 0 && item != null
				&& item.getState() == ScheduleItem.WAITING) {
			item.skipToNext();
			m_store.saveSchedules(item);
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addTime() throws Exception {
		String id = m_urlData.getParameter("id");

		ScheduleItem item = m_store.getScheduleItem(id);

		if (item != null) {
			item.setUserModified();

			Calendar cal = Calendar.getInstance();
			cal.setTime(item.getStart());

			// Add time buffer
			int startBuff = 0;
			int endBuff = 0;

			try {
				startBuff = Integer.parseInt(m_store.getProperty(
						"Schedule.buffer.start", "0"));
				endBuff = Integer.parseInt(m_store.getProperty(
						"Schedule.buffer.end", "0"));
			} catch (Exception e) {
			}

			// if the item is running then only add on to the duration
			if (item.getState() != ScheduleItem.RUNNING) {
				//DVScheduler.log("Not RUNNING");
				cal.add(Calendar.MINUTE, (startBuff * -1));
				item.setDuration(item.getDuration() + startBuff + endBuff);
				item.setStart(cal);
				item.setTrackEpg(false);
			} else {
				//DVScheduler.log("RUNNING");
				item.setDuration(item.getDuration() + endBuff);
				item.setTrackEpg(false);
				item.setRunningStatus(new Date());
			}

			m_store.saveSchedules(item);
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");

	}

	private byte[] changeDuration() throws Exception {
		String id = m_urlData.getParameter("id");

		ScheduleItem item = m_store.getScheduleItem(id);

		if (item != null) {
			item.setUserModified();

			int duration = -1;
			try {
				String dur = m_urlData.getParameter("duration");
				if (dur == null)
				{
					Calendar cal = Calendar.getInstance();
					cal.setTime(item.getStart());

					duration = Integer.parseInt(m_urlData.getParameter("stopHour")) * 60 + Integer.parseInt(m_urlData.getParameter("stopMinute")) - cal.get(Calendar.HOUR_OF_DAY) * 60 - cal.get(Calendar.MINUTE);

					if (duration < 0)
						duration += 60 * 24;
				}
				else
					duration = Integer.parseInt(dur);
			} catch (Exception e) {
			}

			if (duration > 0) {
				item.setDuration(duration);
				item.setTrackEpg(false);
				item.setRunningStatus(new Date());
				m_store.saveSchedules(item);
			}
			else if (item.getState() == ScheduleItem.RUNNING)
			{
				int endBuff = m_urlData.getParameterInt("endbuff", 99999);

				duration = item.getDuration() + endBuff;
				if (duration < 1)
					duration = 1;

				if ( (endBuff != 99999) && (duration > 0) )
				{
					item.setDuration(duration);
					item.setTrackEpg(false);
					item.setRunningStatus(new Date());
					m_store.saveSchedules(item);
				}
			}
			else
			{
				int startBuff = m_urlData.getParameterInt("startbuff", 99999);
				int endBuff = m_urlData.getParameterInt("endbuff", 99999);

				duration = item.getDuration() - startBuff + endBuff;
				if (duration < 1)
				{
					if (startBuff == 0)
						duration = 1;
					else if (endBuff == 0)
					{
						startBuff = item.getDuration() - 1;
						duration = 1;
					}
				}

				if ( (startBuff != 99999) && (endBuff != 99999) && (duration > 0) )
				{
					Calendar cal = Calendar.getInstance();
					cal.setTime(item.getStart());
					cal.add(Calendar.MINUTE, startBuff);
					item.setDuration(duration);
					item.setStart(cal);
					item.setTrackEpg(false);
					m_store.saveSchedules(item);
				}
			}

		}
		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] deleteSchedule() throws Exception {
		String id = m_urlData.getParameter("id");

		ScheduleItem item = m_store.getScheduleItem(id);

		if (item != null
				&& (item.getState() == ScheduleItem.WAITING
				|| item.getState() == ScheduleItem.FINISHED
				|| item.getState() == ScheduleItem.SKIPPED 
				|| item.getState() == ScheduleItem.ERROR))
		{

			m_store.removeScheduleItem(id, true);
			m_store.saveSchedules(item);
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addScheduleFromGuideItem(boolean bRefresh)
			throws Exception {
		String channel = m_urlData.getParameter("channel");
		String id = m_urlData.getParameter("id");

		GuideStore guideStore = GuideStore.getInstance();

		String epgChan = guideStore.getEpgChannelIdFromMap(channel);
		GuideItem guideItem = guideStore.getProgram(epgChan, id);

		if (epgChan == null || epgChan.length() == 0)
			throw new Exception("WS Channel Not Found!");

		//Channel ch = store.getChannel(channel);

		String captype = m_urlData.getParameter("captype");
		if ((captype == null) || captype.isEmpty())
			captype = "Capture.deftype";

		ScheduleItem schItem = new ScheduleItem(guideItem, channel, captype,
				m_store.m_rand.nextLong(), false);

		String task = m_store.getProperty("Tasks.DefTask", "");
		schItem.setPostTask(task);

		// Add time buffer
		int startBuff = 0;
		int endBuff = 0;
		int epgBuff = 0;
		try {
			startBuff = Integer.parseInt(m_store.getProperty(
					"Schedule.buffer.start", "0"));
			endBuff = Integer.parseInt(m_store.getProperty("Schedule.buffer.end",
					"0"));
			epgBuff = Integer.parseInt(m_store.getProperty("Schedule.buffer.EPG",
					"0"));
		} catch (Exception e) {
		}

		String[] patterns = m_store.getNamePatterns();
		schItem.setFilePattern(patterns[0]);

		String keepFor = m_store.getProperty("AutoDel.KeepFor", "30");
		int keepInt = 30;
		try {
			keepInt = Integer.parseInt(keepFor);
		} catch (Exception e) {
		}
		schItem.setKeepFor(keepInt);
		schItem.setAutoDeletable(m_store.isAutoDelByDefault());

		schItem.setCapType(captype);

		// build the Calendar object and set the start time
		Calendar cal = Calendar.getInstance();
		cal.setTime(schItem.getStart());

		cal.add(Calendar.MINUTE, (startBuff * -1));
		schItem.setDuration(guideItem.getDuration() + guideItem.getDuration()
				* epgBuff / 60 + startBuff + endBuff);
		schItem.setStart(cal);

		schItem.setType(ScheduleItem.ONCE);

		schItem.setTrackEpg(m_store.getProperty("Schedule.trackEpg", "Yes").equals("Yes"));

		// Log the add action
		schItem.log("New Schedule from EPG added/edited");

		boolean isAlreadyInList = guideStore.isAlreadyInList(schItem);

		if (!isAlreadyInList)
		{
			m_store.addScheduleItemAndSave(schItem);
		}

		if (bRefresh) {
			return getRedirUrlRedir(null).getBytes("UTF-8");
		} else {
			if (isAlreadyInList) {
				//String str = "ERROR:Already in list";
				String str = "EPGSchedule|ERROR:Already in list";
				return addLength(str).getBytes("UTF-8");
			}

			int date = m_urlData.getParameterInt("date", -1);
			int month = m_urlData.getParameterInt("month", -1);
			int year = m_urlData.getParameterInt("year", -1);
			Calendar start = Calendar.getInstance();
			if ( (date < 0) || (month < 0) || (year < 0) )
			{
				start.setTime(guideItem.getStart());
				if (start.get(Calendar.HOUR_OF_DAY) < 6)
					start.add(Calendar.DATE, -1);
			}
			else
			{
				start.set(year, month, date);
			}

			start.set(Calendar.HOUR_OF_DAY, 6);
			start.set(Calendar.MINUTE, 0);
			start.set(Calendar.SECOND, 0);
			start.set(Calendar.MILLISECOND, 0);

			Calendar start2 = Calendar.getInstance();
			start2.setTime(guideItem.getStart());
			if (start2.get(Calendar.HOUR_OF_DAY) < 6)
				start2.add(Calendar.DATE, -1);

			start2.set(Calendar.HOUR_OF_DAY, 6);
			start2.set(Calendar.MINUTE, 0);
			start2.set(Calendar.SECOND, 0);
			start2.set(Calendar.MILLISECOND, 0);
			
			int daysPast = (int) ((start2.getTimeInMillis() - start.getTimeInMillis()) / 24 / 3600000);

			Calendar startTime = Calendar.getInstance();
			startTime.setTime(schItem.getStart());
			long pastStart = startTime.getTime().getTime() - start2.getTime().getTime();

			String fromTop = new Long(pastStart / (1000 * 60)).toString();
			String cellHeight = new Integer(schItem.getDuration()).toString();

			int page = m_urlData.getParameterInt("page", 1) - 1;	// To zero-based index.
			int channelsPerPage = m_urlData.getParameterInt("channelsPerPage", -1);
			if (channelsPerPage < 1)
				channelsPerPage = m_store.getPropertyInt("EPG.channelsPerPage", 50);
			if (channelsPerPage < 1)
				channelsPerPage = 1;
			
			int daysPerPage = m_urlData.getParameterInt("daysPerPage", -1);
			if (daysPerPage < 1)
				daysPerPage = m_store.getPropertyInt("EPG.daysPerPage", 1);
			if (daysPerPage < 1)
				daysPerPage = 1;

			String colNum = Integer.toString((guideStore.getChannelIndex(channel) - channelsPerPage * page) * daysPerPage + 1 + daysPast);

			SimpleDateFormat dateFormater = new SimpleDateFormat(
					"yyyyMMddHHmmss Z");
			StringBuffer startDateBuff = new StringBuffer();
			dateFormater.format(schItem.getStart(), startDateBuff,
					new FieldPosition(0));
			StringBuffer stopDateBuff = new StringBuffer();
			dateFormater.format(schItem.getStop(), stopDateBuff,
					new FieldPosition(0));

			Calendar stopTime = Calendar.getInstance();
			stopTime.setTime(schItem.getStop());
			
			Calendar crossCalendar = (Calendar) startTime.clone();
			crossCalendar.set(Calendar.HOUR_OF_DAY, 6);
			crossCalendar.set(Calendar.MINUTE, 0);
			crossCalendar.set(Calendar.SECOND, 0);
			crossCalendar.set(Calendar.MILLISECOND, 0);
			boolean bCrossDay = crossCalendar.after(startTime) && crossCalendar.before(stopTime);
			if (!bCrossDay)
			{
				crossCalendar = (Calendar) stopTime.clone();
				crossCalendar.set(Calendar.HOUR_OF_DAY, 6);
				crossCalendar.set(Calendar.MINUTE, 0);
				crossCalendar.set(Calendar.SECOND, 0);
				crossCalendar.set(Calendar.MILLISECOND, 0);
				bCrossDay = crossCalendar.after(startTime) && crossCalendar.before(stopTime);
			}

			String child_type = schItem.getTypeStr();

			String text = "EPGSchedule|" + startDateBuff + "|" + stopDateBuff
					+ "|" + schItem.getDuration() + "|" + child_type + "|"
					+ schItem.getName() + "|" + channel + "|"
					+ schItem.toString() + "|" + colNum + "|" + fromTop + "|"
					+ cellHeight + "|" + startTime.get(Calendar.DAY_OF_MONTH)
					+ "|" + startTime.get(Calendar.MONTH) + "|"
					+ startTime.get(Calendar.YEAR) + "|" + start.get(Calendar.DAY_OF_MONTH)
					+ "|" + start.get(Calendar.MONTH) + "|"
					+ start.get(Calendar.YEAR) + "|" 
					+ stopTime.get(Calendar.HOUR_OF_DAY) + "|" + stopTime.get(Calendar.MINUTE) + "|"
					+ (bCrossDay ? "1" : "0");

			return addLength(text).getBytes("UTF-8");
		}
	}

	private byte[] addUpdateItem() throws Exception
	{
		String id = m_urlData.getParameter("id");
		ScheduleItem item = null;

		if (id != null && id.length() > 0) {
			HashMap<?, ?> times = m_store.getScheduleList();
			item = (ScheduleItem) times.get(id);
		}

		if (item != null
				&& item.getState() != ScheduleItem.FINISHED
				&& item.getState() != ScheduleItem.WAITING
				&& item.getState() != ScheduleItem.SKIPPED 
				&& item.getState() != ScheduleItem.ERROR
				&& item.getState() != ScheduleItem.RUNNING)
		{
			StringBuffer out = new StringBuffer();
			out.append("HTTP/1.0 302 Moved Temporarily\n");
			out.append("Location: /servlet/ScheduleDataRes\n\n");
			return out.toString().getBytes("UTF-8");
		}

		if (item != null
				&& (item.getState() == ScheduleItem.FINISHED
				|| item.getState() == ScheduleItem.WAITING
				|| item.getState() == ScheduleItem.SKIPPED 
				|| item.getState() == ScheduleItem.ERROR))
		{
			item.resetCaptureDevicesUsed();
			item.resetErrorCount();
		}

		String mes = addSchedule(item);

		if (mes != null)
			throw new Exception(mes);

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private String getValue(String text)
	{
		return text.substring(text.indexOf("->") + 2);
	}

	private String replaceKeywords(String text, ScheduleItem item)
	{
		text = m_store.replaceKeywords(text);
		text = item.replaceKeywords(text);	// Has to be before Channel::replaceKeywords(...)

		Channel ch = m_store.getChannel(item.getChannel());	// Can't get running channel.
		if (ch != null)
			text = ch.replaceKeywords(text);

		return text;
	}

	/*
	Return values:
	0: error.
	1: don't do anything.
	2: create schedule.
	 */
	protected int readPreviewFile(ScheduleItem item) throws Exception
	{
		// Check capture type.
		String capType = item.getCaptureCommandFile();
		String capTypeFile = m_store.getProperty("Capture.engine.path", "util") + File.separator + capType;
		File dir = new File(capTypeFile);

		if (!dir.exists() || !dir.isFile())
		{
			DVScheduler.log("Capture type file (" + capType + ") doesn't exist");
			return 0;
		}
		else if (dir.length() > 4096)
		{
			DVScheduler.log("Capture type file (" + capType + ") > 4096 bytes - too big, check for error");
			return 0;
		}
		else
		{
			String createFileName = "";
			String createFileType = "";
			String createFileContent = "";
			String redirect = "";
			BufferedReader r = new BufferedReader(new FileReader(capTypeFile));
			String line = null;

			while ((line = r.readLine()) != null)
			{
				line = line.trim();

				if (line.startsWith("Create File Name->"))
				{
					createFileName = getValue(line).trim();
				}
				else if (line.startsWith("Create File Type->"))
				{
					createFileType = getValue(line).trim();
				}
				else if (line.startsWith("Create File Content->"))
				{
					createFileContent += getValue(line) + "\r\n";
				}
				else if (line.startsWith("Redirect->"))
				{
					redirect += getValue(line) + "\r\n";
				}
			}

			r.close();

			if ( (createFileName.isEmpty() != createFileType.isEmpty()) ? true : (createFileName.isEmpty() != createFileContent.isEmpty()) ) 
			{
				DVScheduler.log("Error reading capture type file (" + capType + "): One or more of CreateFileName, CreateFileType, CreateFileContent missing.");
				return 0;
			}
			if ( !createFileName.isEmpty() && !redirect.isEmpty() )
			{
				createFileName = replaceKeywords(createFileName, item);
				createFileType = replaceKeywords(createFileType, item);
				createFileContent = replaceKeywords(createFileContent, item);

				byte[] createFileContent2 = createFileContent.getBytes("UTF-8");

				StringBuffer buffer = new StringBuffer();
				buffer.append("HTTP/1.0 200 OK\nContent-Type: " + createFileType + "\n");
				buffer.append("Content-Disposition: " + m_store.getProperty("Preview.disposition", "inline") + "; filename=\"" + createFileName + "\"\n");
				buffer.append("Content-Length: " + createFileContent2.length + "\n");
				buffer.append("Cache-Control: no-cache\n");
				buffer.append("\n");

				m_outStream.write(buffer.toString().getBytes("UTF-8"));
				m_outStream.write(createFileContent2);
				return 1;
			}
		}
		return 2;
	}

	private void addPreview(boolean bRefresh) throws Exception
	{
		String channel = m_urlData.getParameter("channel");
		if ( (m_store.getWebGuiProtocol() == DataStore.WEBGUI_HTTPS) && m_store.isAllowUnsecureDownload() )
		{
			String host = m_headers.get("Host");
			int sep = host.lastIndexOf(":");
			if (sep > -1)
				host = host.substring(0, sep);
			if ( host.equals("127.0.0.1") || host.equals("0:0:0:0:0:0:0:1") )
			{
				host = "localhost";
			}
			m_outStream.write( ("HTTP/1.0 302 Moved Temporarily\nLocation: http://" + host + ":" + DVScheduler.getHttpPort() + "/playlist/" + Formatter.encodeURL_UTF8(channel) + "\n\n").getBytes() );
		}
		else
		{
			addPreview(bRefresh, channel);
		}
	}

	private void addPreview(boolean bRefresh, String channel) throws Exception
	{
		// check channel name exists
		Channel channel2 = m_store.getChannel(channel);
		if (channel2 == null)
		{
			int dotPosition = channel.lastIndexOf('.');
			if (dotPosition > 0)
			{
				String channel3 = channel.substring(0, dotPosition);
				channel2 = m_store.getChannel(channel3);
				if (channel2 == null)
					throw new Exception("Channel " + channel + " Not Found!");
				channel = channel3;
			}
			else
				throw new Exception("Channel " + channel + " Not Found!");
		}

		ScheduleItem item = new ScheduleItem(m_store.m_rand.nextLong());

		if (isLocal())
		{
			item.setPreviewLocal();
			String previewType = channel2.getPreviewType();
			if (previewType == null || previewType.isEmpty() || previewType.equals("Preview.deftype"))
			{
				previewType = m_store.getProperty("Preview.deftype", "Preview");
				item.setCapType((previewType.isEmpty() || previewType.equals("*UNDEFINED*")) ? "Preview" : previewType);
			}
			else
				item.setCapType(previewType);
		}
		else
		{
			item.setPreviewRemote();
			String previewType = channel2.getPreviewRemoteType();
			if (previewType == null || previewType.isEmpty() || previewType.equals("Preview.remote.deftype"))
			{
				previewType = m_store.getProperty("Preview.remote.deftype", "Preview");
				item.setCapType((previewType.isEmpty() || previewType.equals("*UNDEFINED*")) ? "Preview" : previewType);
			}
			else
				item.setCapType(previewType);
		}

		// check name pattern exists
		String[] namePatterns = m_store.getNamePatterns();
		String namePattern = namePatterns[0];

		// build the Calendar object and set the start time
		Calendar newDate = Calendar.getInstance();

		item.setType(ScheduleItem.ONCE);
		String ip = m_headers.get("RemoteAddress");
		if ( ip.equals("127.0.0.1") || ip.equals("0:0:0:0:0:0:0:1") )
			ip = "localhost";
		item.setName("Preview from " + ip);

		// Set the initial status
		item.setState(ScheduleItem.WAITING);
		item.setStatus("Waiting");

		// Reset the abort if are editing
		item.resetAbort();

		// Set the start/stop and duration
		item.setStart(newDate);
		item.setDuration(10);

		// Set the channel to capture
		item.setChannel(channel);

		// Set the Auto Del option
		item.setAutoDeletable(true);

		item.setFilePattern(namePattern);

		item.setKeepFor(-1);

		item.setPostTask("");

		item.setNames(m_headers);

		// Log the add action
		item.log("New preview added/edited");

		int result = readPreviewFile(item);
		if (result == 0)
		{
			m_outStream.write( getRedirUrlRedir(null).getBytes("UTF-8") );
			return;
		}
		else if (result == 1)
			return;

		ThreadLock.getInstance().getLock();
		try
		{
			m_store.addScheduleItemAndSave(item);
		}
		finally
		{
			ThreadLock.getInstance().releaseLock();
		}

		int counts = (m_store.getPropertyInt("Capture.startTimeout", 65) + 10) * 10;
		while (item.getState() == ScheduleItem.WAITING && counts > 0) {
			counts--;
			item.waitResponse();
			//Thread.sleep(100);
			if (item.getState() == ScheduleItem.ERROR)
				break;
		}

		if (bRefresh)
		{
			StringBuffer buffer = new StringBuffer();
			m_outStream.write( createFile(item, buffer) ? buffer.toString().getBytes("UTF-8") : getRedirUrlRedir(null).getBytes("UTF-8") );
		}
		else
		{
			GuideStore guide = GuideStore.getInstance();
			Calendar start = Calendar.getInstance();
			start.setTime(item.getStart());
			if (start.get(Calendar.HOUR_OF_DAY) < 6)
				start.add(Calendar.DATE, -1);

			start.set(Calendar.HOUR_OF_DAY, 6);
			start.set(Calendar.MINUTE, 0);
			start.set(Calendar.SECOND, 0);

			Calendar startTime = Calendar.getInstance();
			startTime.setTime(item.getStart());
			long pastStart = startTime.getTime().getTime()
					- start.getTime().getTime();

			String fromTop = new Long(pastStart / (1000 * 60)).toString();
			String cellHeight = new Integer(item.getDuration()).toString();
			String colNum = Integer.toString(guide.getChannelIndex(channel) + 1);

			SimpleDateFormat dateFormater = new SimpleDateFormat(
					"yyyyMMddHHmmss Z");
			StringBuffer startDateBuff = new StringBuffer();
			dateFormater.format(item.getStart(), startDateBuff,
					new FieldPosition(0));
			StringBuffer stopDateBuff = new StringBuffer();
			dateFormater.format(item.getStop(), stopDateBuff,
					new FieldPosition(0));

			String child_type = item.getTypeStr();

			String text = "EPGSchedule|" + startDateBuff + "|" + stopDateBuff
					+ "|" + item.getDuration() + "|" + child_type + "|"
					+ item.getName() + "|" + channel + "|"
					+ item.toString() + "|" + colNum + "|" + fromTop + "|"
					+ cellHeight + "|" + startTime.get(Calendar.DAY_OF_MONTH)
					+ "|" + startTime.get(Calendar.MONTH) + "|"
					+ startTime.get(Calendar.YEAR) + "|" + start.get(Calendar.DAY_OF_MONTH)
					+ "|" + start.get(Calendar.MONTH) + "|"
					+ start.get(Calendar.YEAR) + "|" + (createFile(item, null) ? item.toString() : "");

			m_outStream.write( addLength(text).getBytes("UTF-8") );
		}
	}

	private void addSchedule() throws Exception
	{
		String channel = m_urlData.getParameter("channel");

		// check channel name exists
		Channel channel2 = m_store.getChannel(channel);
		if (channel2 == null) {
			throw new Exception("Channel " + channel + " Not Found!");
		}

		ScheduleItem item = new ScheduleItem(m_store.m_rand.nextLong());

		String mode = m_urlData.getParameter("mode");
		if ("pre".equals(mode))
		{
			item.setPreviewLocal();
		}
		else if ("prr".equals(mode))
		{
			item.setPreviewRemote();
		}
		String type = m_urlData.getParameter("type");
		item.setCapType(type);

		DVScheduler.log("addSchedule() channel:" + channel + " mode:" + mode + " type:" + type);

		// check name pattern exists
		String[] namePatterns = m_store.getNamePatterns();
		String namePattern = namePatterns[0];

		// build the Calendar object and set the start time
		Calendar newDate = Calendar.getInstance();

		item.setType(ScheduleItem.ONCE);
		item.setName(m_urlData.getParameter("name", "Recording"));

		// Set the initial status
		item.setState(ScheduleItem.WAITING);
		item.setStatus("Waiting");

		// Reset the abort if are editing
		item.resetAbort();

		// Set the start/stop and duration
		item.setStart(newDate);
		item.setDuration(10);

		// Set the channel to capture
		item.setChannel(channel);

		// Set the Auto Del option
		item.setAutoDeletable(true);

		item.setFilePattern(namePattern);

		item.setKeepFor(30);

		item.setPostTask("");

		item.setNames(m_headers);

		// Log the add action
		item.log("New preview added/edited");

		ThreadLock.getInstance().getLock();
		try
		{
			m_store.addScheduleItemAndSave(item);
		}
		finally
		{
			ThreadLock.getInstance().releaseLock();
		}

		m_outStream.write( getRedirUrlRedir(null).getBytes("UTF-8") );
	}

	public byte[] addPlay(String channel, boolean bPreview) throws Exception {
		ScheduleItem item = null;

		// check channel name exists
		DataStore store = DataStore.getInstance();
		Channel channel2 = store.getChannel(channel);
		if (channel2 == null)
		{
			int dotPosition = channel.lastIndexOf('.');
			if (dotPosition > 0)
			{
				String channel3 = channel.substring(0, dotPosition);
				channel2 = store.getChannel(channel3);
				if (channel2 == null)
					return getHtmlErrorMessage("Channel " + channel + " or " + channel3 + " Not Found", "Check channel name").getBytes("UTF-8");
				channel = channel3;
			}
			else
				return getHtmlErrorMessage("Channel " + channel + " Not Found", "Check channel name").getBytes("UTF-8");
		}

		// check name pattern exists
		String[] namePatterns = store.getNamePatterns();
		String namePattern = namePatterns[0];

		// build the Calendar object and set the start time
		Calendar newDate = Calendar.getInstance();

		item = new ScheduleItem(store.m_rand.nextLong());

		if (bPreview)
		{
			if (HTTPResponse.isLocal(m_headers))
			{
				item.setPreviewLocal();
				String previewType = channel2.getPreviewType();
				if (previewType == null || previewType.isEmpty() || previewType.equals("Preview.deftype"))
				{
					previewType = store.getProperty("Preview.deftype", "Preview");
					item.setCapType((previewType.isEmpty() || previewType.equals("*UNDEFINED*")) ? "Preview" : previewType);
				}
				else
					item.setCapType(previewType);
			}
			else
			{
				item.setPreviewRemote();
				String previewType = channel2.getPreviewRemoteType();
				if (previewType == null || previewType.isEmpty() || previewType.equals("Preview.remote.deftype"))
				{
					previewType = store.getProperty("Preview.remote.deftype", "Preview");
					item.setCapType((previewType.isEmpty() || previewType.equals("*UNDEFINED*")) ? "Preview" : previewType);
				}
				else
					item.setCapType(previewType);
			}
		}
		else
		{
			item.setPlaylist();
			item.setCapType("Playlist");
		}

		item.setType(ScheduleItem.ONCE);
		String ip = m_headers.get("RemoteAddress");
		if ( ip.equals("127.0.0.1") || ip.equals("0:0:0:0:0:0:0:1") )
			ip = "localhost";
		item.setName("Preview from " + ip);

		// Set the initial status
		item.setState(ScheduleItem.WAITING);
		item.setStatus("Waiting");

		// Reset the abort if are editing
		item.resetAbort();

		// Set the start/stop and duration
		item.setStart(newDate);
		item.setDuration(10);

		// Set the channel to capture
		item.setChannel(channel);

		// Set the Auto Del option
		item.setAutoDeletable(true);

		item.setFilePattern(namePattern);

		item.setKeepFor(-1);

		item.setPostTask("");

		item.setNames(m_headers);

		// Log the add action
		item.log("New play added/edited");

		ThreadLock.getInstance().getLock();
		try
		{
			store.addScheduleItemAndSave(item);
		}
		finally
		{
			ThreadLock.getInstance().releaseLock();
		}

		int counts = (store.getPropertyInt("Capture.startTimeout", 65) + 10) * 10;
		while (item.getState() == ScheduleItem.WAITING && counts > 0) {
			counts--;
			item.waitResponse();
			//Thread.sleep(100);
			if (item.getState() == ScheduleItem.ERROR)
				break;
		}

		StringBuffer buffer = new StringBuffer();
		return createFile(item, buffer) ? buffer.toString().getBytes("UTF-8") : getHtmlErrorMessage(item).getBytes("UTF-8");
	}

	private static String getHtmlErrorMessage(String response, String description)
	{
		String html = "HTTP/1.0 404 ";
		html += response;
		html += "\nContent-type: text/html\n\n<html><head><title>DV Scheduler Error</title></head><body><pre>";
		html += response + "\n\n";
		html += HTMLEncoder.encode(description);
		html += "</pre></body></html>";
		return html;
	}

	private static String getHtmlErrorMessage(ScheduleItem item)
	{
		return getHtmlErrorMessage(item.getStatus(), item.getLog());
	}

	private byte[] addPlay(boolean bPreview) throws Exception {
		String channel = m_urlData.getParameter("channel");
		return addPlay(channel, bPreview);
	}

	private static boolean createFile(ScheduleItem item, StringBuffer buffer) throws Exception
	{
		DataStore store = DataStore.getInstance();
		// Should it be if (item.getState() == ScheduleItem.RUNNING) instead, but also checked with if (task == null)
		if (item.getState() != ScheduleItem.ERROR)
		{
			CaptureTask task = store.m_captureTasks.get(item.toString());
			if (task == null)
				return false;

			String redirect = task.getRedirect();
			if (redirect.isEmpty())
			{
				String fileName = task.getCreateFileName();
				String fileType = task.getCreateFileType();
				String fileContent = task.getCreateFileContent();
				if ( !fileName.isEmpty() && !fileType.isEmpty() && !fileContent.isEmpty() )
				{
					if (buffer == null)
						return true;

					buffer.append("HTTP/1.0 200 OK\nContent-Type: " + fileType + "\n");
					buffer.append("Content-Disposition: " + store.getProperty("Preview.disposition", "inline") + "; filename=\"" + fileName + "\"\n");
					buffer.append("Content-Length: " + fileContent.getBytes("UTF-8").length + "\n");
					buffer.append("Cache-Control: no-cache\n");
					buffer.append("\n");

					buffer.append(fileContent);

					return true;
				}
			}
			else
			{
				if (buffer == null)
					return true;

				buffer.append("HTTP/1.0 302 Moved Temporarily\n");
				buffer.append("Location: " + redirect + "\n");
				buffer.append("\n");

				return true;
			}
		}

		return false;
	}

	private byte[] serveFile() throws Exception
	{
		String id = m_urlData.getParameter("scheduleId");
		if (id == null)
			return getRedirUrlRedir(null).getBytes("UTF-8");

		ScheduleItem item = m_store.getScheduleItem(id);
		if (item == null)
			return getRedirUrlRedir(null).getBytes("UTF-8");

		StringBuffer buffer = new StringBuffer();
		return createFile(item, buffer) ? buffer.toString().getBytes("UTF-8") : getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private String addSchedule(ScheduleItem item)
			throws Exception {
		// Add time buffer
		int startBuff = 0;
		int endBuff = 0;
		int epgBuff = 0;
		try {
			startBuff = Integer.parseInt(m_store.getProperty(
					"Schedule.buffer.start", "0"));
			endBuff = Integer.parseInt(m_store.getProperty("Schedule.buffer.end",
					"0"));
			epgBuff = Integer.parseInt(m_store.getProperty("Schedule.buffer.EPG",
					"0"));
		} catch (Exception e) {
		}
		String addBuff = m_urlData.getParameter("buffer");

		// Get all the input data
		String selection = m_urlData.getParameter("selection");
		String y = m_urlData.getParameter("year");
		String m = m_urlData.getParameter("month");
		String d = m_urlData.getParameter("day");
		String h = m_urlData.getParameter("hour");
		String mi = m_urlData.getParameter("min");
		String channel = m_urlData.getParameter("channel");
		String name = m_urlData.getParameter("name");
		String autoDel = m_urlData.getParameter("autoDel");
		String capturePath = m_urlData.getParameter("capturePath");
		String namePattern = m_urlData.getParameter("namePattern");
		String keepFor = m_urlData.getParameter("keepfor");
		String task = m_urlData.getParameter("task");
		String wakeSystem = m_urlData.getParameter("wakeSystem");

		// check channel name exists
		HashMap<String, Channel> channels = m_store.getChannels();
		if (!channels.containsKey(channel)) {
			throw new Exception("Channel " + channel + " Not Found!");
		}

		String[] paths = DVScheduler.getArray(m_store.getProperty("Capture.path", "capture"));
		if (capturePath == null)
			capturePath = "*";
		else if (!capturePath.equals("*"))
		{
			boolean bFound = false;
			for (int x = 0; x < paths.length; x++)
			{
				if (paths[x].equals(capturePath))
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
				capturePath = "*";
		}

		// check name pattern exists
		String[] namePatterns = m_store.getNamePatterns();
		if (namePattern == null || namePattern.length() == 0)
			namePattern = namePatterns[0];

		boolean found = false;
		for (int x = 0; x < namePatterns.length; x++) {
			if (namePatterns[x].equals(namePattern)) {
				found = true;
				break;
			}
		}
		if (!found) {
			namePattern = namePatterns[0];
		}

		GuideStore guide = GuideStore.getInstance();

		if (item != null && item.getState() != ScheduleItem.RUNNING) {
			m_store.removeScheduleItem(item.toString());
		}

		// Calc the duration in min
		int duration = 1;
		String stopSelection = m_urlData.getParameter("stopselection");
		if (stopSelection.equals("1"))
		{
			try
			{
				int minuteStart = Integer.parseInt(h) * 60 + Integer.parseInt(mi);
				int minuteStop = Integer.parseInt(m_urlData.getParameter("stopHour")) * 60 + Integer.parseInt(m_urlData.getParameter("stopMinute"));
				duration = minuteStop - minuteStart;
				if (duration < 0)
					duration += 60 * 24;
			}
			catch (Exception e) {}
		}
		else
		{
			String dur = m_urlData.getParameter("duration");
			try
			{
				duration = Integer.parseInt(dur);
			}
			catch (Exception e) {}
		}

		int type = m_urlData.getParameterInt("type", 0);

		int customDays = 0;
		String day = m_urlData.getParameter("Sun");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_SUN;
		day = m_urlData.getParameter("Mon");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_MON;
		day = m_urlData.getParameter("Tue");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_TUE;
		day = m_urlData.getParameter("Wed");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_WED;
		day = m_urlData.getParameter("Thu");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_THU;
		day = m_urlData.getParameter("Fri");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_FRI;
		day = m_urlData.getParameter("Sat");
		if (day != null && "1".equals(day))
			customDays |= ScheduleItem.CUSTOM_SAT;

		String captype = "Capture.deftype";
		/*
		 * String captype = ""; try { captype =
		 * store.getProperty("Capture.deftype", ""); } catch (Exception e01) { }
		 */

		try {
			captype = m_urlData.getParameter("captype");
		} catch (Exception e01) {
		}

		// build the Calendar object and set the start time
		Calendar newDate = Calendar.getInstance();
		newDate.set(Calendar.MILLISECOND, 0);
		newDate.set(Integer.parseInt(y), Integer.parseInt(m), Integer
				.parseInt(d), Integer.parseInt(h), Integer.parseInt(mi), 0);

		// If needed add the Time buffer
		if ("yes".equals(addBuff)) {
			newDate.add(Calendar.MINUTE, (startBuff * -1));
			duration = duration + duration * epgBuff / 60 + startBuff + endBuff;
		}

		// Crerate the new Schedule Object
		if (item == null)
			item = new ScheduleItem(m_store.m_rand.nextLong());

		String sGuideId = m_urlData.getParameter("guideItem");
		if (sGuideId != null && sGuideId.length() > 0)
		{
			String epgChan = guide.getEpgChannelIdFromMap(channel);
			GuideItem guideItem = guide.getProgram(epgChan, sGuideId);
			item.setCreatedFrom(guideItem);
		}
		item.setCapType(captype);
		item.setType(type);
		item.setCustomDays(customDays);
		item.setUserModified();
		item.setName(name);

		// Set the initial status
		if (item.getState() != ScheduleItem.RUNNING)
		{
			item.setState(ScheduleItem.WAITING);
			item.setStatus("Waiting");
		}

		// Reset the abort if are editing
		item.resetAbort();

		// Set the start/stop and duration
		GuideItem guideItem = item.getCreatedFrom();
		if (selection != null && selection.equals("0") && guideItem != null)
		{
			item.setTrackEpg(true);
			final int startBuffer = m_store.getPropertyInt("Schedule.buffer.start", 4);
			final int stopBuffer = m_store.getPropertyInt("Schedule.buffer.end", 5);
			final int epgBuffer = m_store.getPropertyInt("Schedule.buffer.EPG", 5);
			try
			{
				if (item.getState() == ScheduleItem.WAITING)
				{
					item.setStart(guideItem.getStart().getTime() - startBuffer * 60000);
				}
				if ( (item.getState() == ScheduleItem.WAITING) || (item.getState() == ScheduleItem.RUNNING) )
				{
					item.setDuration( guideItem.getDuration()
							+ guideItem.getDuration() * epgBuffer / 60 
							+ startBuffer
							+ stopBuffer );
					item.setRunningStatus(new Date());
				}
			}
			catch (Exception e)
			{
			}
		}
		else
		{
			item.setTrackEpg(false);
			item.setStart(newDate);
			if (duration <= 0)
				duration = 1;
			item.setDuration(duration);
		}

		// Set the channel to capture
		item.setChannel(channel);

		// Set the Auto Del option
		if ("true".equalsIgnoreCase(autoDel))
			item.setAutoDeletable(true);
		else
			item.setAutoDeletable(false);

		item.setCapturePath(capturePath);
		item.setFilePattern(namePattern);

		if (keepFor != null) {
			int keepInt = 30;
			try {
				keepInt = Integer.parseInt(keepFor);
			} catch (Exception e) {
			}
			item.setKeepFor(keepInt);
		} else {
			keepFor = m_store.getProperty("AutoDel.KeepFor", "30");
			int keepInt = 30;
			try {
				keepInt = Integer.parseInt(keepFor);
			} catch (Exception e) {
			}
			item.setKeepFor(keepInt);
		}

		if (task != null && !task.equalsIgnoreCase("none") && task.length() > 0) {
			HashMap<?, ?> tasks = m_store.getTaskList();
			if (tasks.containsKey(task))
				item.setPostTask(task);
		} else if (task != null && task.equalsIgnoreCase("none")) {
			item.setPostTask("");
		}

		item.setWakeSystem("1".equals(wakeSystem));

		// Log the add action
		item.log("New Schedule added/edited");

		if (item.getState() != ScheduleItem.RUNNING)
		{
			boolean isAlreadyInLIst = guide.isAlreadyInList(item);
			if (isAlreadyInLIst)
			{
				return null;
			}
			else
			{
				item.setNames(m_headers);
				m_store.addScheduleItemAndSave(item);
			}
		}

		return null;
	}

	private byte[] showAddForm(boolean bFromGuide) throws Exception {
		int day = -1;
		int month = -1;
		int year = -1;
		ScheduleItem item = null;
		String id = null;
		GuideItem guideItem = null;

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "itemdetails.html");

		if (bFromGuide)
		{
			String channel = m_urlData.getParameter("channel");
			id = m_urlData.getParameter("id");

			GuideStore guide = GuideStore.getInstance();

			String epgChan = guide.getEpgChannelIdFromMap(channel);
			guideItem = guide.getProgram(epgChan, id);

			if (epgChan == null || epgChan.length() == 0)
				throw new Exception("DVS Channel Not Found!");

			if (guideItem == null)
				throw new Exception("Invalid guide item!");

			String captype = m_urlData.getParameter("captype");
			if ((captype == null) || captype.isEmpty())
				captype = "Capture.deftype";

			item = new ScheduleItem(guideItem, channel, captype,
					m_store.m_rand.nextLong(), false);

			String task = m_store.getProperty("Tasks.DefTask", "");
			item.setPostTask(task);

			// Add time buffer
			int startBuff = 0;
			int endBuff = 0;
			int epgBuff = 0;
			try {
				startBuff = Integer.parseInt(m_store.getProperty(
						"Schedule.buffer.start", "0"));
				endBuff = Integer.parseInt(m_store.getProperty("Schedule.buffer.end",
						"0"));
				epgBuff = Integer.parseInt(m_store.getProperty("Schedule.buffer.EPG",
						"0"));
			} catch (Exception e) {
			}

			String[] patterns = m_store.getNamePatterns();
			item.setFilePattern(patterns[0]);

			String keepFor = m_store.getProperty("AutoDel.KeepFor", "30");
			int keepInt = 30;
			try {
				keepInt = Integer.parseInt(keepFor);
			} catch (Exception e) {
			}
			item.setKeepFor(keepInt);
			item.setAutoDeletable(m_store.isAutoDelByDefault());

			item.setCapType(captype);

			// build the Calendar object and set the start time
			Calendar cal = Calendar.getInstance();
			cal.setTime(item.getStart());

			cal.add(Calendar.MINUTE, (startBuff * -1));
			item.setDuration(guideItem.getDuration() + guideItem.getDuration()
					* epgBuff / 60 + startBuff + endBuff);
			item.setStart(cal);

			item.setType(ScheduleItem.ONCE);

			day = cal.get(Calendar.DAY_OF_MONTH);
			month = cal.get(Calendar.MONTH);
			year = cal.get(Calendar.YEAR);

			if (m_store.getProperty("Schedule.trackEpg", "Yes").equals("Yes"))
				template.replace("$checkedTrackEpg", "checked");
			else
				template.replace("$checkedTime", "checked");

			template.replace("$guideItem", guideItem.toString());
		}
		else
		{
			try {
				day = Integer.parseInt(m_urlData.getParameter("day"));
				month = Integer.parseInt(m_urlData.getParameter("month"));
				year = Integer.parseInt(m_urlData.getParameter("year"));
			} catch (Exception e) {
			}

			id = m_urlData.getParameter("id");

			if (id != null && id.length() > 0) {
				HashMap<?, ?> times = m_store.getScheduleList();
				item = (ScheduleItem) times.get(id);
			}

			if (item != null
					&& item.getState() != ScheduleItem.FINISHED
					&& item.getState() != ScheduleItem.WAITING
					&& item.getState() != ScheduleItem.SKIPPED 
					&& item.getState() != ScheduleItem.ERROR
					&& item.getState() != ScheduleItem.RUNNING)
			{
				StringBuffer out = new StringBuffer();
				out.append("HTTP/1.0 302 Moved Temporarily\n");
				out.append("Location: /servlet/ScheduleDataRes\n\n");
				return out.toString().getBytes("UTF-8");
			}

			if ( (item != null) && (day < 0 || month < 0 || year < 0) )
			{
				Calendar currentDate = Calendar.getInstance();
				currentDate.setTime(item.getStart());
				day = currentDate.get(Calendar.DATE);
				month = currentDate.get(Calendar.MONTH);
				year = currentDate.get(Calendar.YEAR);
			}

			if (item != null)
			{
				if (item.getCreatedFrom() == null)
				{
					template.replace("$checkedTime", "checked");
					template.replace("$style", "style='display:none'");
				}
				else
				{
					Calendar cal = Calendar.getInstance();
					cal.setTime(item.getStart());
					if ( (day != cal.get(Calendar.DATE)) || (month != cal.get(Calendar.MONTH)) || (year != cal.get(Calendar.YEAR)) )
						template.replace("$checkedTime", "checked");
					else if (item.isTrackEpg())
						template.replace("$checkedTrackEpg", "checked");
					else
						template.replace("$checkedTime", "checked");
				}
			}
			else
			{
				template.replace("$checkedTime", "checked");
				template.replace("$style", "style='display:none'");
			}

			template.replace("guideItem", "");
		}

		template.replaceRedirUrl("$putar");

		int duration = 60;
		if (item != null)
		{
			duration = item.getDuration();
		}
		else
		{
			try
			{
				duration = Integer.parseInt(m_store.getProperty("Capture.defaultDuration", "60"));
			}
			catch (Exception e) {}
		}
		template.replace("$duration", Integer.toString(duration));

		if (item != null)
			template.replace("$name", item.getName());
		else
			template.replace("$name", "Recording");

		Calendar cal = Calendar.getInstance();
		if (item != null)
			cal.setTime(item.getStart());

		template.replace("$hour", DataStore.intToStr(cal
				.get(Calendar.HOUR_OF_DAY)));
		template.replace("$min", DataStore.intToStr(cal.get(Calendar.MINUTE)));

		if (duration < 24 * 60)
		{
			cal.add(Calendar.MINUTE, duration);
			template.replace("$stopHour", DataStore.intToStr(cal
					.get(Calendar.HOUR_OF_DAY)));
			template.replace("$stopMinute", DataStore.intToStr(cal.get(Calendar.MINUTE)));
		}
		else
		{
			template.replace("$stopHour", "");
			template.replace("$stopMinute", "");
		}

		template.replace("$channels", getChannelList(item));

		template.replace("$item_type", getTypeList(item));

		template.replace("$item_captype", getCapTypeList(item));

		String fields = "";
		fields += "<input type='hidden' name='day' value='" + day + "'>\n";
		fields += "<input type='hidden' name='month' value='" + month + "'>\n";
		fields += "<input type='hidden' name='year' value='" + year + "'>\n";

		if (!bFromGuide && (item != null))
		{
			fields += "<input name='id' type='hidden' id='id' value='" + id
					+ "'>\n";
		}

		template.replace("$fields", fields);

		if (item != null && item.isAutoDeletable())
			template.replace("$adtrue", "checked");
		else
			template.replace("$adtrue", m_store.isAutoDelByDefault() ? "checked" : "");

		template.replace("$capturePath", getCapturePathList(item));
		template.replace("$pattern", getNamePatternList(item));

		if (item == null)
		{
			String defKeepFor = m_store.getProperty("AutoDel.KeepFor", "30");
			if (defKeepFor == null)
				defKeepFor = "30";

			template.replace("$keepfor", defKeepFor);

			template.replace("$wakeSystem", "checked");
		}
		else
		{
			template.replace("$keepfor", new Integer(item.getKeepFor()).toString());

			template.replace("$wakeSystem", item.isWakeSystem() ? "checked" : "");
		}

		template.replace("$tasks", getTaskList(item));

		if (item != null
				&& item.getState() == ScheduleItem.RUNNING)
		{
			template.replace("$readonly", "readonly");
			template.replace("$disabled", "disabled");
		}

		return template.getPageBytes();
	}

	private String getTaskList(ScheduleItem item) {
		StringBuffer buff = new StringBuffer(1024);
		HashMap<String, TaskCommand> tasks = m_store.getTaskList();

		String selectedTask = m_store.getProperty("Tasks.DefTask", "");
		if (item != null) {
			selectedTask = item.getPostTask();
		}

		String[] keys = (String[]) tasks.keySet().toArray(new String[0]);
		Arrays.sort(keys);

		if (selectedTask.length() == 0)
			buff
			.append("<label><input type='radio' name='task' value='none' checked>none</label><br>\n");
		else
			buff
			.append("<label><input type='radio' name='task' value='none'>none</label><br>\n");

		for (int x = 0; x < keys.length; x++) {
			if (keys[x].equals(selectedTask))
				buff.append("<label><input type='radio' name='task' value='"
						+ HTMLEncoder.encode(keys[x]) + "' checked>" + HTMLEncoder.encode(keys[x]) + "</label><br>\n");
			else
				buff.append("<label><input type='radio' name='task' value='"
						+ HTMLEncoder.encode(keys[x]) + "'>" + HTMLEncoder.encode(keys[x]) + "</label><br>\n");
		}

		return buff.toString();
	}

	private String getCapturePathList(ScheduleItem item)
	{
		StringBuffer buff = new StringBuffer(1024);
		String[] paths = DVScheduler.getArray(m_store.getProperty("Capture.path", "capture"));

		if ( item == null || 
				(item != null && ("*".equals(item.getCapturePath()) || item.getCapturePath() == null)) )
			buff
			.append("<label><input type='radio' name='capturePath' value='*' checked $disabled>Default</label><br>\n");
		else
			buff
			.append("<label><input type='radio' name='capturePath' value='*' $disabled>Default</label><br>\n");

		for(int x = 0; x < paths.length; x++)
		{
			if (item != null && paths[x].equals(item.getCapturePath()))
				buff
				.append("<label><input type='radio' name='capturePath' value='"
						+ paths[x]
								+ "' checked $disabled>"
								+ paths[x] + "</label><br>\n");
			else
				buff
				.append("<label><input type='radio' name='capturePath' value='"
						+ paths[x]
								+ "' $disabled>"
								+ paths[x]
										+ "</label><br>\n");
		}

		return buff.toString();
	}

	private String getNamePatternList(ScheduleItem item) {
		StringBuffer buff = new StringBuffer(1024);
		String[] namePatterns = m_store.getNamePatterns();

		for (int x = 0; x < namePatterns.length; x++) {
			if (item == null && x == 0 || item != null
					&& namePatterns[x].equals(item.getFilePattern()))
				buff
				.append("<label><input type='radio' name='namePattern' value='"
						+ namePatterns[x]
								+ "' checked $disabled>"
								+ namePatterns[x] + "</label><br>\n");
			else
				buff
				.append("<label><input type='radio' name='namePattern' value='"
						+ namePatterns[x]
								+ "' $disabled>"
								+ namePatterns[x]
										+ "</label><br>\n");
		}

		return buff.toString();
	}

	private String getCapTypeList(ScheduleItem item) {
		StringBuffer typeList = new StringBuffer(1024);
		String type = "Capture.deftype";
		/*
		 * String type = ""; try { type = store.getProperty("Capture.deftype",
		 * ""); } catch(Exception e){}
		 */

		if (item != null && item.getCapType() != null)
			type = item.getCapType();

		/*
		 * typeList.append("<label><input name='captype' type='radio'
		 * value='0' "); if(type == 0) typeList.append("checked");
		 * typeList.append(">Full TS</label><br>\n");
		 * 
		 * typeList.append("<label><input name='captype' type='radio'
		 * value='1' "); if(type == 1) typeList.append("checked");
		 * typeList.append(">Dvr-MS Stream Buffer</label><br>\n");
		 * 
		 * typeList.append("<label><input name='captype' type='radio'
		 * value='2' "); if(type == 2) typeList.append("checked");
		 * typeList.append(">TS mux</label><br>\n");
		 * 
		 * typeList.append("<label><input name='captype' type='radio'
		 * value='3' "); if(type == 3) typeList.append("checked");
		 * typeList.append(">Separate Files</label><br>\n");
		 */

		Vector<String> capTypes = m_store.getCaptureTypes();
		for (int x = 0; x < capTypes.size(); x++) {
			String typeAt = capTypes.get(x);

			typeList
			.append("<label><input name='captype' type='radio' value=\""
					+ typeAt + "\" ");
			if (type.equals(typeAt))
				typeList.append("checked");
			typeList.append(" $disabled>" + typeAt + "</label><br>\n");
		}

		return typeList.toString();
	}

	private String getChannelList(ScheduleItem item) {
		String channelList = "";
		HashMap<String, Channel> channels = m_store.getChannels();
		String[] keys = (String[]) channels.keySet().toArray(new String[0]);
		Arrays.sort(keys);
		String chan = null;

		//Arrays.sort(keys);

		if (item != null)
			chan = item.getChannel();

		for (int x = 0; x < keys.length; x++) {
			if (chan != null && keys[x].equals(chan))
				channelList += "<label><input type='radio' name='channel' value='"
						+ HTMLEncoder.encode(keys[x]) + "' checked $disabled>" + HTMLEncoder.encode(keys[x]) + "</label><br>\n";
			else
				channelList += "<label><input type='radio' name='channel' value='"
						+ HTMLEncoder.encode(keys[x]) + "' $disabled>" + HTMLEncoder.encode(keys[x]) + "</label><br>\n";
		}

		return channelList;
	}

	private String getTypeList(ScheduleItem item) {
		StringBuffer typeList = new StringBuffer(1024);
		int type = 0;
		int customDays = 0;

		if (item != null)
		{
			type = item.getType();
			customDays = item.getCustomDays();
		}

		typeList.append("<label><input name='type' type='radio' value='0' onClick='disableCustomDays()' ");
		if (type == ScheduleItem.ONCE)
			typeList.append("checked");
		typeList.append(" $disabled>Once</label><br>\n");

		typeList.append("<label><input name='type' type='radio' value='1' onClick='disableCustomDays()' ");
		if (type == ScheduleItem.DAILY)
			typeList.append("checked");
		typeList.append(" $disabled>Daily</label><br>\n");

		typeList.append("<label><input name='type' type='radio' value='2' onClick='enableCustomDays()' ");
		if (type == ScheduleItem.WEEKLY)
			typeList.append("checked");
		typeList.append(" $disabled>Weekly</label><br>\n");

		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Sun' id='customDaySun' value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_SUN) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Sun<br>");
		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Mon' id='customDayMon'  value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_MON) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Mon<br>");
		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Tue' id='customDayTue'  value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_TUE) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Tue<br>");
		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Wed' id='customDayWed'  value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_WED) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Wed<br>");
		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Thu' id='customDayThu'  value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_THU) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Thu<br>");
		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Fri' id='customDayFri'  value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_FRI) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Fri<br>");
		typeList.append("&nbsp; &nbsp; <input type='checkbox' name='Sat' id='customDaySat'  value='1'");
		if ( (customDays & ScheduleItem.CUSTOM_SAT) > 0 )
			typeList.append(" checked");
		typeList.append(" $disabled>Sat<br>");

		typeList.append("<label><input name='type' type='radio' value='3' onClick='disableCustomDays()' ");
		if (type == ScheduleItem.MONTHLY)
			typeList.append("checked");
		typeList.append(" $disabled>Monthly</label><br>\n");

		typeList.append("<label><input name='type' type='radio' value='4' onClick='disableCustomDays()' ");
		if (type == ScheduleItem.WEEKDAY)
			typeList.append("checked");
		typeList.append(" $disabled>Week Day</label><br>\n");

		typeList.append("<label><input name='type' type='radio' value='5' onClick='disableCustomDays()' ");
		if (type == ScheduleItem.EPG)
			typeList.append("checked");
		typeList.append(" $disabled>EPG</label><br>\n");

		typeList.append("<label><input name='type' type='radio' value='6' onClick='disableCustomDays()' ");
		if (type == ScheduleItem.EPG_SCAN)
			typeList.append("checked");
		typeList.append(" $disabled>EPG Scan</label><br>\n");

		return typeList.toString();
	}

	private byte[] showCalendar() throws Exception
	{
		String id = m_urlData.getParameter("id");

		ScheduleItem item = m_store.getScheduleItem(id);

		// if we are trying to edit a running schedule just redirect back
		// to the main page
		if (item != null
				&& (item.getState() != ScheduleItem.FINISHED
				&& item.getState() != ScheduleItem.WAITING
				&& item.getState() != ScheduleItem.SKIPPED && item
				.getState() != ScheduleItem.ERROR)) {
			StringBuffer out = new StringBuffer();
			out.append("HTTP/1.0 302 Moved Temporarily\n");
			out.append("Location: /servlet/ScheduleDataRes\n\n");
			return out.toString().getBytes("UTF-8");
		}

		int month = -1;
		int year = -1;
		try {
			month = Integer.parseInt(m_urlData.getParameter("month"));
			year = Integer.parseInt(m_urlData.getParameter("year"));
		} catch (Exception e) {
		}

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "calendar.html");
		template.replace("$calendar", getCalendarTable(month, year, id));

		return template.getPageBytes();
	}

	private String getCalendarTable(int month, int year, String id) throws Exception {
		StringBuffer content = new StringBuffer();
		Calendar cal = Calendar.getInstance();
		ScheduleItem item = null;
		String idString = "";

		if (id != null && id.length() > 0) {
			HashMap<?, ?> times = m_store.getScheduleList();
			item = (ScheduleItem) times.get(id);

			idString = "&id=" + Formatter.encodeURL(id, "UTF-8");
		}

		int thisDay = 0;
		cal.get(Calendar.DATE);
		int thisMonth = 0;
		cal.get(Calendar.MONTH);
		int thisYear = 0;
		cal.get(Calendar.YEAR);
		if (item != null) {
			Calendar currentDate = Calendar.getInstance();
			currentDate.setTime(item.getStart());
			thisDay = currentDate.get(Calendar.DATE);
			thisMonth = currentDate.get(Calendar.MONTH);
			thisYear = currentDate.get(Calendar.YEAR);
		} else {
			thisDay = cal.get(Calendar.DATE);
			thisMonth = cal.get(Calendar.MONTH);
			thisYear = cal.get(Calendar.YEAR);
		}

		cal.set(Calendar.DATE, 1);
		if (month != -1 && year != -1) {
			cal.set(Calendar.MONTH, month);
			cal.set(Calendar.YEAR, year);
		} else if (item != null)
		{
			year = thisYear;
			month = thisMonth;
			cal.set(Calendar.MONTH, month);
			cal.set(Calendar.YEAR, year);
		}
		else
		{
			year = cal.get(Calendar.YEAR);
			month = cal.get(Calendar.MONTH);
		}

		cal.add(Calendar.MONTH, 1);
		int nextMonth = cal.get(Calendar.MONTH);
		int nextYear = cal.get(Calendar.YEAR);
		cal.add(Calendar.MONTH, -2);
		int prevMonth = cal.get(Calendar.MONTH);
		int prevYear = cal.get(Calendar.YEAR);
		cal.add(Calendar.MONTH, 1);

		String redirUrl = getRedirUrlPutar(null);
		content.append("<tr><td class='calendarTitle' colspan='7'>");
		content.append("<a class='infoNav' href='/servlet/"
				+ m_urlData.getServletClass() + "?action=01&month=" + prevMonth
				+ "&year=" + prevYear + idString + redirUrl + "'><<</a> ");
		content
		.append(m_store.monthNameFull.get(new Integer(month)) + " "
				+ year);
		content.append(" <a class='infoNav' href='/servlet/"
				+ m_urlData.getServletClass() + "?action=01&month=" + nextMonth
				+ "&year=" + nextYear + idString + redirUrl + "'>>></a> ");
		content.append("</td></tr>");

		content
		.append("<tr><td class='calendarweek'>SUN</td><td class='calendarweek'>MON</td><td class='calendarweek'>TUES</td><td class='calendarweek'>WED</td><td class='calendarweek'>THUR</td><td class='calendarweek'>FRI</td><td class='calendarweek'>SAT</td></tr>");

		int dayOfWeek = cal.get(Calendar.DAY_OF_WEEK);
		int dayOfMonth = 0;
		int numberOfWeeks = (cal.getActualMaximum(Calendar.DATE) + dayOfWeek + 5) / 7;

		// DVScheduler.log(cal.get(Calendar.MONTH));

		for (int week = 0; week < numberOfWeeks; week++) {
			content.append("<tr>");
			for (int day = 1; day < 8; day++) {
				if ((day < dayOfWeek) && week == 0) {
					content.append("<td class='calendarday'>&nbsp;</td>");
				} else if (cal.get(Calendar.MONTH) != month) {
					content.append("<td class='calendarday'>&nbsp;</td>");
				} else {
					dayOfMonth = cal.get(Calendar.DATE);
					String dayURL = "/servlet/" + m_urlData.getServletClass()
							+ "?action=02&day=" + dayOfMonth + "&month="
							+ month + "&year=" + year + idString
							+ redirUrl;

					if (dayOfMonth == thisDay && month == thisMonth
							&& year == thisYear) {
						content.append("<td onClick=\"document.location.href='"
								+ dayURL + "'\" class='calendarToday'>");
					} else {
						content.append("<td onClick=\"document.location.href='"
								+ dayURL + "'\" class='calendarday'>");
					}

					content.append("<a class='noUnder' href='" + dayURL + "'>");
					content.append(dayOfMonth + "</a></td>");

					cal.add(Calendar.DATE, 1);
				}

			}
			content.append("</tr>");
		}

		return content.toString();
	}

	private byte[] getScheduleTable() throws Exception {
		PageTemplate template = new PageTemplate(m_headers, m_urlData, "schedulelist.html", true);

		String showOverlap = m_urlData.getParameter("ShowOverlap");
		boolean showOverlapStatus = false;

		if ("1".equals(showOverlap)) {
			showOverlapStatus = true;
			String overlapIcon = "<a href='/servlet/ScheduleDataRes' class='noUnder'>"
					+ "<img border=0 src='/images/stop.png' align='absmiddle' width='24' height='24'> "
					+ "<span class='areaTitle'>Hide Overlaps</span></a>";
			template.replace("$OverlapIcon", overlapIcon);
		} else {
			showOverlapStatus = false;
			String overlapIcon = "<a href='/servlet/ScheduleDataRes?ShowOverlap=1' class='noUnder'>"
					+ "<img border=0 src='/images/log.png' align='absmiddle' width='24' height='24'> "
					+ "<span class='areaTitle'>Show Overlaps</span></a>";
			template.replace("$OverlapIcon", overlapIcon);
		}

		StringBuffer content = new StringBuffer();

		HashMap<String, ScheduleItem> times = m_store.getScheduleList();
		ScheduleItem[] itemsArray = (ScheduleItem[]) times.values().toArray(
				new ScheduleItem[0]);

		ScheduleItem[] temp = filterItems(itemsArray, true);
		int totalItmes = 0;

		if (temp.length > 0) {
			totalItmes += temp.length;
			content
			.append("<tr><td colspan='9' class='itemheading'>Past Schedules</td></tr>");
			getSchTblData(temp, content, showOverlapStatus);
			content.append("<tr><td colspan='9'><br></td></tr>");
			template.replace("$PastSchedules", content.toString());
		} else
			template.replace("$PastSchedules", "");

		temp = filterItems(itemsArray, false);
		content = new StringBuffer();

		if (temp.length > 0) {
			totalItmes += temp.length;
			content
			.append("<tr><td colspan='9' class='itemheading'>Current Schedules</td></tr>");
			getSchTblData(temp, content, showOverlapStatus);
			template.replace("$PendingSchedules", content.toString());
		} else
			template.replace("$PendingSchedules", "");

		if (totalItmes == 0) {
			content = new StringBuffer();
			content
			.append("<tr><td colspan='9' class='itemheading'>No Schedule Items</td></tr>");
			template.replace("$NoSchedules", content.toString());
		} else
			template.replace("$NoSchedules", "");

		String warnings = "";
		CaptureDeviceList devList = CaptureDeviceList.getInstance();
		if (devList.getDeviceCount() <= 0)
			warnings += "<span class='warning'>Warning: No capture device selected, click <a class='warning' href='/servlet/SystemDataRes?action=04'>here</a></span>";

		int recordingErrorCount = m_store.m_nRecordingErrorCount - m_store.m_nLastRecordingErrorCount;
		if (recordingErrorCount == 1)
			warnings += "<span class='warning'><a class='warning' href='/?action=02'>[Acknowledge]:</a>1 recording error has occurred</span>";
		else if (recordingErrorCount > 1)
			warnings += "<span class='warning'><a class='warning' href='/?action=02'>[Acknowledge]:</a>" + recordingErrorCount + " recording errors have occurred</span>";

		template.replace("$warnings", warnings);

		// set delete after value
		String autoDel = m_store.getProperty("sch.autodel", "180");
		template.replace("$deleteAfter", autoDel);

		return template.getPageBytes();

	}

	private ScheduleItem[] filterItems(ScheduleItem[] itemsArray, boolean past) {
		Vector<ScheduleItem> filteredList = new Vector<ScheduleItem>();
		Date now = new Date();

		for (int x = 0; x < itemsArray.length; x++) {
			ScheduleItem item = itemsArray[x];

			if ( !past && ((item.getStop().getTime() >= now.getTime()) && 
					(item.getState() != ScheduleItem.FINISHED)) )
			{
				filteredList.add(item);
			}
			else if ( past && !((item.getStop().getTime() >= now.getTime()) && 
					(item.getState() != ScheduleItem.FINISHED)) )
			{
				filteredList.add(item);
			}

		}

		ScheduleItem[] items = (ScheduleItem[]) filteredList
				.toArray(new ScheduleItem[0]);
		Arrays.sort(items);

		return items;
	}

	private int overlapDepth(ScheduleItem item) {
		Calendar cal = Calendar.getInstance();

		ScheduleItem[] items = (ScheduleItem[]) m_store.getScheduleList().values()
				.toArray(new ScheduleItem[0]);

		Vector<ScheduleItem> operlapItems = new Vector<ScheduleItem>();
		operlapItems.add(item);

		Channel channel = m_store.getChannel(item.getChannel());
		String netType = channel.getNetworkType();

		for (int x = 0; x < items.length; x++)
		{
			Channel channel2 = m_store.getChannel(items[x].getChannel());
			if (channel2 == null || channel2.isGroup() || !channel2.getNetworkType().equals(netType))
				continue;
			if (items[x].toString().equals(item.toString()) == false)
			{
				if (item.isOverlapping(items[x]))
				{
					operlapItems.add(items[x]);
				}
			}
		}

		// now check the depth
		String setting = channel.getSetting();
		String setting2 = null;

		cal.setTime(item.getStart());
		int duration = item.getDuration();
		int maxCount = 0;

		for (int x = 0; x < duration; x++)
		{
			int count = 1;
			HashSet<String> conflictSettings = new HashSet<String>();

			for (int y = 0; y < operlapItems.size(); y++)
			{
				ScheduleItem checkItem = (ScheduleItem) operlapItems.get(y);
				setting2 = m_store.getChannel(checkItem.getChannel()).getSetting();
				long slice = cal.getTime().getTime();
				if (slice > checkItem.getStart().getTime() 
						&& slice < checkItem.getStop().getTime() 
						&& !setting.equals(setting2) 
						&& !conflictSettings.contains(setting2))
				{
					conflictSettings.add(setting2);
					count++;
				}
			}

			if (count > maxCount)
				maxCount = count;

			cal.add(Calendar.MINUTE, 1);
		}

		return maxCount;
	}

	private int getSchTblData(ScheduleItem[] itemsArray, StringBuffer content,
			boolean showOverlapStatus) throws Exception {
		Calendar dateFormater = Calendar.getInstance();

		// page background colour #6F92FA;
		String rowHi = "class='rowHi'";
		String rowLo = "class='rowLow'";

		DateFormatter2 dateFormatter2 = new DateFormatter2();

		for (int x = 0; x < itemsArray.length; x++) {
			ScheduleItem item = itemsArray[x];

			dateFormater.setTime(item.getStart());

			String type = item.getTypeStr();

			content.append("<tr ");
			if (x % 2 == 0)
				content.append(rowHi + " >");
			else
				content.append(rowLo + " >");

			content.append("<td class='itemdata'>");

			CaptureDeviceList devList = CaptureDeviceList.getInstance();

			if (showOverlapStatus) {
				Channel channel = m_store.getChannel(item.getChannel());
				if (channel == null)
				{
					content
					.append("<img alt='Unknown (invalid channel)' title='Unknown (invalid channel)' src='/images/unknown_24.png' border='0' width='24' height='24'> ");
				}
				else if (channel.isGroup())
				{
					content
					.append("<img alt='Unknown (channel group)' title='Unknown (channel group)' src='/images/unknown_24.png' border='0' width='24' height='24'> ");
				}
				else
				{
					int depth = overlapDepth(item);

					if (depth > devList.getDeviceCountByChannel(item.getChannel()))
						content
						.append("<img alt='Too many overlapping items ("
								+ depth
								+ ")' title='Too many overlapping items ("
								+ depth
								+ ")' "
								+ "src='/images/important.png' border='0' width='24' height='24'> ");
					else
						content
						.append("<img alt='("
								+ depth
								+ ")' title='("
								+ depth
								+ ")' "
								+ "src='/images/tick.png' border='0' width='24' height='24'> ");
				}

			}

			content.append("<a href='/servlet/ScheduleDataRes?action=07&id="
					+ Formatter.encodeURL(item.toString(), "UTF-8") + "'>");

			if (item.getErrorCount() > 0)
			{
				content
				.append("<img alt='Item has error ("
						+ item.getErrorCount()
						+ ")' title='Item has error ("
						+ item.getErrorCount()
						+ ")' "
						+ "src='/images/exclaim24.png' border='0' width='24' height='24'></a> ");
			}
			else
				content.append("<img src='/images/log.png' border='0' alt='Schedule Log' title='Schedule Log' width='24' height='24'></a> ");

			String egpUrl = "/servlet/EpgDataRes?action=25&id=" + item.toString();
			content.append("<a href='" + egpUrl + "'>");
			content.append("<img src='/images/epglink.png' border='0' alt='Show in EPG' title='Show in EPG' width='24' height='24'></a>\n");

			content.append("</td>\n");

			content.append("<td class='itemdatawrap'>" + HTMLEncoder.encode(item.getName()) + "</td>\n");

			//
			// Add the time to the table
			//
			String timeString = dateFormatter2.formatTime(dateFormater.getTime());
			/*
			// I think there is a bug in the .get(Calendar.HOUR) of Calendar
			// it return 0 for 12 pm so do the following to fix this
			int hour = dateFormater.get(Calendar.HOUR);
			if (hour == 0)
				hour = 12;
			String timeString = store.intToStr(hour)
			+ ":"
			+ store.intToStr(dateFormater.get(Calendar.MINUTE))
			+ " "
			+ store.ampm.get(new Integer(dateFormater
					.get(Calendar.AM_PM)));
			 */
			content.append("<td class='itemdata'><b>" + timeString
					+ "</b></td>\n");

			//
			// Add the date to the table
			//
			String dateString = m_store.dayName.get(new Integer(dateFormater
					.get(Calendar.DAY_OF_WEEK)))
					+ ", "
					+ dateFormater.get(Calendar.DATE)
					+ " "
					+ m_store.monthNameShort.get(new Integer(dateFormater
							.get(Calendar.MONTH)));// + ", " +
			// dateFormater.get(Calendar.YEAR);
			content.append("<td class='itemdata'>" + dateString + "</td>\n");

			//
			// Add the duration to the table
			//
			content.append("<td class='itemdata'>" + item.getDuration()
					+ "min</td>\n");

			//
			// Add the channel to the table
			//
			content.append("<td class='itemdata'>");
			content.append(HTMLEncoder.encode(item.getChannel()));
			content.append("</td>\n");
			//
			// Add the type to the table
			//
			content.append("<td class='itemdata'>" + HTMLEncoder.encode(type) + "</td>\n");

			//
			// Add the atatus to the table
			//
			content.append("<td class='itemdata'>" + HTMLEncoder.encode(item.getStatus())
					+ "</td>\n");

			//
			// Now add all the action button
			//
			content.append("<td class='itemdata'>");

			if (item.getState() == ScheduleItem.WAITING
					|| item.getState() == ScheduleItem.SKIPPED
					|| item.getState() == ScheduleItem.FINISHED
					|| item.getState() == ScheduleItem.ERROR)
			{
				// Show the delete button
				content
				.append("<a onClick='return confirmAction(\"Delete\");' href='/servlet/ScheduleDataRes?action=04&id="
						+ Formatter.encodeURL(item.toString(), "UTF-8")
						+ "'>");
				content
				.append("<img src='/images/delete.png' border='0' alt='Delete' title='Delete' width='24' height='24'></a>\n");

				// if(item.getType() != ScheduleItem.EPG)
				{
					// Show the Edit button
					Calendar cal = Calendar.getInstance();
					cal.setTime(item.getStart());
					content
					.append(" <a href='/servlet/ScheduleDataRes?action=01&id="
							+ Formatter.encodeURL(item.toString(),
									"UTF-8")
									+ "&month="
									+ cal.get(Calendar.MONTH)
									+ "&year="
									+ cal.get(Calendar.YEAR) + "'>");
					content
					.append("<img src='/images/editdate.png' border='0' alt='Change Date' title='Change Date' width='24' height='24'></a>\n");

					// Show the Edit without calendar button
					content
					.append(" <a href='/servlet/ScheduleDataRes?action=02&id="
							+ Formatter.encodeURL(item.toString(),
									"UTF-8")
									+ "&day="
									+ cal.get(Calendar.DAY_OF_MONTH)
									+ "&month="
									+ cal.get(Calendar.MONTH)
									+ "&year=" + cal.get(Calendar.YEAR) + "'>");
					content
					.append("<img src='/images/edit.png' border='0' alt='Edit' title='Edit' width='24' height='24'></a>\n");

					// show the change duration button
					content
					.append(" <a onClick='javascript:savePosition(event);' href='javascript:inputForm(\""
							+ item.toString()
							+ "\","
							+ item.getDuration() + "," + item.getStopHour() + "," + item.getStopMinute() + ",-1)" + "'>");
					content
					.append("<img src='/images/+52.png' border='0' alt='Change Duration' title='Change Duration' width='24' height='24'></a>\n");

					// show the add time button
					content
					.append("<a href='/servlet/ScheduleDataRes?action=05&id="
							+ Formatter.encodeURL(item.toString(),
									"UTF-8") + "'>");
					content
					.append("<img src='/images/+5.png' border='0' alt='Add Time' title='Add Time' width='24' height='24'></a>\n");
				}

				if (item.getType() == ScheduleItem.DAILY
						|| item.getType() == ScheduleItem.WEEKLY
						|| item.getType() == ScheduleItem.MONTHLY
						|| item.getType() == ScheduleItem.WEEKDAY) {
					content
					.append("<a href='/servlet/ScheduleDataRes?action=06&id="
							+ Formatter.encodeURL(item.toString(),
									"UTF-8") + "'>");
					content
					.append("<img src='/images/skip.png' border='0' alt='Skip' title='Skip' width='24' height='24'></a>\n");
				}
			} else if (item.getState() == ScheduleItem.RUNNING) {
				// Show the stop/abort button
				content
				.append("<a onClick='return confirmAction(\"Stop\");' href='/servlet/ScheduleDataRes?action=09&id="
						+ Formatter.encodeURL(item.toString(), "UTF-8")
						+ "'>");
				content
				.append("<img src='/images/stop.png' border='0' alt='Stop' title='Stop' width='24' height='24'></a>\n");

				content
				.append("<a onClick='return confirmAction2(\"Stop and Delete File\");' href='/servlet/ScheduleDataRes?action=09&delfile=1&id="
						+ Formatter.encodeURL(item.toString(), "UTF-8")
						+ "'>");
				content
				.append("<img src='/images/stopDelete.png' border='0' alt='Stop and Delete File' title='Stop and Delete File' width='24' height='24'></a>\n");

				// Show the Edit without calendar button
				content
				.append(" <a href='/servlet/ScheduleDataRes?action=02&id="
						+ Formatter.encodeURL(item.toString(),
								"UTF-8")
								+ "'>");
				content
				.append("<img src='/images/edit.png' border='0' alt='Edit' title='Edit' width='24' height='24'></a>\n");

				// show the change duration button
				content
				.append(" <a onClick='javascript:savePosition(event);' href='javascript:inputForm(\""
						+ item.toString()
						+ "\","
						+ item.getDuration() + "," + item.getStopHour() + "," + item.getStopMinute() 
						+ ",-1)" + "'>");
				content
				.append("<img src='/images/+52.png' border='0' alt='Change Duration' title='Change Duration' width='24' height='24'></a>\n");

				// show the add time button
				content
				.append("<a href='/servlet/ScheduleDataRes?action=05&id="
						+ Formatter.encodeURL(item.toString(), "UTF-8")
						+ "'>");
				content
				.append("<img src='/images/+5.png' border='0' alt='Add Time' title='Add Time' width='24' height='24'></a>\n");
			}

			content.append("</td>\n");
			content.append("</tr>\n");
		}

		return 0;
	}

	// return value:
	// 100 channel not in database
	// 101 ok, also return schedule id
	// 102 taking too long, unknown state, also return schedule id
	// 104 error
	private byte[] addSurf() throws Exception
	{
		ScheduleItem item = null;

		String sChannel = m_urlData.getParameter("channel");
		String sNumber = m_urlData.getParameter("channelnumber");
		String next = m_urlData.getParameter("next");
		String prev = m_urlData.getParameter("previous");
		if ( (sNumber != null) && !sNumber.isEmpty() )
		{
			int number = -1;
			try
			{
				number = Integer.parseInt(sNumber);
				sChannel = m_store.m_channelOrder.getChannel(number);
			}
			catch (Exception e) {}
		}
		else if (next != null)
			sChannel = m_store.m_channelOrder.getNextChannelSameHardSetting(sChannel);
		else if (prev != null)
			sChannel = m_store.m_channelOrder.getPreviousChannelSameHardSetting(sChannel);

		if (sChannel == null)
			sChannel = m_store.m_channelOrder.getFirstChannel();

		// check channel name exists
		Channel channel = m_store.getChannel(sChannel);
		if (channel == null) {
			return addLength("DVSchedulerSurf|100").getBytes("UTF-8");
		}

		// check name pattern exists
		String[] namePatterns = m_store.getNamePatterns();
		String namePattern = namePatterns[0];

		// build the Calendar object and set the start time
		Calendar newDate = Calendar.getInstance();

		long id = m_store.m_rand.nextLong();
		String sID = Long.toString(id);
		item = new ScheduleItem(id);

		if (isLocal())
		{
			item.setSurfLocal();
			String surfType = channel.getSurfType();
			if (surfType == null || surfType.isEmpty() || surfType.equals("Surf.deftype"))
			{
				surfType = m_store.getProperty("Surf.deftype", "Surf");
				item.setCapType((surfType.isEmpty() || surfType.equals("*UNDEFINED*")) ? "Surf" : surfType);
			}
			else
				item.setCapType(surfType);
		}
		else
		{
			item.setSurfRemote();
			String surfType = channel.getSurfRemoteType();
			if (surfType == null || surfType.isEmpty() || surfType.equals("Surf.remote.deftype"))
			{
				surfType = m_store.getProperty("Surf.remote.deftype", "Surf");
				item.setCapType((surfType.isEmpty() || surfType.equals("*UNDEFINED*")) ? "Surf" : surfType);
			}
			else
				item.setCapType(surfType);
		}

		item.setType(ScheduleItem.ONCE);
		String ip = m_headers.get("RemoteAddress");
		if ( ip.equals("127.0.0.1") || ip.equals("0:0:0:0:0:0:0:1") )
			ip = "localhost";
		item.setName("Surf from " + ip);

		// Set the initial status
		item.setState(ScheduleItem.WAITING);
		item.setStatus("Waiting");

		// Reset the abort if are editing
		item.resetAbort();

		// Set the start/stop and duration
		item.setStart(newDate);
		item.setDuration(10);

		// Set the channel to capture
		item.setChannel(sChannel);

		// Set the Auto Del option
		item.setAutoDeletable(true);

		item.setFilePattern(namePattern);

		item.setKeepFor(-1);

		item.setPostTask("");

		item.setNames(m_headers);

		// Log the add action
		item.log("New surf added/edited");

		ThreadLock.getInstance().getLock();
		try
		{
			m_store.addScheduleItemAndSave(item);
		}
		finally
		{
			ThreadLock.getInstance().releaseLock();
		}

		int counts = (m_store.getPropertyInt("Capture.startTimeout", 65) + 10) * 10;
		while (item.getState() == ScheduleItem.WAITING && counts > 0) {
			counts--;
			item.waitResponse();
			//Thread.sleep(100);
			if (item.getState() == ScheduleItem.ERROR)
			{
				return addLength("DVSchedulerSurf|104|" + item.getStatus()).getBytes("UTF-8");
			}
		}

		// In case it was a channel group, get the real channel running.
		if (channel.isGroup())
		{
			sChannel = item.getRunningChannel();
			item.setChannel(sChannel);
			channel = m_store.getChannel(sChannel);
		}

		if (item.getState() == ScheduleItem.RUNNING)
		{
			//Thread.sleep(500);
			CaptureTask task = m_store.m_captureTasks.get(sID);
			return addLength("DVSchedulerSurf|101|" + 
					sID + "|" + 
					sChannel + "|" + 
					channel.getNumber() + "|" +
					task.getClientGetAddress() + "|" +
					(task.isSeekable() ? "1" : "0") + "|" +
					task.getKeepAliveTime() + "|" +
					(task.isFile() ? "1" : "0") + "|" +
					task.getCaptureFile().getUnformattedOriginalDirectory().replace("\\", "/")
					).getBytes("UTF-8");
		}
		else if (item.getState() == ScheduleItem.ERROR)
		{
			return addLength("DVSchedulerSurf|104|" + item.getStatus()).getBytes("UTF-8");
		}
		else
		{
			return addLength("DVSchedulerSurf|102|" + 
					sID + "|" + 
					sChannel + "|" + 
					channel.getNumber()).getBytes("UTF-8");
		}
	}

	// return value:
	// 200 schedule id not found
	// 201 ok
	// 202 new channel not in database
	// 203 can't change channel cause of recording
	// 204 error
	// 205 can't change channel due to hard setting.
	// 206 can't change channel cause file is used.
	private byte[] changeRunningTask() throws Exception
	{
		String sID = m_urlData.getParameter("id");
		CaptureTask task = m_store.m_captureTasks.get(sID);
		if (task == null)
			return addLength("DVSchedulerSurf|200").getBytes("UTF-8");

		ScheduleItem item = task.getScheduleItem();
		if (item.isAborted())
			return addLength("DVSchedulerSurf|204|Schedule is aborting due to previous error").getBytes("UTF-8");
		else if (item.getState() != ScheduleItem.RUNNING)
			return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");

		String sOldChannel = item.getRunningChannel();

		String sNewChannel = m_urlData.getParameter("channel");
		String sNumber = m_urlData.getParameter("channelnumber");
		String next = m_urlData.getParameter("next");
		String prev = m_urlData.getParameter("previous");
		if ( (sNumber != null) && !sNumber.isEmpty() )
		{
			int number = -1;
			try
			{
				number = Integer.parseInt(sNumber);
				sNewChannel = m_store.m_channelOrder.getChannel(number);
			}
			catch (Exception e) {}
		}
		else if (next != null)
			sNewChannel = m_store.m_channelOrder.getNextChannelSameHardSetting(sOldChannel);
		else if (prev != null)
			sNewChannel = m_store.m_channelOrder.getPreviousChannelSameHardSetting(sOldChannel);
		else if (sNewChannel == null)
			sNewChannel = sOldChannel;

		if (sNewChannel == null)
			return addLength("DVSchedulerSurf|202").getBytes("UTF-8");
		Channel newChannel = m_store.getChannel(sNewChannel);
		if (newChannel == null)
			return addLength("DVSchedulerSurf|202").getBytes("UTF-8");
		else if (!newChannel.isGroup() && !newChannel.isDataValid())
		{
			item.abort();
			item.setStatus("Channel object has invalid data");
			item.setState(ScheduleItem.ABORTED);
			m_store.setToDoWake();
			return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
		}

		if (task.isLiveToNormal())
		{
			task.setLiveToNormal(false);
			item.setName("Surf Recording");
			item.setType2(0);
			item.setAutoDeletable(false);
			int duration = 60;
			try
			{
				duration = Integer.parseInt(m_store.getProperty("Capture.defaultDuration", "60"));
			}
			catch (Exception e) {}
			item.setDuration(duration + item.getDuration());
			item.log("Changed to normal recording");
			item.setRunningStatus(new Date());
			m_store.saveSchedules(item);

			return addLength("DVSchedulerSurf|206").getBytes("UTF-8");
		}

		if (newChannel.isGroup())
		{
			try
			{
				newChannel = task.getBestChannel(newChannel);
				sNewChannel = newChannel.getName();
			}
			catch (ResultException e)
			{
				item.abort();
				item.setState(ScheduleItem.ABORTED);
				m_store.setToDoWake();
				return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
			}
		}

		if (isLocal())
		{
			String surfType = newChannel.getSurfType();
			if (surfType == null || surfType.isEmpty() || surfType.equals("Surf.deftype"))
			{
				surfType = m_store.getProperty("Surf.deftype", "Surf");
				if ( surfType.isEmpty() || surfType.equals("*UNDEFINED*") )
					surfType = "Surf";
			}
			if ( !item.getCapType().equals(surfType) )
			{
				item.abort();
				item.setStatus("Aborting 207");
				item.setState(ScheduleItem.ABORTED);
				m_store.setToDoWake();
				return addLength("DVSchedulerSurf|207").getBytes("UTF-8");
			}
		}
		else
		{
			String surfType = newChannel.getSurfRemoteType();
			if (surfType == null || surfType.isEmpty() || surfType.equals("Surf.remote.deftype"))
			{
				surfType = m_store.getProperty("Surf.remote.deftype", "Surf");
				if ( surfType.isEmpty() || surfType.equals("*UNDEFINED*") )
					surfType = "Surf";
			}
			if ( !item.getCapType().equals(surfType) )
			{
				item.abort();
				item.setStatus("Aborting 207");
				item.setState(ScheduleItem.ABORTED);
				m_store.setToDoWake();
				return addLength("DVSchedulerSurf|207").getBytes("UTF-8");
			}
		}

		Channel oldChannel = m_store.getChannel(sOldChannel);

		if (newChannel.isHardSettingEqual(oldChannel) && task.isSettingChangeable())
		{
			item.setNames(m_headers);

			if (newChannel.isSettingEqual(oldChannel))
			{
				DVScheduler.log("Change channel: setting equal");
				int result = task.changeChannel(newChannel);
				if (result > 0)
				{
					item.setChannel(sNewChannel);
					return addLength("DVSchedulerSurf|201|" + 
							sID + "|" + 
							sNewChannel + "|" + 
							newChannel.getNumber() + "|" +
							task.getClientGetAddress() + "|" +
							(task.isSeekable() ? "1" : "0") + "|" +
							task.getKeepAliveTime() + "|" +
							(task.isFile() ? "1" : "0") + "|" +
							task.getCaptureFile().getUnformattedOriginalDirectory().replace("\\", "/")
							).getBytes("UTF-8");
				}
				else
				{
					item.abort();
					item.setStatus("Same setting change error");
					item.setState(ScheduleItem.ABORTED);
					m_store.setToDoWake();
					return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
				}
			}
			else
			{
				CaptureDeviceList devList = CaptureDeviceList.getInstance();
				if (devList.isAvailableRunningDevice(newChannel.getHardSetting(), newChannel.getSetting()))
				{
					DVScheduler.log("Change channel: running device");
					int result = task.changeDevice(newChannel);
					if (result > 0)
					{
						item.setChannel(sNewChannel);
						return addLength("DVSchedulerSurf|201|" + 
								sID + "|" + 
								sNewChannel + "|" + 
								newChannel.getNumber() + "|" +
								task.getClientGetAddress() + "|" +
								(task.isSeekable() ? "1" : "0") + "|" +
								task.getKeepAliveTime() + "|" +
								(task.isFile() ? "1" : "0") + "|" +
								task.getCaptureFile().getUnformattedOriginalDirectory().replace("\\", "/")
								).getBytes("UTF-8");
					}
					else
					{
						item.abort();
						item.setStatus("Running device change error");
						item.setState(ScheduleItem.ABORTED);
						m_store.setToDoWake();
						return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
					}
				}
				else
				{
					DVScheduler.log("Change channel: change setting");
					int result = task.changeSetting(newChannel);
					if (result > 0)
					{
						item.setChannel(sNewChannel);
						return addLength("DVSchedulerSurf|201|" + 
								sID + "|" + 
								sNewChannel + "|" + 
								newChannel.getNumber() + "|" +
								task.getClientGetAddress() + "|" +
								(task.isSeekable() ? "1" : "0") + "|" +
								task.getKeepAliveTime() + "|" +
								(task.isFile() ? "1" : "0") + "|" +
								task.getCaptureFile().getUnformattedOriginalDirectory().replace("\\", "/")
								).getBytes("UTF-8");
					}
					else if (result == -2)
					{
						DVScheduler.log("Change channel: active recording");
						if ( (next == null) && (prev == null) )
						{
							item.abort();
							item.setStatus("Aborting");
							item.setState(ScheduleItem.ABORTED);
							m_store.setToDoWake();
							return addLength("DVSchedulerSurf|203").getBytes("UTF-8");
						}

						if (next != null)
							sNewChannel = m_store.m_channelOrder.getNextChannelSameSetting(sOldChannel);
						else if (prev != null)
							sNewChannel = m_store.m_channelOrder.getPreviousChannelSameSetting(sOldChannel);

						if (sNewChannel == null)
							return addLength("DVSchedulerSurf|202").getBytes("UTF-8");
						newChannel = m_store.getChannel(sNewChannel);
						if (newChannel == null)
							return addLength("DVSchedulerSurf|202").getBytes("UTF-8");

						int result2 = task.changeChannel(newChannel);
						if (result2 > 0)
						{
							item.setChannel(sNewChannel);
							return addLength("DVSchedulerSurf|201|" + 
									sID + "|" + 
									sNewChannel + "|" + 
									newChannel.getNumber() + "|" +
									task.getClientGetAddress() + "|" +
									(task.isSeekable() ? "1" : "0") + "|" +
									task.getKeepAliveTime() + "|" +
									(task.isFile() ? "1" : "0") + "|" +
									task.getCaptureFile().getUnformattedOriginalDirectory().replace("\\", "/")
									).getBytes("UTF-8");
						}
						else
						{
							item.abort();
							item.setStatus("Same setting active recording change error");
							item.setState(ScheduleItem.ABORTED);
							m_store.setToDoWake();
							return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
						}
					}
					else
					{
						item.abort();
						item.setStatus("Change setting error");
						item.setState(ScheduleItem.ABORTED);
						m_store.setToDoWake();
						return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
					}
				}
			}

		}
		else
		{
			CaptureDeviceList devList = CaptureDeviceList.getInstance();
			if (devList.isAvailableRunningDevice(newChannel.getHardSetting(), newChannel.getSetting()))
			{
				DVScheduler.log("Change channel: running device2");
				int result = task.changeDevice(newChannel);
				if (result > 0)
				{
					item.setChannel(sNewChannel);
					return addLength("DVSchedulerSurf|201|" + 
							sID + "|" + 
							sNewChannel + "|" + 
							newChannel.getNumber() + "|" +
							task.getClientGetAddress() + "|" +
							(task.isSeekable() ? "1" : "0") + "|" +
							task.getKeepAliveTime() + "|" +
							(task.isFile() ? "1" : "0") + "|" +
							task.getCaptureFile().getUnformattedOriginalDirectory().replace("\\", "/")
							).getBytes("UTF-8");
				}
				else
				{
					item.abort();
					item.setStatus("Running device change error2");
					item.setState(ScheduleItem.ABORTED);
					m_store.setToDoWake();
					return addLength("DVSchedulerSurf|204|" + item.getStatus()).getBytes("UTF-8");
				}
			}
			else
			{
				item.abort();
				item.setStatus("Aborting 205");
				item.setState(ScheduleItem.ABORTED);
				m_store.setToDoWake();
				return addLength("DVSchedulerSurf|205").getBytes("UTF-8");
			}
		}
	}

	// return value:
	// 400 schedule id not found
	// 401 ok
	private byte[] keepAliveRunningTask() throws Exception
	{
		String sID = m_urlData.getParameter("id");
		CaptureTask task = m_store.m_captureTasks.get(sID);
		if (task == null)
			return addLength("DVSchedulerSurf|400").getBytes("UTF-8");

		task.setLastTime();
		return addLength("DVSchedulerSurf|401").getBytes("UTF-8");
	}

	private void listFiles(String directory, String parentDirectory, Document doc, Element fileNode, Element directoryNode)
	{
		Element elm = null;

		if (directory.isEmpty())
			directory = ".";

		directory = directory.replace("\\", "/");

		File baseDir = new File(directory);
		if (!baseDir.isDirectory())
			return;
		String fileMasks = m_store.getProperty("filebrowser.surfmasks", ".mpg,.mpeg,.bin,.mpv,.mpa,.ts,.tp,.dvr-ms,.rec,.pva,.avi,.mp4,.mkv");
		File[] files = baseDir.listFiles(new FileTypeFilter(fileMasks, 0));

		if (files != null)
		{
			for (int x = 0; x < files.length; x++)
			{
				String name = files[x].getName();
				String path = files[x].getAbsolutePath().replace("\\", "/");
				String relativePath = files[x].getPath().substring(parentDirectory.length()+1).replace("\\", "/");
				elm = doc.createElement("file");
				elm.setAttribute("name", name);
				elm.setAttribute("path", path);
				elm.setAttribute("relativePath", relativePath);
				elm.setAttribute("directory", parentDirectory);
				elm.setAttribute("size", Long.toString(files[x].length()));
				fileNode.appendChild(elm);

				elm = doc.createElement("file");
				elm.setAttribute("name", name);
				elm.setAttribute("path", path);
				elm.setAttribute("relativePath", relativePath);
				elm.setAttribute("size", Long.toString(files[x].length()));
				directoryNode.appendChild(elm);
			}
		}

		File[] dirs = baseDir.listFiles(new FileTypeFilter(fileMasks, 1));

		if (dirs != null)
		{
			for (int x = 0; x < dirs.length; x++)
			{
				listFiles(dirs[x].getPath(), parentDirectory, doc, fileNode, directoryNode);
			}
		}
	}

	private byte[] showSurfControl(String xslName) throws Exception
	{
		// Creation of an XML document
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		DOMImplementation di = db.getDOMImplementation();

		Document doc = di.createDocument("tv", "tv", null);

		Element root = doc.getDocumentElement();

		String host = m_headers.get("Host");
		root.setAttribute("servername", host);
		root.setAttribute("User-Agent", m_headers.get("User-Agent"));
		root.setAttribute("pathTheme", m_store.getThemeDirectory(m_headers.get("User-Agent")));
		root.setAttribute("videoheight", m_store.getProperty("video.height", "405"));
		root.setAttribute("videowidth", m_store.getProperty("video.width", "720"));
		root.setAttribute("local", isLocal() ? "1" : "0");
		if ( !isLocal() && !m_store.getProperty("Surf.remote.file", "HTTP").equals("*") )
			root.setAttribute("customPlayFile", "1");
		root.setAttribute("protocol", (m_store.getWebGuiProtocol() == DataStore.WEBGUI_HTTPS) ? "HTTPS" : "HTTP");

		if ( (!isLocal() && (m_store.getSurfRemoteTypes().size() <= 1)) || 
				(isLocal() && (m_store.getSurfTypes().size() <= 1)) )
			root.setAttribute("surf", "0");
		else
			root.setAttribute("surf", "1");

		int balloonDelay = m_urlData.getParameterInt("balloonDelay", -1);

		if(balloonDelay == -1)
		{
			balloonDelay = Integer.parseInt(m_store.getProperty("EPG.balloonDelay", "0"));
			if (balloonDelay < 0)
				balloonDelay = 0;
		}
		root.setAttribute("balloonDelay", new Integer(balloonDelay).toString());

		String structuredFileList = m_urlData.getCookie("SurfStructuredFileList");
		boolean bStructuredFileList = false;
		if ( (structuredFileList == null) || (!structuredFileList.equals("0") && !structuredFileList.equals("1")) )
		{
			bStructuredFileList = m_store.getProperty("surf.fileView", "Structured List").equals("Structured List");
		}
		else
			bStructuredFileList = structuredFileList.equals("1");
		root.setAttribute("structuredFileList", bStructuredFileList ? "1" : "0");

		root.appendChild(m_store.m_channelOrder.getXML(doc, m_store.getChannels(), ChannelOrder.USE_SETTING, m_headers.get("User-Agent")));

		//String[] paths = DVScheduler.getArray(m_store.getProperty("Capture.path", "capture"));
		String[] paths = m_store.getServeFilePaths();

		Element elm2 = null;
		Element item = doc.createElement("files");
		if (bStructuredFileList)
		{
			String directory = m_urlData.getCookie("SurfCurrentDirectory");
			try
			{
				directory = URLDecoder.decode(directory, "UTF-8");
			}
			catch (Exception e) {}

			FileManagementDataRes.listFilesDirectories(directory, m_store.getProperty("filebrowser.surfmasks", ".mpg,.mpeg,.bin,.mpv,.mpa,.ts,.tp,.dvr-ms,.rec,.pva,.avi,.mp4,.mkv"), root, doc, true, true);
		}
		else
		{
			Element itemDir = doc.createElement("directories");
			for (int i=0; i<paths.length; i++)
			{
				if (paths[i].isEmpty())
					paths[i] = ".";

				paths[i] = paths[i].replace("\\", "/");

				elm2 = doc.createElement("directory");
				elm2.setAttribute("name", paths[i]);

				listFiles(paths[i], paths[i], doc, item, elm2);

				itemDir.appendChild(elm2);
			}
			root.appendChild(itemDir);
			root.appendChild(item);
		}

		item = doc.createElement("now_and_next");
		SystemStatusData.addNOWandNEXT(m_store, item, doc, m_headers.get("User-Agent"));
		root.appendChild(item);

		CaptureDeviceList devList = CaptureDeviceList.getInstance();
		item = doc.createElement("devices");
		item.setAttribute("total", Integer.toString(devList.getDeviceCount()));
		item.setAttribute("total_running", Integer.toString(devList.getRunningDeviceCount()));
		addDevices(m_store, item, doc);
		root.appendChild(item);

		item = doc.createElement("lists");
		String cookie = m_urlData.getCookie("SurfList-devicesList");
		if (cookie != null && cookie.equals("0"))
		{
			elm2 = doc.createElement("devicesList");
			elm2.setAttribute("height", "1");
			item.appendChild(elm2);
		}
		cookie = m_urlData.getCookie("SurfList-nowNextList");
		if (cookie != null && cookie.equals("0"))
		{
			elm2 = doc.createElement("nowNextList");
			elm2.setAttribute("height", "1");
			item.appendChild(elm2);
		}
		cookie = m_urlData.getCookie("SurfList-channelList");
		if (cookie != null && cookie.equals("0"))
		{
			elm2 = doc.createElement("channelList");
			elm2.setAttribute("height", "1");
			item.appendChild(elm2);
		}
		cookie = m_urlData.getCookie("SurfList-fileList");
		if (cookie != null && cookie.equals("0"))
		{
			elm2 = doc.createElement("fileList");
			elm2.setAttribute("height", "1");
			item.appendChild(elm2);
		}
		root.appendChild(item);

		//
		// Do transform and return data
		//
		XSL transformer = new XSL(doc, xslName, m_headers, m_urlData);

		return transformer.transform(-1, true);
	}

	// return value:
	// 500 channel not in database
	// 501 ok, also return schedule id
	// 502 taking too long, unknown state, also return schedule id
	// 503 already in list
	// 504 error
	// 505 ok with recording all time-shift file.
	private byte[] addSchedule(boolean bHTML) throws Exception
	{
		String channel = m_urlData.getParameter("channel");
		String sNumber = m_urlData.getParameter("channelnumber");
		if ( (sNumber != null) && !sNumber.isEmpty() )
		{
			int number = -1;
			try
			{
				number = Integer.parseInt(sNumber);
				channel = m_store.m_channelOrder.getChannel(number);
			}
			catch (Exception e) {}
		}
		String sID = m_urlData.getParameter("id");
		if ( (sID != null) && !sID.isEmpty() )
		{
			String liveToNormal = m_urlData.getParameter("start");

			ThreadLock.getInstance().getLock();
			try
			{
				CaptureTask task = m_store.m_captureTasks.get(sID);
				if (task != null)
				{
					if ( liveToNormal != null )
					{
						if (task.isFile())
						{
							task.setLiveToNormal(true);
							if (bHTML)
							{
								return getRedirUrlRedir(null).getBytes("UTF-8");
							}
							else
							{
								return addLength("DVSchedulerSurf|505|" + 
										task.getCaptureFile().getFullPath()).getBytes("UTF-8");
							}
						}
						else
						{
							if (bHTML)
							{
								return getRedirUrlRedir(null).getBytes("UTF-8");
							}
							else
							{
								return addLength("DVSchedulerSurf|504|No time-shift file").getBytes("UTF-8");
							}
						}
					}

					channel = task.getScheduleItem().getChannel();
				}
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
		}
		if (channel == null)
			channel = m_store.m_channelOrder.getFirstChannel();

		// check channel name exists
		Channel channel2 = m_store.getChannel(channel);
		if (channel2 == null)
		{
			if (bHTML)
			{
				return getRedirUrlRedir(null).getBytes("UTF-8");
			}
			else
				return addLength("DVSchedulerSurf|500").getBytes("UTF-8");
		}

		// check name pattern exists
		String[] namePatterns = m_store.getNamePatterns();
		String namePattern = namePatterns[0];

		// build the Calendar object and set the start time
		Calendar newDate = Calendar.getInstance();
		newDate.set(Calendar.SECOND, 0);
		newDate.set(Calendar.MILLISECOND, 0);

		long id = m_store.m_rand.nextLong();
		sID = Long.toString(id);
		ScheduleItem item = new ScheduleItem(id);
		item.setName(m_urlData.getParameter("name", "Recording"));

		item.setCapType("Capture.deftype");

		item.setType(ScheduleItem.ONCE);

		// Set the initial status
		item.setState(ScheduleItem.WAITING);
		item.setStatus("Waiting");

		// Reset the abort if are editing
		item.resetAbort();

		// Set the start/stop and duration
		item.setStart(newDate);
		int duration = 60;
		try
		{
			duration = Integer.parseInt(m_store.getProperty("Capture.defaultDuration", "60"));
		}
		catch (Exception e) {}
		item.setDuration(duration);

		// Set the channel to capture
		item.setChannel(channel);

		// Set the Auto Del option
		item.setAutoDeletable(m_store.isAutoDelByDefault());

		item.setFilePattern(namePattern);

		String keepFor = m_store.getProperty("AutoDel.KeepFor", "30");
		int keepInt = 30;
		try {
			keepInt = Integer.parseInt(keepFor);
		} catch (Exception e) {
		}
		item.setKeepFor(keepInt);

		String postTask = m_store.getProperty("Tasks.DefTask", "");
		item.setPostTask(postTask);

		item.setNames(m_headers);

		// Log the add action
		item.log("New Schedule added");

		GuideStore guide = GuideStore.getInstance();
		if (guide.isAlreadyInList(item))
		{
			if (bHTML)
			{
				return getRedirUrlRedir(null).getBytes("UTF-8");
			}
			else
			{
				return addLength("DVSchedulerSurf|503|" + 
						item.getChannel() + "|" + 
						channel2.getNumber()).getBytes("UTF-8");
			}
		}

		ThreadLock.getInstance().getLock();
		try
		{
			m_store.addScheduleItemAndSave(item);
		}
		finally
		{
			ThreadLock.getInstance().releaseLock();
		}

		if (bHTML)
		{
			return getRedirUrlRedir(null).getBytes("UTF-8");
		}
		else
		{
			int counts = (m_store.getPropertyInt("Capture.startTimeout", 65) + 10) * 10;
			while (item.getState() == ScheduleItem.WAITING && counts > 0) {
				counts--;
				item.waitResponse();
				//Thread.sleep(100);
				if (item.getState() == ScheduleItem.ERROR)
				{
					return addLength("DVSchedulerSurf|504|" + item.getStatus()).getBytes("UTF-8");
				}
			}

			if (item.getState() == ScheduleItem.RUNNING)
			{
				//Thread.sleep(500);
				return addLength("DVSchedulerSurf|501|" + 
						sID + "|" + 
						item.getChannel() + "|" + 
						channel2.getNumber() + "|" +
						item.getDuration()
						).getBytes("UTF-8");
			}
			else
			{
				return addLength("DVSchedulerSurf|502|" + 
						sID + "|" + 
						item.getChannel() + "|" + 
						channel2.getNumber()).getBytes("UTF-8");
			}
		}
	}

	protected String addLength(String text)
	{
		return String.format("%1$04d", text.length()+4) + text;
	}

	// return value:
	// 600 schedule id not found
	// 601 ok
	// 604 error
	protected byte[] getSignalStatistic() throws Exception
	{
		String sID = m_urlData.getParameter("id");
		CaptureTask task = m_store.m_captureTasks.get(sID);
		if (task == null)
			return addLength("DVSchedulerSurf|600").getBytes("UTF-8");

		String stat = task.getSignalStatistic();
		if (stat == null)
		{
			return addLength("DVSchedulerSurf|604|Error").getBytes("UTF-8");
		}

		return addLength("DVSchedulerSurf|601|" + task.getSignalStatistic() + "|" + 
				task.getCardName()).getBytes("UTF-8");
	}

	private void addDevices(DataStore store, Element item, Document doc)
	{
		CaptureDeviceList devList = CaptureDeviceList.getInstance();
		int status;
		int total = devList.getDeviceCount();
		for (int i=0; i<total; i++)
		{
			CaptureDevice dev = devList.getDevice(i);
			status = dev.getStatus();
			Element item2 = doc.createElement("device");
			item2.setAttribute("index", Integer.toString(i));
			item2.setAttribute("name", dev.getName());
			item2.setAttribute("number", Integer.toString(dev.getNumber()));
			item2.setAttribute("unique_name", dev.getUniqueName());
			item2.setAttribute("status", Integer.toString(status));
			if (status > 0)
			{
				item2.setAttribute("setting", dev.getSettingName());
				item2.setAttribute("total_capture", status == 2 ? Integer.toString(dev.getCaptureProcess().getTotalCapture()) : "0");
			}
			item.appendChild(item2);
		}
	}

	private byte[] logRequest() throws Exception
	{
		String text = m_urlData.getParameter("text");
		if (text != null)
			DVScheduler.log(text);

		//Thread.sleep(2000);
		return "Request received".getBytes("UTF-8");
	}

	private byte[] stopDevice() throws Exception
	{
		int index = m_urlData.getParameterInt("index", -1);
		if (index < 0)
			return getRedirUrlRedir(null).getBytes("UTF-8");

		DVScheduler.log("Stopping idle device:" + index);
		ThreadLock.getInstance().getLock();
		try
		{
			CaptureDeviceList deviceList = CaptureDeviceList.getInstance();
			deviceList.stopIdleRunningDevice(index);
		}
		finally
		{
			ThreadLock.getInstance().releaseLock();
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}
}
