
#include "log.h"

#include <stdio.h>
#include <string>

static FILE *fp_log = 0;
static std::string logPath = "log";

void openLogFile(char *logFile)
{
	HKEY hKey = NULL;
	RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\DV Scheduler", 0, KEY_READ, &hKey);
	if(hKey)
	{
		DWORD dwType, cbData(1000);
		char buffer[2000];
		bool bSaveToAppData(false);
		if ( (RegQueryValueEx(hKey, "SaveToAppData", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			bSaveToAppData = (buffer[0] == '1');
		}
		cbData=1000;
		if ( (RegQueryValueEx(hKey, "Path", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			strcat_s(buffer, 1000, "\\");

			if (!bSaveToAppData)
			{
				logPath = buffer + logPath;
			}
		}
		cbData=1000;
		if ( (RegQueryValueEx(hKey, "DataPath", NULL, &dwType, (BYTE*)buffer, &cbData) == ERROR_SUCCESS) &&
			(dwType == REG_SZ) )
		{
			strcat_s(buffer, 1000, "\\");
			if (bSaveToAppData)
			{
				logPath = buffer + logPath;
			}
		}
	}
	RegCloseKey(hKey);

	CreateDirectory(logPath.c_str(), NULL);

    SYSTEMTIME st;
    GetLocalTime(&st);

	char name[128];
	StringCchPrintf(name, 128, (logPath + "\\%s%.4d%.2d%.2d-%.2d%.2d%.2d-%.3d.log").c_str(), logFile, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);

	fp_log = fopen(name, "at");
}

void closeLogFile()
{
	fclose(fp_log);
}

int log(char *sz,...)
{
    char tach[2000];

    SYSTEMTIME st;
    GetLocalTime(&st);

	char timeBuff[60];
	StringCchPrintf(timeBuff, 60, "%.4d/%.2d/%.2d %.2d:%.2d:%.2d.%.3d - ", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);

    va_list va;
    va_start(va, sz);
	StringCchVPrintf(tach, 2000, sz, va);
    va_end(va);

	if(fp_log != NULL)
	{
		fputs(timeBuff, fp_log);
		fputs(tach, fp_log);
		fflush(fp_log);
	}
	else
	{
		printf(timeBuff);
		printf(tach);
		fflush(stdout);
	}

    return FALSE;
}